module GLX_AMD_gpu_association
  module Constants
    GPU_VENDOR_AMD                = 0x1F00
    GPU_RENDERER_STRING_AMD       = 0x1F01
    GPU_OPENGL_VERSION_STRING_AMD = 0x1F02
    GPU_FASTEST_TARGET_GPUS_AMD   = 0x21A2
    GPU_RAM_AMD                   = 0x21A3
    GPU_CLOCK_AMD                 = 0x21A4
    GPU_NUM_PIPES_AMD             = 0x21A5
    GPU_NUM_SIMD_AMD              = 0x21A6
    GPU_NUM_RB_AMD                = 0x21A7
    GPU_NUM_SPI_AMD               = 0x21A8
  end
  
  Functions = {
    def glXGetGPUIDsAMD(maxCount, ids) end => [ :uint, :uint, :pointer ].freeze,
    def glXGetGPUInfoAMD(id, property, dataType, size, data) end => [ :int, :uint, :int, :GLenum, :uint, :pointer ].freeze,
    def glXGetContextGPUIDAMD(ctx) end => [ :uint, :GLXContext ].freeze,
    def glXCreateAssociatedContextAMD(id, share_list) end => [ :GLXContext, :uint, :GLXContext ].freeze,
    def glXCreateAssociatedContextAttribsAMD(id, share_context, attribList) end => [ :GLXContext, :uint, :GLXContext, :pointer ].freeze,
    def glXDeleteAssociatedContextAMD(ctx) end => [ :Bool, :GLXContext ].freeze,
    def glXMakeAssociatedContextCurrentAMD(ctx) end => [ :Bool, :GLXContext ].freeze,
    def glXGetCurrentAssociatedContextAMD() end => [ :GLXContext ].freeze,
    def glXBlitContextFramebufferAMD(dstCtx, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter) end => [ :void, :GLXContext, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLbitfield, :GLenum ].freeze,
  }.freeze
end