module GLX_MESA_query_renderer
  module Constants
    RENDERER_VENDOR_ID_MESA                            = 0x8183
    RENDERER_DEVICE_ID_MESA                            = 0x8184
    RENDERER_VERSION_MESA                              = 0x8185
    RENDERER_ACCELERATED_MESA                          = 0x8186
    RENDERER_VIDEO_MEMORY_MESA                         = 0x8187
    RENDERER_UNIFIED_MEMORY_ARCHITECTURE_MESA          = 0x8188
    RENDERER_PREFERRED_PROFILE_MESA                    = 0x8189
    RENDERER_OPENGL_CORE_PROFILE_VERSION_MESA          = 0x818A
    RENDERER_OPENGL_COMPATIBILITY_PROFILE_VERSION_MESA = 0x818B
    RENDERER_OPENGL_ES_PROFILE_VERSION_MESA            = 0x818C
    RENDERER_OPENGL_ES2_PROFILE_VERSION_MESA           = 0x818D
    RENDERER_ID_MESA                                   = 0x818E
  end
  
  Functions = {
    def glXQueryCurrentRendererIntegerMESA(attribute, value) end => [ :Bool, :int, :pointer ].freeze,
    def glXQueryCurrentRendererStringMESA(attribute) end => [ :string, :int ].freeze,
    def glXQueryRendererIntegerMESA(dpy, screen, renderer, attribute, value) end => [ :Bool, :pointer, :int, :int, :int, :pointer ].freeze,
    def glXQueryRendererStringMESA(dpy, screen, renderer, attribute) end => [ :string, :pointer, :int, :int, :int ].freeze,
  }.freeze
end