module GLX_NV_video_out
  module Constants
    VIDEO_OUT_COLOR_NV              = 0x20C3
    VIDEO_OUT_ALPHA_NV              = 0x20C4
    VIDEO_OUT_DEPTH_NV              = 0x20C5
    VIDEO_OUT_COLOR_AND_ALPHA_NV    = 0x20C6
    VIDEO_OUT_COLOR_AND_DEPTH_NV    = 0x20C7
    VIDEO_OUT_FRAME_NV              = 0x20C8
    VIDEO_OUT_FIELD_1_NV            = 0x20C9
    VIDEO_OUT_FIELD_2_NV            = 0x20CA
    VIDEO_OUT_STACKED_FIELDS_1_2_NV = 0x20CB
    VIDEO_OUT_STACKED_FIELDS_2_1_NV = 0x20CC
  end
  
  Functions = {
    def glXGetVideoDeviceNV(dpy, screen, numVideoDevices, pVideoDevice) end => [ :int, :pointer, :int, :int, :pointer ].freeze,
    def glXReleaseVideoDeviceNV(dpy, screen, videoDevice) end => [ :int, :pointer, :int, :GLXVideoDeviceNV ].freeze,
    def glXBindVideoImageNV(dpy, videoDevice, pbuf, iVideoBuffer) end => [ :int, :pointer, :GLXVideoDeviceNV, :GLXPbuffer, :int ].freeze,
    def glXReleaseVideoImageNV(dpy, pbuf) end => [ :int, :pointer, :GLXPbuffer ].freeze,
    def glXSendPbufferToVideoNV(dpy, pbuf, iBufferType, pulCounterPbuffer, bBlock) end => [ :int, :pointer, :GLXPbuffer, :int, :pointer, :GLboolean ].freeze,
    def glXGetVideoInfoNV(dpy, screen, videoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo) end => [ :int, :pointer, :int, :GLXVideoDeviceNV, :pointer, :pointer ].freeze,
  }.freeze
end