module GLX_SGIX_fbconfig
  module Constants
    WINDOW_BIT_SGIX       = 0x00000001
    PIXMAP_BIT_SGIX       = 0x00000002
    RGBA_BIT_SGIX         = 0x00000001
    COLOR_INDEX_BIT_SGIX  = 0x00000002
    DRAWABLE_TYPE_SGIX    = 0x8010
    RENDER_TYPE_SGIX      = 0x8011
    X_RENDERABLE_SGIX     = 0x8012
    FBCONFIG_ID_SGIX      = 0x8013
    RGBA_TYPE_SGIX        = 0x8014
    COLOR_INDEX_TYPE_SGIX = 0x8015
    SCREEN_EXT            = 0x800C
  end
  
  Functions = {
    def glXGetFBConfigAttribSGIX(dpy, config, attribute, value) end => [ :int, :pointer, :GLXFBConfigSGIX, :int, :pointer ].freeze,
    def glXChooseFBConfigSGIX(dpy, screen, attrib_list, nelements) end => [ :pointer, :pointer, :int, :pointer, :pointer ].freeze,
    def glXCreateGLXPixmapWithConfigSGIX(dpy, config, pixmap) end => [ :GLXPixmap, :pointer, :GLXFBConfigSGIX, :Pixmap ].freeze,
    def glXCreateContextWithConfigSGIX(dpy, config, render_type, share_list, direct) end => [ :GLXContext, :pointer, :GLXFBConfigSGIX, :int, :GLXContext, :Bool ].freeze,
    def glXGetVisualFromFBConfigSGIX(dpy, config) end => [ :pointer, :pointer, :GLXFBConfigSGIX ].freeze,
    def glXGetFBConfigFromVisualSGIX(dpy, vis) end => [ :GLXFBConfigSGIX, :pointer, :pointer ].freeze,
  }.freeze
end