module GLX_SGIX_hyperpipe
  module Constants
    HYPERPIPE_PIPE_NAME_LENGTH_SGIX = 80
    BAD_HYPERPIPE_CONFIG_SGIX       = 91
    BAD_HYPERPIPE_SGIX              = 92
    HYPERPIPE_DISPLAY_PIPE_SGIX     = 0x00000001
    HYPERPIPE_RENDER_PIPE_SGIX      = 0x00000002
    PIPE_RECT_SGIX                  = 0x00000001
    PIPE_RECT_LIMITS_SGIX           = 0x00000002
    HYPERPIPE_STEREO_SGIX           = 0x00000003
    HYPERPIPE_PIXEL_AVERAGE_SGIX    = 0x00000004
    HYPERPIPE_ID_SGIX               = 0x8030
  end
  
  Functions = {
    def glXQueryHyperpipeNetworkSGIX(dpy, npipes) end => [ :pointer, :pointer, :pointer ].freeze,
    def glXHyperpipeConfigSGIX(dpy, networkId, npipes, cfg, hpId) end => [ :int, :pointer, :int, :int, :pointer, :pointer ].freeze,
    def glXQueryHyperpipeConfigSGIX(dpy, hpId, npipes) end => [ :pointer, :pointer, :int, :pointer ].freeze,
    def glXDestroyHyperpipeConfigSGIX(dpy, hpId) end => [ :int, :pointer, :int ].freeze,
    def glXBindHyperpipeSGIX(dpy, hpId) end => [ :int, :pointer, :int ].freeze,
    def glXQueryHyperpipeBestAttribSGIX(dpy, timeSlice, attrib, size, attribList, returnAttribList) end => [ :int, :pointer, :int, :int, :int, :pointer, :pointer ].freeze,
    def glXHyperpipeAttribSGIX(dpy, timeSlice, attrib, size, attribList) end => [ :int, :pointer, :int, :int, :int, :pointer ].freeze,
    def glXQueryHyperpipeAttribSGIX(dpy, timeSlice, attrib, size, returnAttribList) end => [ :int, :pointer, :int, :int, :int, :pointer ].freeze,
  }.freeze
end