module GLX_SGIX_pbuffer
  module Constants
    PBUFFER_BIT_SGIX            = 0x00000004
    BUFFER_CLOBBER_MASK_SGIX    = 0x08000000
    FRONT_LEFT_BUFFER_BIT_SGIX  = 0x00000001
    FRONT_RIGHT_BUFFER_BIT_SGIX = 0x00000002
    BACK_LEFT_BUFFER_BIT_SGIX   = 0x00000004
    BACK_RIGHT_BUFFER_BIT_SGIX  = 0x00000008
    AUX_BUFFERS_BIT_SGIX        = 0x00000010
    DEPTH_BUFFER_BIT_SGIX       = 0x00000020
    STENCIL_BUFFER_BIT_SGIX     = 0x00000040
    ACCUM_BUFFER_BIT_SGIX       = 0x00000080
    SAMPLE_BUFFERS_BIT_SGIX     = 0x00000100
    MAX_PBUFFER_WIDTH_SGIX      = 0x8016
    MAX_PBUFFER_HEIGHT_SGIX     = 0x8017
    MAX_PBUFFER_PIXELS_SGIX     = 0x8018
    OPTIMAL_PBUFFER_WIDTH_SGIX  = 0x8019
    OPTIMAL_PBUFFER_HEIGHT_SGIX = 0x801A
    PRESERVED_CONTENTS_SGIX     = 0x801B
    LARGEST_PBUFFER_SGIX        = 0x801C
    WIDTH_SGIX                  = 0x801D
    HEIGHT_SGIX                 = 0x801E
    EVENT_MASK_SGIX             = 0x801F
    DAMAGED_SGIX                = 0x8020
    SAVED_SGIX                  = 0x8021
    WINDOW_SGIX                 = 0x8022
    PBUFFER_SGIX                = 0x8023
  end
  
  Functions = {
    def glXCreateGLXPbufferSGIX(dpy, config, width, height, attrib_list) end => [ :GLXPbufferSGIX, :pointer, :GLXFBConfigSGIX, :uint, :uint, :pointer ].freeze,
    def glXDestroyGLXPbufferSGIX(dpy, pbuf) end => [ :void, :pointer, :GLXPbufferSGIX ].freeze,
    def glXQueryGLXPbufferSGIX(dpy, pbuf, attribute, value) end => [ :int, :pointer, :GLXPbufferSGIX, :int, :pointer ].freeze,
    def glXSelectEventSGIX(dpy, drawable, mask) end => [ :void, :pointer, :GLXDrawable, :ulong ].freeze,
    def glXGetSelectedEventSGIX(dpy, drawable, mask) end => [ :void, :pointer, :GLXDrawable, :pointer ].freeze,
  }.freeze
end