module GL_AMD_debug_output
  module Constants
    MAX_DEBUG_MESSAGE_LENGTH_AMD          = 0x9143
    MAX_DEBUG_LOGGED_MESSAGES_AMD         = 0x9144
    DEBUG_LOGGED_MESSAGES_AMD             = 0x9145
    DEBUG_SEVERITY_HIGH_AMD               = 0x9146
    DEBUG_SEVERITY_MEDIUM_AMD             = 0x9147
    DEBUG_SEVERITY_LOW_AMD                = 0x9148
    DEBUG_CATEGORY_API_ERROR_AMD          = 0x9149
    DEBUG_CATEGORY_WINDOW_SYSTEM_AMD      = 0x914A
    DEBUG_CATEGORY_DEPRECATION_AMD        = 0x914B
    DEBUG_CATEGORY_UNDEFINED_BEHAVIOR_AMD = 0x914C
    DEBUG_CATEGORY_PERFORMANCE_AMD        = 0x914D
    DEBUG_CATEGORY_SHADER_COMPILER_AMD    = 0x914E
    DEBUG_CATEGORY_APPLICATION_AMD        = 0x914F
    DEBUG_CATEGORY_OTHER_AMD              = 0x9150
  end
  
  Callbacks = {
    GLDEBUGPROCAMD: [ :void, :GLuint, :GLenum, :GLenum, :GLsizei, :string, :pointer ].freeze,
  }.freeze
  
  Functions = {
    def glDebugMessageEnableAMD(category, severity, count, ids, enabled) end => [ :void, :GLenum, :GLenum, :GLsizei, :pointer, :GLboolean ].freeze,
    def glDebugMessageInsertAMD(category, severity, id, length, buf) end => [ :void, :GLenum, :GLenum, :GLuint, :GLsizei, :string ].freeze,
    def glDebugMessageCallbackAMD(callback, userParam) end => [ :void, :GLDEBUGPROCAMD, :pointer ].freeze,
    def glGetDebugMessageLogAMD(count, bufsize, categories, severities, ids, lengths, message) end => [ :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :pointer, :string ].freeze,
  }.freeze
end