module GL_AMD_gpu_shader_int64
  module Constants
    INT64_NV               = 0x140E
    UNSIGNED_INT64_NV      = 0x140F
    INT8_NV                = 0x8FE0
    INT8_VEC2_NV           = 0x8FE1
    INT8_VEC3_NV           = 0x8FE2
    INT8_VEC4_NV           = 0x8FE3
    INT16_NV               = 0x8FE4
    INT16_VEC2_NV          = 0x8FE5
    INT16_VEC3_NV          = 0x8FE6
    INT16_VEC4_NV          = 0x8FE7
    INT64_VEC2_NV          = 0x8FE9
    INT64_VEC3_NV          = 0x8FEA
    INT64_VEC4_NV          = 0x8FEB
    UNSIGNED_INT8_NV       = 0x8FEC
    UNSIGNED_INT8_VEC2_NV  = 0x8FED
    UNSIGNED_INT8_VEC3_NV  = 0x8FEE
    UNSIGNED_INT8_VEC4_NV  = 0x8FEF
    UNSIGNED_INT16_NV      = 0x8FF0
    UNSIGNED_INT16_VEC2_NV = 0x8FF1
    UNSIGNED_INT16_VEC3_NV = 0x8FF2
    UNSIGNED_INT16_VEC4_NV = 0x8FF3
    UNSIGNED_INT64_VEC2_NV = 0x8FF5
    UNSIGNED_INT64_VEC3_NV = 0x8FF6
    UNSIGNED_INT64_VEC4_NV = 0x8FF7
    FLOAT16_NV             = 0x8FF8
    FLOAT16_VEC2_NV        = 0x8FF9
    FLOAT16_VEC3_NV        = 0x8FFA
    FLOAT16_VEC4_NV        = 0x8FFB
  end
  
  Functions = {
    def glUniform1i64NV(location, x) end => [ :void, :GLint, :GLint64EXT ].freeze,
    def glUniform2i64NV(location, x, y) end => [ :void, :GLint, :GLint64EXT, :GLint64EXT ].freeze,
    def glUniform3i64NV(location, x, y, z) end => [ :void, :GLint, :GLint64EXT, :GLint64EXT, :GLint64EXT ].freeze,
    def glUniform4i64NV(location, x, y, z, w) end => [ :void, :GLint, :GLint64EXT, :GLint64EXT, :GLint64EXT, :GLint64EXT ].freeze,
    def glUniform1i64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2i64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3i64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4i64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform1ui64NV(location, x) end => [ :void, :GLint, :GLuint64EXT ].freeze,
    def glUniform2ui64NV(location, x, y) end => [ :void, :GLint, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glUniform3ui64NV(location, x, y, z) end => [ :void, :GLint, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glUniform4ui64NV(location, x, y, z, w) end => [ :void, :GLint, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glUniform1ui64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2ui64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3ui64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4ui64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glGetUniformi64vNV(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glGetUniformui64vNV(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glProgramUniform1i64NV(program, location, x) end => [ :void, :GLuint, :GLint, :GLint64EXT ].freeze,
    def glProgramUniform2i64NV(program, location, x, y) end => [ :void, :GLuint, :GLint, :GLint64EXT, :GLint64EXT ].freeze,
    def glProgramUniform3i64NV(program, location, x, y, z) end => [ :void, :GLuint, :GLint, :GLint64EXT, :GLint64EXT, :GLint64EXT ].freeze,
    def glProgramUniform4i64NV(program, location, x, y, z, w) end => [ :void, :GLuint, :GLint, :GLint64EXT, :GLint64EXT, :GLint64EXT, :GLint64EXT ].freeze,
    def glProgramUniform1i64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2i64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3i64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4i64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform1ui64NV(program, location, x) end => [ :void, :GLuint, :GLint, :GLuint64EXT ].freeze,
    def glProgramUniform2ui64NV(program, location, x, y) end => [ :void, :GLuint, :GLint, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glProgramUniform3ui64NV(program, location, x, y, z) end => [ :void, :GLuint, :GLint, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glProgramUniform4ui64NV(program, location, x, y, z, w) end => [ :void, :GLuint, :GLint, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glProgramUniform1ui64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2ui64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3ui64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4ui64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
  }.freeze
end