module GL_AMD_performance_monitor
  module Constants
    COUNTER_TYPE_AMD             = 0x8BC0
    COUNTER_RANGE_AMD            = 0x8BC1
    UNSIGNED_INT64_AMD           = 0x8BC2
    PERCENTAGE_AMD               = 0x8BC3
    PERFMON_RESULT_AVAILABLE_AMD = 0x8BC4
    PERFMON_RESULT_SIZE_AMD      = 0x8BC5
    PERFMON_RESULT_AMD           = 0x8BC6
  end
  
  Functions = {
    def glGetPerfMonitorGroupsAMD(numGroups, groupsSize, groups) end => [ :void, :pointer, :GLsizei, :pointer ].freeze,
    def glGetPerfMonitorCountersAMD(group, numCounters, maxActiveCounters, counterSize, counters) end => [ :void, :GLuint, :pointer, :pointer, :GLsizei, :pointer ].freeze,
    def glGetPerfMonitorGroupStringAMD(group, bufSize, length, groupString) end => [ :void, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glGetPerfMonitorCounterStringAMD(group, counter, bufSize, length, counterString) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glGetPerfMonitorCounterInfoAMD(group, counter, pname, data) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glGenPerfMonitorsAMD(n, monitors) end => [ :void, :GLsizei, :pointer ].freeze,
    def glDeletePerfMonitorsAMD(n, monitors) end => [ :void, :GLsizei, :pointer ].freeze,
    def glSelectPerfMonitorCountersAMD(monitor, enable, group, numCounters, counterList) end => [ :void, :GLuint, :GLboolean, :GLuint, :GLint, :pointer ].freeze,
    def glBeginPerfMonitorAMD(monitor) end => [ :void, :GLuint ].freeze,
    def glEndPerfMonitorAMD(monitor) end => [ :void, :GLuint ].freeze,
    def glGetPerfMonitorCounterDataAMD(monitor, pname, dataSize, data, bytesWritten) end => [ :void, :GLuint, :GLenum, :GLsizei, :pointer, :pointer ].freeze,
  }.freeze
end