module GL_APPLE_sync
  module Constants
    SYNC_OBJECT_APPLE                = 0x8A53
    MAX_SERVER_WAIT_TIMEOUT_APPLE    = 0x9111
    OBJECT_TYPE_APPLE                = 0x9112
    SYNC_CONDITION_APPLE             = 0x9113
    SYNC_STATUS_APPLE                = 0x9114
    SYNC_FLAGS_APPLE                 = 0x9115
    SYNC_FENCE_APPLE                 = 0x9116
    SYNC_GPU_COMMANDS_COMPLETE_APPLE = 0x9117
    UNSIGNALED_APPLE                 = 0x9118
    SIGNALED_APPLE                   = 0x9119
    ALREADY_SIGNALED_APPLE           = 0x911A
    TIMEOUT_EXPIRED_APPLE            = 0x911B
    CONDITION_SATISFIED_APPLE        = 0x911C
    WAIT_FAILED_APPLE                = 0x911D
    SYNC_FLUSH_COMMANDS_BIT_APPLE    = 0x00000001
    TIMEOUT_IGNORED_APPLE            = 0xFFFFFFFFFFFFFFFF
  end
  
  Functions = {
    def glFenceSyncAPPLE(condition, flags) end => [ :GLsync, :GLenum, :GLbitfield ].freeze,
    def glIsSyncAPPLE(sync) end => [ :GLboolean, :GLsync ].freeze,
    def glDeleteSyncAPPLE(sync) end => [ :void, :GLsync ].freeze,
    def glClientWaitSyncAPPLE(sync, flags, timeout) end => [ :GLenum, :GLsync, :GLbitfield, :GLuint64 ].freeze,
    def glWaitSyncAPPLE(sync, flags, timeout) end => [ :void, :GLsync, :GLbitfield, :GLuint64 ].freeze,
    def glGetInteger64vAPPLE(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
    def glGetSyncivAPPLE(sync, pname, bufSize, length, values) end => [ :void, :GLsync, :GLenum, :GLsizei, :pointer, :pointer ].freeze,
  }.freeze
end