module GL_ARB_ES2_compatibility
  module Constants
    FIXED                            = 0x140C
    IMPLEMENTATION_COLOR_READ_TYPE   = 0x8B9A
    IMPLEMENTATION_COLOR_READ_FORMAT = 0x8B9B
    LOW_FLOAT                        = 0x8DF0
    MEDIUM_FLOAT                     = 0x8DF1
    HIGH_FLOAT                       = 0x8DF2
    LOW_INT                          = 0x8DF3
    MEDIUM_INT                       = 0x8DF4
    HIGH_INT                         = 0x8DF5
    SHADER_COMPILER                  = 0x8DFA
    SHADER_BINARY_FORMATS            = 0x8DF8
    NUM_SHADER_BINARY_FORMATS        = 0x8DF9
    MAX_VERTEX_UNIFORM_VECTORS       = 0x8DFB
    MAX_VARYING_VECTORS              = 0x8DFC
    MAX_FRAGMENT_UNIFORM_VECTORS     = 0x8DFD
    RGB565                           = 0x8D62
  end
  
  Functions = {
    def glReleaseShaderCompiler() end => [ :void ].freeze,
    def glShaderBinary(count, shaders, binaryformat, binary, length) end => [ :void, :GLsizei, :pointer, :GLenum, :pointer, :GLsizei ].freeze,
    def glGetShaderPrecisionFormat(shadertype, precisiontype, range, precision) end => [ :void, :GLenum, :GLenum, :pointer, :pointer ].freeze,
    def glDepthRangef(n, f) end => [ :void, :GLfloat, :GLfloat ].freeze,
    def glClearDepthf(d) end => [ :void, :GLfloat ].freeze,
  }.freeze
end