module GL_ARB_bindless_texture
  module Constants
    UNSIGNED_INT64_ARB = 0x140F
  end
  
  Functions = {
    def glGetTextureHandleARB(texture) end => [ :GLuint64, :GLuint ].freeze,
    def glGetTextureSamplerHandleARB(texture, sampler) end => [ :GLuint64, :GLuint, :GLuint ].freeze,
    def glMakeTextureHandleResidentARB(handle) end => [ :void, :GLuint64 ].freeze,
    def glMakeTextureHandleNonResidentARB(handle) end => [ :void, :GLuint64 ].freeze,
    def glGetImageHandleARB(texture, level, layered, layer, format) end => [ :GLuint64, :GLuint, :GLint, :GLboolean, :GLint, :GLenum ].freeze,
    def glMakeImageHandleResidentARB(handle, access) end => [ :void, :GLuint64, :GLenum ].freeze,
    def glMakeImageHandleNonResidentARB(handle) end => [ :void, :GLuint64 ].freeze,
    def glUniformHandleui64ARB(location, value) end => [ :void, :GLint, :GLuint64 ].freeze,
    def glUniformHandleui64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniformHandleui64ARB(program, location, value) end => [ :void, :GLuint, :GLint, :GLuint64 ].freeze,
    def glProgramUniformHandleui64vARB(program, location, count, values) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glIsTextureHandleResidentARB(handle) end => [ :GLboolean, :GLuint64 ].freeze,
    def glIsImageHandleResidentARB(handle) end => [ :GLboolean, :GLuint64 ].freeze,
    def glVertexAttribL1ui64ARB(index, x) end => [ :void, :GLuint, :GLuint64EXT ].freeze,
    def glVertexAttribL1ui64vARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glGetVertexAttribLui64vARB(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end