module GL_ARB_direct_state_access
  module Constants
    TEXTURE_TARGET                       = 0x1006
    QUERY_TARGET                         = 0x82EA
    TEXTURE_BINDING_1D                   = 0x8068
    TEXTURE_BINDING_1D_ARRAY             = 0x8C1C
    TEXTURE_BINDING_2D                   = 0x8069
    TEXTURE_BINDING_2D_ARRAY             = 0x8C1D
    TEXTURE_BINDING_2D_MULTISAMPLE       = 0x9104
    TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY = 0x9105
    TEXTURE_BINDING_3D                   = 0x806A
    TEXTURE_BINDING_BUFFER               = 0x8C2C
    TEXTURE_BINDING_CUBE_MAP             = 0x8514
    TEXTURE_BINDING_CUBE_MAP_ARRAY       = 0x900A
    TEXTURE_BINDING_RECTANGLE            = 0x84F6
  end
  
  Functions = {
    def glCreateTransformFeedbacks(n, ids) end => [ :void, :GLsizei, :pointer ].freeze,
    def glTransformFeedbackBufferBase(xfb, index, buffer) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glTransformFeedbackBufferRange(xfb, index, buffer, offset, size) end => [ :void, :GLuint, :GLuint, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glGetTransformFeedbackiv(xfb, pname, param) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetTransformFeedbacki_v(xfb, pname, index, param) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glGetTransformFeedbacki64_v(xfb, pname, index, param) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glCreateBuffers(n, buffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glNamedBufferStorage(buffer, size, data, flags) end => [ :void, :GLuint, :GLsizeiptr, :pointer, :GLbitfield ].freeze,
    def glNamedBufferData(buffer, size, data, usage) end => [ :void, :GLuint, :GLsizeiptr, :pointer, :GLenum ].freeze,
    def glNamedBufferSubData(buffer, offset, size, data) end => [ :void, :GLuint, :GLintptr, :GLsizeiptr, :pointer ].freeze,
    def glCopyNamedBufferSubData(readBuffer, writeBuffer, readOffset, writeOffset, size) end => [ :void, :GLuint, :GLuint, :GLintptr, :GLintptr, :GLsizeiptr ].freeze,
    def glClearNamedBufferData(buffer, internalformat, format, type, data) end => [ :void, :GLuint, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glClearNamedBufferSubData(buffer, internalformat, offset, size, format, type, data) end => [ :void, :GLuint, :GLenum, :GLintptr, :GLsizeiptr, :GLenum, :GLenum, :pointer ].freeze,
    def glMapNamedBuffer(buffer, access) end => [ :pointer, :GLuint, :GLenum ].freeze,
    def glMapNamedBufferRange(buffer, offset, length, access) end => [ :pointer, :GLuint, :GLintptr, :GLsizeiptr, :GLbitfield ].freeze,
    def glUnmapNamedBuffer(buffer) end => [ :GLboolean, :GLuint ].freeze,
    def glFlushMappedNamedBufferRange(buffer, offset, length) end => [ :void, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glGetNamedBufferParameteriv(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetNamedBufferParameteri64v(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetNamedBufferPointerv(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetNamedBufferSubData(buffer, offset, size, data) end => [ :void, :GLuint, :GLintptr, :GLsizeiptr, :pointer ].freeze,
    def glCreateFramebuffers(n, framebuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glNamedFramebufferRenderbuffer(framebuffer, attachment, renderbuffertarget, renderbuffer) end => [ :void, :GLuint, :GLenum, :GLenum, :GLuint ].freeze,
    def glNamedFramebufferParameteri(framebuffer, pname, param) end => [ :void, :GLuint, :GLenum, :GLint ].freeze,
    def glNamedFramebufferTexture(framebuffer, attachment, texture, level) end => [ :void, :GLuint, :GLenum, :GLuint, :GLint ].freeze,
    def glNamedFramebufferTextureLayer(framebuffer, attachment, texture, level, layer) end => [ :void, :GLuint, :GLenum, :GLuint, :GLint, :GLint ].freeze,
    def glNamedFramebufferDrawBuffer(framebuffer, buf) end => [ :void, :GLuint, :GLenum ].freeze,
    def glNamedFramebufferDrawBuffers(framebuffer, n, bufs) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glNamedFramebufferReadBuffer(framebuffer, src) end => [ :void, :GLuint, :GLenum ].freeze,
    def glInvalidateNamedFramebufferData(framebuffer, numAttachments, attachments) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glInvalidateNamedFramebufferSubData(framebuffer, numAttachments, attachments, x, y, width, height) end => [ :void, :GLuint, :GLsizei, :pointer, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glClearNamedFramebufferiv(framebuffer, buffer, drawbuffer, value) end => [ :void, :GLuint, :GLenum, :GLint, :pointer ].freeze,
    def glClearNamedFramebufferuiv(framebuffer, buffer, drawbuffer, value) end => [ :void, :GLuint, :GLenum, :GLint, :pointer ].freeze,
    def glClearNamedFramebufferfv(framebuffer, buffer, drawbuffer, value) end => [ :void, :GLuint, :GLenum, :GLint, :pointer ].freeze,
    def glClearNamedFramebufferfi(framebuffer, buffer, drawbuffer, depth, stencil) end => [ :void, :GLuint, :GLenum, :GLint, :GLfloat, :GLint ].freeze,
    def glBlitNamedFramebuffer(readFramebuffer, drawFramebuffer, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter) end => [ :void, :GLuint, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLbitfield, :GLenum ].freeze,
    def glCheckNamedFramebufferStatus(framebuffer, target) end => [ :GLenum, :GLuint, :GLenum ].freeze,
    def glGetNamedFramebufferParameteriv(framebuffer, pname, param) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetNamedFramebufferAttachmentParameteriv(framebuffer, attachment, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glCreateRenderbuffers(n, renderbuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glNamedRenderbufferStorage(renderbuffer, internalformat, width, height) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glNamedRenderbufferStorageMultisample(renderbuffer, samples, internalformat, width, height) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glGetNamedRenderbufferParameteriv(renderbuffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glCreateTextures(target, n, textures) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
    def glTextureBuffer(texture, internalformat, buffer) end => [ :void, :GLuint, :GLenum, :GLuint ].freeze,
    def glTextureBufferRange(texture, internalformat, buffer, offset, size) end => [ :void, :GLuint, :GLenum, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glTextureStorage1D(texture, levels, internalformat, width) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei ].freeze,
    def glTextureStorage2D(texture, levels, internalformat, width, height) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glTextureStorage3D(texture, levels, internalformat, width, height, depth) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei ].freeze,
    def glTextureStorage2DMultisample(texture, samples, internalformat, width, height, fixedsamplelocations) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLboolean ].freeze,
    def glTextureStorage3DMultisample(texture, samples, internalformat, width, height, depth, fixedsamplelocations) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLboolean ].freeze,
    def glTextureSubImage1D(texture, level, xoffset, width, format, type, pixels) end => [ :void, :GLuint, :GLint, :GLint, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureSubImage2D(texture, level, xoffset, yoffset, width, height, format, type, pixels) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureSubImage3D(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glCompressedTextureSubImage1D(texture, level, xoffset, width, format, imageSize, data) end => [ :void, :GLuint, :GLint, :GLint, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glCompressedTextureSubImage2D(texture, level, xoffset, yoffset, width, height, format, imageSize, data) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glCompressedTextureSubImage3D(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glCopyTextureSubImage1D(texture, level, xoffset, x, y, width) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLsizei ].freeze,
    def glCopyTextureSubImage2D(texture, level, xoffset, yoffset, x, y, width, height) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glCopyTextureSubImage3D(texture, level, xoffset, yoffset, zoffset, x, y, width, height) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glTextureParameterf(texture, pname, param) end => [ :void, :GLuint, :GLenum, :GLfloat ].freeze,
    def glTextureParameterfv(texture, pname, param) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glTextureParameteri(texture, pname, param) end => [ :void, :GLuint, :GLenum, :GLint ].freeze,
    def glTextureParameterIiv(texture, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glTextureParameterIuiv(texture, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glTextureParameteriv(texture, pname, param) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGenerateTextureMipmap(texture) end => [ :void, :GLuint ].freeze,
    def glBindTextureUnit(unit, texture) end => [ :void, :GLuint, :GLuint ].freeze,
    def glGetTextureImage(texture, level, format, type, bufSize, pixels) end => [ :void, :GLuint, :GLint, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetCompressedTextureImage(texture, level, bufSize, pixels) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetTextureLevelParameterfv(texture, level, pname, params) end => [ :void, :GLuint, :GLint, :GLenum, :pointer ].freeze,
    def glGetTextureLevelParameteriv(texture, level, pname, params) end => [ :void, :GLuint, :GLint, :GLenum, :pointer ].freeze,
    def glGetTextureParameterfv(texture, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetTextureParameterIiv(texture, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetTextureParameterIuiv(texture, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetTextureParameteriv(texture, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glCreateVertexArrays(n, arrays) end => [ :void, :GLsizei, :pointer ].freeze,
    def glDisableVertexArrayAttrib(vaobj, index) end => [ :void, :GLuint, :GLuint ].freeze,
    def glEnableVertexArrayAttrib(vaobj, index) end => [ :void, :GLuint, :GLuint ].freeze,
    def glVertexArrayElementBuffer(vaobj, buffer) end => [ :void, :GLuint, :GLuint ].freeze,
    def glVertexArrayVertexBuffer(vaobj, bindingindex, buffer, offset, stride) end => [ :void, :GLuint, :GLuint, :GLuint, :GLintptr, :GLsizei ].freeze,
    def glVertexArrayVertexBuffers(vaobj, first, count, buffers, offsets, strides) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer ].freeze,
    def glVertexArrayAttribBinding(vaobj, attribindex, bindingindex) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glVertexArrayAttribFormat(vaobj, attribindex, size, type, normalized, relativeoffset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLboolean, :GLuint ].freeze,
    def glVertexArrayAttribIFormat(vaobj, attribindex, size, type, relativeoffset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLuint ].freeze,
    def glVertexArrayAttribLFormat(vaobj, attribindex, size, type, relativeoffset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLuint ].freeze,
    def glVertexArrayBindingDivisor(vaobj, bindingindex, divisor) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glGetVertexArrayiv(vaobj, pname, param) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexArrayIndexediv(vaobj, index, pname, param) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexArrayIndexed64iv(vaobj, index, pname, param) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glCreateSamplers(n, samplers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glCreateProgramPipelines(n, pipelines) end => [ :void, :GLsizei, :pointer ].freeze,
    def glCreateQueries(target, n, ids) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetQueryBufferObjecti64v(id, buffer, pname, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLintptr ].freeze,
    def glGetQueryBufferObjectiv(id, buffer, pname, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLintptr ].freeze,
    def glGetQueryBufferObjectui64v(id, buffer, pname, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLintptr ].freeze,
    def glGetQueryBufferObjectuiv(id, buffer, pname, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLintptr ].freeze,
  }.freeze
end