module GL_ARB_fragment_program
  module Constants
    FRAGMENT_PROGRAM_ARB                    = 0x8804
    PROGRAM_FORMAT_ASCII_ARB                = 0x8875
    PROGRAM_LENGTH_ARB                      = 0x8627
    PROGRAM_FORMAT_ARB                      = 0x8876
    PROGRAM_BINDING_ARB                     = 0x8677
    PROGRAM_INSTRUCTIONS_ARB                = 0x88A0
    MAX_PROGRAM_INSTRUCTIONS_ARB            = 0x88A1
    PROGRAM_NATIVE_INSTRUCTIONS_ARB         = 0x88A2
    MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB     = 0x88A3
    PROGRAM_TEMPORARIES_ARB                 = 0x88A4
    MAX_PROGRAM_TEMPORARIES_ARB             = 0x88A5
    PROGRAM_NATIVE_TEMPORARIES_ARB          = 0x88A6
    MAX_PROGRAM_NATIVE_TEMPORARIES_ARB      = 0x88A7
    PROGRAM_PARAMETERS_ARB                  = 0x88A8
    MAX_PROGRAM_PARAMETERS_ARB              = 0x88A9
    PROGRAM_NATIVE_PARAMETERS_ARB           = 0x88AA
    MAX_PROGRAM_NATIVE_PARAMETERS_ARB       = 0x88AB
    PROGRAM_ATTRIBS_ARB                     = 0x88AC
    MAX_PROGRAM_ATTRIBS_ARB                 = 0x88AD
    PROGRAM_NATIVE_ATTRIBS_ARB              = 0x88AE
    MAX_PROGRAM_NATIVE_ATTRIBS_ARB          = 0x88AF
    MAX_PROGRAM_LOCAL_PARAMETERS_ARB        = 0x88B4
    MAX_PROGRAM_ENV_PARAMETERS_ARB          = 0x88B5
    PROGRAM_UNDER_NATIVE_LIMITS_ARB         = 0x88B6
    PROGRAM_ALU_INSTRUCTIONS_ARB            = 0x8805
    PROGRAM_TEX_INSTRUCTIONS_ARB            = 0x8806
    PROGRAM_TEX_INDIRECTIONS_ARB            = 0x8807
    PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB     = 0x8808
    PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB     = 0x8809
    PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB     = 0x880A
    MAX_PROGRAM_ALU_INSTRUCTIONS_ARB        = 0x880B
    MAX_PROGRAM_TEX_INSTRUCTIONS_ARB        = 0x880C
    MAX_PROGRAM_TEX_INDIRECTIONS_ARB        = 0x880D
    MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB = 0x880E
    MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB = 0x880F
    MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB = 0x8810
    PROGRAM_STRING_ARB                      = 0x8628
    PROGRAM_ERROR_POSITION_ARB              = 0x864B
    CURRENT_MATRIX_ARB                      = 0x8641
    TRANSPOSE_CURRENT_MATRIX_ARB            = 0x88B7
    CURRENT_MATRIX_STACK_DEPTH_ARB          = 0x8640
    MAX_PROGRAM_MATRICES_ARB                = 0x862F
    MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB      = 0x862E
    MAX_TEXTURE_COORDS_ARB                  = 0x8871
    MAX_TEXTURE_IMAGE_UNITS_ARB             = 0x8872
    PROGRAM_ERROR_STRING_ARB                = 0x8874
    MATRIX0_ARB                             = 0x88C0
    MATRIX1_ARB                             = 0x88C1
    MATRIX2_ARB                             = 0x88C2
    MATRIX3_ARB                             = 0x88C3
    MATRIX4_ARB                             = 0x88C4
    MATRIX5_ARB                             = 0x88C5
    MATRIX6_ARB                             = 0x88C6
    MATRIX7_ARB                             = 0x88C7
    MATRIX8_ARB                             = 0x88C8
    MATRIX9_ARB                             = 0x88C9
    MATRIX10_ARB                            = 0x88CA
    MATRIX11_ARB                            = 0x88CB
    MATRIX12_ARB                            = 0x88CC
    MATRIX13_ARB                            = 0x88CD
    MATRIX14_ARB                            = 0x88CE
    MATRIX15_ARB                            = 0x88CF
    MATRIX16_ARB                            = 0x88D0
    MATRIX17_ARB                            = 0x88D1
    MATRIX18_ARB                            = 0x88D2
    MATRIX19_ARB                            = 0x88D3
    MATRIX20_ARB                            = 0x88D4
    MATRIX21_ARB                            = 0x88D5
    MATRIX22_ARB                            = 0x88D6
    MATRIX23_ARB                            = 0x88D7
    MATRIX24_ARB                            = 0x88D8
    MATRIX25_ARB                            = 0x88D9
    MATRIX26_ARB                            = 0x88DA
    MATRIX27_ARB                            = 0x88DB
    MATRIX28_ARB                            = 0x88DC
    MATRIX29_ARB                            = 0x88DD
    MATRIX30_ARB                            = 0x88DE
    MATRIX31_ARB                            = 0x88DF
  end
  
  Functions = {
    def glProgramStringARB(target, format, len, string) end => [ :void, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glBindProgramARB(target, program) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteProgramsARB(n, programs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGenProgramsARB(n, programs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glProgramEnvParameter4dARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramEnvParameter4dvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramEnvParameter4fARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramEnvParameter4fvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramLocalParameter4dARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramLocalParameter4dvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramLocalParameter4fARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramLocalParameter4fvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramEnvParameterdvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramEnvParameterfvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramLocalParameterdvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramLocalParameterfvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramivARB(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetProgramStringARB(target, pname, string) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glIsProgramARB(program) end => [ :GLboolean, :GLuint ].freeze,
  }.freeze
end