module GL_ARB_framebuffer_object
  module Constants
    INVALID_FRAMEBUFFER_OPERATION                = 0x0506
    FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING        = 0x8210
    FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE        = 0x8211
    FRAMEBUFFER_ATTACHMENT_RED_SIZE              = 0x8212
    FRAMEBUFFER_ATTACHMENT_GREEN_SIZE            = 0x8213
    FRAMEBUFFER_ATTACHMENT_BLUE_SIZE             = 0x8214
    FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE            = 0x8215
    FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE            = 0x8216
    FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE          = 0x8217
    FRAMEBUFFER_DEFAULT                          = 0x8218
    FRAMEBUFFER_UNDEFINED                        = 0x8219
    DEPTH_STENCIL_ATTACHMENT                     = 0x821A
    MAX_RENDERBUFFER_SIZE                        = 0x84E8
    DEPTH_STENCIL                                = 0x84F9
    UNSIGNED_INT_24_8                            = 0x84FA
    DEPTH24_STENCIL8                             = 0x88F0
    TEXTURE_STENCIL_SIZE                         = 0x88F1
    UNSIGNED_NORMALIZED                          = 0x8C17
    FRAMEBUFFER_BINDING                          = 0x8CA6
    DRAW_FRAMEBUFFER_BINDING                     = 0x8CA6
    RENDERBUFFER_BINDING                         = 0x8CA7
    READ_FRAMEBUFFER                             = 0x8CA8
    DRAW_FRAMEBUFFER                             = 0x8CA9
    READ_FRAMEBUFFER_BINDING                     = 0x8CAA
    RENDERBUFFER_SAMPLES                         = 0x8CAB
    FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE           = 0x8CD0
    FRAMEBUFFER_ATTACHMENT_OBJECT_NAME           = 0x8CD1
    FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL         = 0x8CD2
    FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE = 0x8CD3
    FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER         = 0x8CD4
    FRAMEBUFFER_COMPLETE                         = 0x8CD5
    FRAMEBUFFER_INCOMPLETE_ATTACHMENT            = 0x8CD6
    FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT    = 0x8CD7
    FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER           = 0x8CDB
    FRAMEBUFFER_INCOMPLETE_READ_BUFFER           = 0x8CDC
    FRAMEBUFFER_UNSUPPORTED                      = 0x8CDD
    MAX_COLOR_ATTACHMENTS                        = 0x8CDF
    COLOR_ATTACHMENT0                            = 0x8CE0
    COLOR_ATTACHMENT1                            = 0x8CE1
    COLOR_ATTACHMENT2                            = 0x8CE2
    COLOR_ATTACHMENT3                            = 0x8CE3
    COLOR_ATTACHMENT4                            = 0x8CE4
    COLOR_ATTACHMENT5                            = 0x8CE5
    COLOR_ATTACHMENT6                            = 0x8CE6
    COLOR_ATTACHMENT7                            = 0x8CE7
    COLOR_ATTACHMENT8                            = 0x8CE8
    COLOR_ATTACHMENT9                            = 0x8CE9
    COLOR_ATTACHMENT10                           = 0x8CEA
    COLOR_ATTACHMENT11                           = 0x8CEB
    COLOR_ATTACHMENT12                           = 0x8CEC
    COLOR_ATTACHMENT13                           = 0x8CED
    COLOR_ATTACHMENT14                           = 0x8CEE
    COLOR_ATTACHMENT15                           = 0x8CEF
    DEPTH_ATTACHMENT                             = 0x8D00
    STENCIL_ATTACHMENT                           = 0x8D20
    FRAMEBUFFER                                  = 0x8D40
    RENDERBUFFER                                 = 0x8D41
    RENDERBUFFER_WIDTH                           = 0x8D42
    RENDERBUFFER_HEIGHT                          = 0x8D43
    RENDERBUFFER_INTERNAL_FORMAT                 = 0x8D44
    STENCIL_INDEX1                               = 0x8D46
    STENCIL_INDEX4                               = 0x8D47
    STENCIL_INDEX8                               = 0x8D48
    STENCIL_INDEX16                              = 0x8D49
    RENDERBUFFER_RED_SIZE                        = 0x8D50
    RENDERBUFFER_GREEN_SIZE                      = 0x8D51
    RENDERBUFFER_BLUE_SIZE                       = 0x8D52
    RENDERBUFFER_ALPHA_SIZE                      = 0x8D53
    RENDERBUFFER_DEPTH_SIZE                      = 0x8D54
    RENDERBUFFER_STENCIL_SIZE                    = 0x8D55
    FRAMEBUFFER_INCOMPLETE_MULTISAMPLE           = 0x8D56
    MAX_SAMPLES                                  = 0x8D57
    INDEX                                        = 0x8222
  end
  
  Functions = {
    def glIsRenderbuffer(renderbuffer) end => [ :GLboolean, :GLuint ].freeze,
    def glBindRenderbuffer(target, renderbuffer) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteRenderbuffers(n, renderbuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGenRenderbuffers(n, renderbuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glRenderbufferStorage(target, internalformat, width, height) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glGetRenderbufferParameteriv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glIsFramebuffer(framebuffer) end => [ :GLboolean, :GLuint ].freeze,
    def glBindFramebuffer(target, framebuffer) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteFramebuffers(n, framebuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGenFramebuffers(n, framebuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glCheckFramebufferStatus(target) end => [ :GLenum, :GLenum ].freeze,
    def glFramebufferTexture1D(target, attachment, textarget, texture, level) end => [ :void, :GLenum, :GLenum, :GLenum, :GLuint, :GLint ].freeze,
    def glFramebufferTexture2D(target, attachment, textarget, texture, level) end => [ :void, :GLenum, :GLenum, :GLenum, :GLuint, :GLint ].freeze,
    def glFramebufferTexture3D(target, attachment, textarget, texture, level, zoffset) end => [ :void, :GLenum, :GLenum, :GLenum, :GLuint, :GLint, :GLint ].freeze,
    def glFramebufferRenderbuffer(target, attachment, renderbuffertarget, renderbuffer) end => [ :void, :GLenum, :GLenum, :GLenum, :GLuint ].freeze,
    def glGetFramebufferAttachmentParameteriv(target, attachment, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGenerateMipmap(target) end => [ :void, :GLenum ].freeze,
    def glBlitFramebuffer(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter) end => [ :void, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLbitfield, :GLenum ].freeze,
    def glRenderbufferStorageMultisample(target, samples, internalformat, width, height) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glFramebufferTextureLayer(target, attachment, texture, level, layer) end => [ :void, :GLenum, :GLenum, :GLuint, :GLint, :GLint ].freeze,
  }.freeze
end