module GL_ARB_geometry_shader4
  module Constants
    LINES_ADJACENCY_ARB                      = 0x000A
    LINE_STRIP_ADJACENCY_ARB                 = 0x000B
    TRIANGLES_ADJACENCY_ARB                  = 0x000C
    TRIANGLE_STRIP_ADJACENCY_ARB             = 0x000D
    PROGRAM_POINT_SIZE_ARB                   = 0x8642
    MAX_GEOMETRY_TEXTURE_IMAGE_UNITS_ARB     = 0x8C29
    FRAMEBUFFER_ATTACHMENT_LAYERED_ARB       = 0x8DA7
    FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS_ARB = 0x8DA8
    FRAMEBUFFER_INCOMPLETE_LAYER_COUNT_ARB   = 0x8DA9
    GEOMETRY_SHADER_ARB                      = 0x8DD9
    GEOMETRY_VERTICES_OUT_ARB                = 0x8DDA
    GEOMETRY_INPUT_TYPE_ARB                  = 0x8DDB
    GEOMETRY_OUTPUT_TYPE_ARB                 = 0x8DDC
    MAX_GEOMETRY_VARYING_COMPONENTS_ARB      = 0x8DDD
    MAX_VERTEX_VARYING_COMPONENTS_ARB        = 0x8DDE
    MAX_GEOMETRY_UNIFORM_COMPONENTS_ARB      = 0x8DDF
    MAX_GEOMETRY_OUTPUT_VERTICES_ARB         = 0x8DE0
    MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_ARB = 0x8DE1
    MAX_VARYING_COMPONENTS                   = 0x8B4B
    FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER     = 0x8CD4
  end
  
  Functions = {
    def glProgramParameteriARB(program, pname, value) end => [ :void, :GLuint, :GLenum, :GLint ].freeze,
    def glFramebufferTextureARB(target, attachment, texture, level) end => [ :void, :GLenum, :GLenum, :GLuint, :GLint ].freeze,
    def glFramebufferTextureLayerARB(target, attachment, texture, level, layer) end => [ :void, :GLenum, :GLenum, :GLuint, :GLint, :GLint ].freeze,
    def glFramebufferTextureFaceARB(target, attachment, texture, level, face) end => [ :void, :GLenum, :GLenum, :GLuint, :GLint, :GLenum ].freeze,
  }.freeze
end