module GL_ARB_gpu_shader_fp64
  module Constants
    DOUBLE        = 0x140A
    DOUBLE_VEC2   = 0x8FFC
    DOUBLE_VEC3   = 0x8FFD
    DOUBLE_VEC4   = 0x8FFE
    DOUBLE_MAT2   = 0x8F46
    DOUBLE_MAT3   = 0x8F47
    DOUBLE_MAT4   = 0x8F48
    DOUBLE_MAT2x3 = 0x8F49
    DOUBLE_MAT2x4 = 0x8F4A
    DOUBLE_MAT3x2 = 0x8F4B
    DOUBLE_MAT3x4 = 0x8F4C
    DOUBLE_MAT4x2 = 0x8F4D
    DOUBLE_MAT4x3 = 0x8F4E
  end
  
  Functions = {
    def glUniform1d(location, x) end => [ :void, :GLint, :GLdouble ].freeze,
    def glUniform2d(location, x, y) end => [ :void, :GLint, :GLdouble, :GLdouble ].freeze,
    def glUniform3d(location, x, y, z) end => [ :void, :GLint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glUniform4d(location, x, y, z, w) end => [ :void, :GLint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glUniform1dv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2dv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3dv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4dv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniformMatrix2dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix3dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix4dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix2x3dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix2x4dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix3x2dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix3x4dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix4x2dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix4x3dv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glGetUniformdv(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
  }.freeze
end