module GL_ARB_gpu_shader_int64
  module Constants
    INT64_ARB               = 0x140E
    UNSIGNED_INT64_ARB      = 0x140F
    INT64_VEC2_ARB          = 0x8FE9
    INT64_VEC3_ARB          = 0x8FEA
    INT64_VEC4_ARB          = 0x8FEB
    UNSIGNED_INT64_VEC2_ARB = 0x8FF5
    UNSIGNED_INT64_VEC3_ARB = 0x8FF6
    UNSIGNED_INT64_VEC4_ARB = 0x8FF7
  end
  
  Functions = {
    def glUniform1i64ARB(location, x) end => [ :void, :GLint, :GLint64 ].freeze,
    def glUniform2i64ARB(location, x, y) end => [ :void, :GLint, :GLint64, :GLint64 ].freeze,
    def glUniform3i64ARB(location, x, y, z) end => [ :void, :GLint, :GLint64, :GLint64, :GLint64 ].freeze,
    def glUniform4i64ARB(location, x, y, z, w) end => [ :void, :GLint, :GLint64, :GLint64, :GLint64, :GLint64 ].freeze,
    def glUniform1i64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2i64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3i64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4i64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform1ui64ARB(location, x) end => [ :void, :GLint, :GLuint64 ].freeze,
    def glUniform2ui64ARB(location, x, y) end => [ :void, :GLint, :GLuint64, :GLuint64 ].freeze,
    def glUniform3ui64ARB(location, x, y, z) end => [ :void, :GLint, :GLuint64, :GLuint64, :GLuint64 ].freeze,
    def glUniform4ui64ARB(location, x, y, z, w) end => [ :void, :GLint, :GLuint64, :GLuint64, :GLuint64, :GLuint64 ].freeze,
    def glUniform1ui64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2ui64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3ui64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4ui64vARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glGetUniformi64vARB(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glGetUniformui64vARB(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glGetnUniformi64vARB(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformui64vARB(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform1i64ARB(program, location, x) end => [ :void, :GLuint, :GLint, :GLint64 ].freeze,
    def glProgramUniform2i64ARB(program, location, x, y) end => [ :void, :GLuint, :GLint, :GLint64, :GLint64 ].freeze,
    def glProgramUniform3i64ARB(program, location, x, y, z) end => [ :void, :GLuint, :GLint, :GLint64, :GLint64, :GLint64 ].freeze,
    def glProgramUniform4i64ARB(program, location, x, y, z, w) end => [ :void, :GLuint, :GLint, :GLint64, :GLint64, :GLint64, :GLint64 ].freeze,
    def glProgramUniform1i64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2i64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3i64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4i64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform1ui64ARB(program, location, x) end => [ :void, :GLuint, :GLint, :GLuint64 ].freeze,
    def glProgramUniform2ui64ARB(program, location, x, y) end => [ :void, :GLuint, :GLint, :GLuint64, :GLuint64 ].freeze,
    def glProgramUniform3ui64ARB(program, location, x, y, z) end => [ :void, :GLuint, :GLint, :GLuint64, :GLuint64, :GLuint64 ].freeze,
    def glProgramUniform4ui64ARB(program, location, x, y, z, w) end => [ :void, :GLuint, :GLint, :GLuint64, :GLuint64, :GLuint64, :GLuint64 ].freeze,
    def glProgramUniform1ui64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2ui64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3ui64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4ui64vARB(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
  }.freeze
end