module GL_ARB_imaging
  module Constants
    BLEND_COLOR                         = 0x8005
    BLEND_EQUATION                      = 0x8009
    CONSTANT_COLOR                      = 0x8001
    ONE_MINUS_CONSTANT_COLOR            = 0x8002
    CONSTANT_ALPHA                      = 0x8003
    ONE_MINUS_CONSTANT_ALPHA            = 0x8004
    FUNC_ADD                            = 0x8006
    FUNC_REVERSE_SUBTRACT               = 0x800B
    FUNC_SUBTRACT                       = 0x800A
    MIN                                 = 0x8007
    MAX                                 = 0x8008
    CONVOLUTION_1D                      = 0x8010
    CONVOLUTION_2D                      = 0x8011
    SEPARABLE_2D                        = 0x8012
    CONVOLUTION_BORDER_MODE             = 0x8013
    CONVOLUTION_FILTER_SCALE            = 0x8014
    CONVOLUTION_FILTER_BIAS             = 0x8015
    REDUCE                              = 0x8016
    CONVOLUTION_FORMAT                  = 0x8017
    CONVOLUTION_WIDTH                   = 0x8018
    CONVOLUTION_HEIGHT                  = 0x8019
    MAX_CONVOLUTION_WIDTH               = 0x801A
    MAX_CONVOLUTION_HEIGHT              = 0x801B
    POST_CONVOLUTION_RED_SCALE          = 0x801C
    POST_CONVOLUTION_GREEN_SCALE        = 0x801D
    POST_CONVOLUTION_BLUE_SCALE         = 0x801E
    POST_CONVOLUTION_ALPHA_SCALE        = 0x801F
    POST_CONVOLUTION_RED_BIAS           = 0x8020
    POST_CONVOLUTION_GREEN_BIAS         = 0x8021
    POST_CONVOLUTION_BLUE_BIAS          = 0x8022
    POST_CONVOLUTION_ALPHA_BIAS         = 0x8023
    HISTOGRAM                           = 0x8024
    PROXY_HISTOGRAM                     = 0x8025
    HISTOGRAM_WIDTH                     = 0x8026
    HISTOGRAM_FORMAT                    = 0x8027
    HISTOGRAM_RED_SIZE                  = 0x8028
    HISTOGRAM_GREEN_SIZE                = 0x8029
    HISTOGRAM_BLUE_SIZE                 = 0x802A
    HISTOGRAM_ALPHA_SIZE                = 0x802B
    HISTOGRAM_LUMINANCE_SIZE            = 0x802C
    HISTOGRAM_SINK                      = 0x802D
    MINMAX                              = 0x802E
    MINMAX_FORMAT                       = 0x802F
    MINMAX_SINK                         = 0x8030
    TABLE_TOO_LARGE                     = 0x8031
    COLOR_MATRIX                        = 0x80B1
    COLOR_MATRIX_STACK_DEPTH            = 0x80B2
    MAX_COLOR_MATRIX_STACK_DEPTH        = 0x80B3
    POST_COLOR_MATRIX_RED_SCALE         = 0x80B4
    POST_COLOR_MATRIX_GREEN_SCALE       = 0x80B5
    POST_COLOR_MATRIX_BLUE_SCALE        = 0x80B6
    POST_COLOR_MATRIX_ALPHA_SCALE       = 0x80B7
    POST_COLOR_MATRIX_RED_BIAS          = 0x80B8
    POST_COLOR_MATRIX_GREEN_BIAS        = 0x80B9
    POST_COLOR_MATRIX_BLUE_BIAS         = 0x80BA
    POST_COLOR_MATRIX_ALPHA_BIAS        = 0x80BB
    COLOR_TABLE                         = 0x80D0
    POST_CONVOLUTION_COLOR_TABLE        = 0x80D1
    POST_COLOR_MATRIX_COLOR_TABLE       = 0x80D2
    PROXY_COLOR_TABLE                   = 0x80D3
    PROXY_POST_CONVOLUTION_COLOR_TABLE  = 0x80D4
    PROXY_POST_COLOR_MATRIX_COLOR_TABLE = 0x80D5
    COLOR_TABLE_SCALE                   = 0x80D6
    COLOR_TABLE_BIAS                    = 0x80D7
    COLOR_TABLE_FORMAT                  = 0x80D8
    COLOR_TABLE_WIDTH                   = 0x80D9
    COLOR_TABLE_RED_SIZE                = 0x80DA
    COLOR_TABLE_GREEN_SIZE              = 0x80DB
    COLOR_TABLE_BLUE_SIZE               = 0x80DC
    COLOR_TABLE_ALPHA_SIZE              = 0x80DD
    COLOR_TABLE_LUMINANCE_SIZE          = 0x80DE
    COLOR_TABLE_INTENSITY_SIZE          = 0x80DF
    CONSTANT_BORDER                     = 0x8151
    REPLICATE_BORDER                    = 0x8153
    CONVOLUTION_BORDER_COLOR            = 0x8154
  end
  
  Functions = {
    def glBlendColor(red, green, blue, alpha) end => [ :void, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glBlendEquation(mode) end => [ :void, :GLenum ].freeze,
    def glColorTable(target, internalformat, width, format, type, table) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glColorTableParameterfv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glColorTableParameteriv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyColorTable(target, internalformat, x, y, width) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei ].freeze,
    def glGetColorTable(target, format, type, table) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetColorTableParameterfv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetColorTableParameteriv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glColorSubTable(target, start, count, format, type, data) end => [ :void, :GLenum, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyColorSubTable(target, start, x, y, width) end => [ :void, :GLenum, :GLsizei, :GLint, :GLint, :GLsizei ].freeze,
    def glConvolutionFilter1D(target, internalformat, width, format, type, image) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glConvolutionFilter2D(target, internalformat, width, height, format, type, image) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glConvolutionParameterf(target, pname, params) end => [ :void, :GLenum, :GLenum, :GLfloat ].freeze,
    def glConvolutionParameterfv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glConvolutionParameteri(target, pname, params) end => [ :void, :GLenum, :GLenum, :GLint ].freeze,
    def glConvolutionParameteriv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyConvolutionFilter1D(target, internalformat, x, y, width) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei ].freeze,
    def glCopyConvolutionFilter2D(target, internalformat, x, y, width, height) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glGetConvolutionFilter(target, format, type, image) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetConvolutionParameterfv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetConvolutionParameteriv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetSeparableFilter(target, format, type, row, column, span) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer, :pointer, :pointer ].freeze,
    def glSeparableFilter2D(target, internalformat, width, height, format, type, row, column) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer, :pointer ].freeze,
    def glGetHistogram(target, reset, format, type, values) end => [ :void, :GLenum, :GLboolean, :GLenum, :GLenum, :pointer ].freeze,
    def glGetHistogramParameterfv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetHistogramParameteriv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMinmax(target, reset, format, type, values) end => [ :void, :GLenum, :GLboolean, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMinmaxParameterfv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMinmaxParameteriv(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glHistogram(target, width, internalformat, sink) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLboolean ].freeze,
    def glMinmax(target, internalformat, sink) end => [ :void, :GLenum, :GLenum, :GLboolean ].freeze,
    def glResetHistogram(target) end => [ :void, :GLenum ].freeze,
    def glResetMinmax(target) end => [ :void, :GLenum ].freeze,
  }.freeze
end