module GL_ARB_multitexture
  module Constants
    TEXTURE0_ARB              = 0x84C0
    TEXTURE1_ARB              = 0x84C1
    TEXTURE2_ARB              = 0x84C2
    TEXTURE3_ARB              = 0x84C3
    TEXTURE4_ARB              = 0x84C4
    TEXTURE5_ARB              = 0x84C5
    TEXTURE6_ARB              = 0x84C6
    TEXTURE7_ARB              = 0x84C7
    TEXTURE8_ARB              = 0x84C8
    TEXTURE9_ARB              = 0x84C9
    TEXTURE10_ARB             = 0x84CA
    TEXTURE11_ARB             = 0x84CB
    TEXTURE12_ARB             = 0x84CC
    TEXTURE13_ARB             = 0x84CD
    TEXTURE14_ARB             = 0x84CE
    TEXTURE15_ARB             = 0x84CF
    TEXTURE16_ARB             = 0x84D0
    TEXTURE17_ARB             = 0x84D1
    TEXTURE18_ARB             = 0x84D2
    TEXTURE19_ARB             = 0x84D3
    TEXTURE20_ARB             = 0x84D4
    TEXTURE21_ARB             = 0x84D5
    TEXTURE22_ARB             = 0x84D6
    TEXTURE23_ARB             = 0x84D7
    TEXTURE24_ARB             = 0x84D8
    TEXTURE25_ARB             = 0x84D9
    TEXTURE26_ARB             = 0x84DA
    TEXTURE27_ARB             = 0x84DB
    TEXTURE28_ARB             = 0x84DC
    TEXTURE29_ARB             = 0x84DD
    TEXTURE30_ARB             = 0x84DE
    TEXTURE31_ARB             = 0x84DF
    ACTIVE_TEXTURE_ARB        = 0x84E0
    CLIENT_ACTIVE_TEXTURE_ARB = 0x84E1
    MAX_TEXTURE_UNITS_ARB     = 0x84E2
  end
  
  Functions = {
    def glActiveTextureARB(texture) end => [ :void, :GLenum ].freeze,
    def glClientActiveTextureARB(texture) end => [ :void, :GLenum ].freeze,
    def glMultiTexCoord1dARB(target, s) end => [ :void, :GLenum, :GLdouble ].freeze,
    def glMultiTexCoord1dvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord1fARB(target, s) end => [ :void, :GLenum, :GLfloat ].freeze,
    def glMultiTexCoord1fvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord1iARB(target, s) end => [ :void, :GLenum, :GLint ].freeze,
    def glMultiTexCoord1ivARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord1sARB(target, s) end => [ :void, :GLenum, :GLshort ].freeze,
    def glMultiTexCoord1svARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord2dARB(target, s, t) end => [ :void, :GLenum, :GLdouble, :GLdouble ].freeze,
    def glMultiTexCoord2dvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord2fARB(target, s, t) end => [ :void, :GLenum, :GLfloat, :GLfloat ].freeze,
    def glMultiTexCoord2fvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord2iARB(target, s, t) end => [ :void, :GLenum, :GLint, :GLint ].freeze,
    def glMultiTexCoord2ivARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord2sARB(target, s, t) end => [ :void, :GLenum, :GLshort, :GLshort ].freeze,
    def glMultiTexCoord2svARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord3dARB(target, s, t, r) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMultiTexCoord3dvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord3fARB(target, s, t, r) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMultiTexCoord3fvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord3iARB(target, s, t, r) end => [ :void, :GLenum, :GLint, :GLint, :GLint ].freeze,
    def glMultiTexCoord3ivARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord3sARB(target, s, t, r) end => [ :void, :GLenum, :GLshort, :GLshort, :GLshort ].freeze,
    def glMultiTexCoord3svARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord4dARB(target, s, t, r, q) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMultiTexCoord4dvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord4fARB(target, s, t, r, q) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMultiTexCoord4fvARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord4iARB(target, s, t, r, q) end => [ :void, :GLenum, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glMultiTexCoord4ivARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord4sARB(target, s, t, r, q) end => [ :void, :GLenum, :GLshort, :GLshort, :GLshort, :GLshort ].freeze,
    def glMultiTexCoord4svARB(target, v) end => [ :void, :GLenum, :pointer ].freeze,
  }.freeze
end