module GL_ARB_robustness
  module Constants
    NO_ERROR                           = 0
    CONTEXT_FLAG_ROBUST_ACCESS_BIT_ARB = 0x00000004
    LOSE_CONTEXT_ON_RESET_ARB          = 0x8252
    GUILTY_CONTEXT_RESET_ARB           = 0x8253
    INNOCENT_CONTEXT_RESET_ARB         = 0x8254
    UNKNOWN_CONTEXT_RESET_ARB          = 0x8255
    RESET_NOTIFICATION_STRATEGY_ARB    = 0x8256
    NO_RESET_NOTIFICATION_ARB          = 0x8261
  end
  
  Functions = {
    def glGetGraphicsResetStatusARB() end => [ :GLenum ].freeze,
    def glGetnTexImageARB(target, level, format, type, bufSize, img) end => [ :void, :GLenum, :GLint, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glReadnPixelsARB(x, y, width, height, format, type, bufSize, data) end => [ :void, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnCompressedTexImageARB(target, lod, bufSize, img) end => [ :void, :GLenum, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformfvARB(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformivARB(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformuivARB(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformdvARB(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnMapdvARB(target, query, bufSize, v) end => [ :void, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnMapfvARB(target, query, bufSize, v) end => [ :void, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnMapivARB(target, query, bufSize, v) end => [ :void, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnPixelMapfvARB(map, bufSize, values) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnPixelMapuivARB(map, bufSize, values) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnPixelMapusvARB(map, bufSize, values) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnPolygonStippleARB(bufSize, pattern) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGetnColorTableARB(target, format, type, bufSize, table) end => [ :void, :GLenum, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnConvolutionFilterARB(target, format, type, bufSize, image) end => [ :void, :GLenum, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnSeparableFilterARB(target, format, type, rowBufSize, row, columnBufSize, column, span) end => [ :void, :GLenum, :GLenum, :GLenum, :GLsizei, :pointer, :GLsizei, :pointer, :pointer ].freeze,
    def glGetnHistogramARB(target, reset, format, type, bufSize, values) end => [ :void, :GLenum, :GLboolean, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnMinmaxARB(target, reset, format, type, bufSize, values) end => [ :void, :GLenum, :GLboolean, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
  }.freeze
end