module GL_ARB_shader_objects
  module Constants
    PROGRAM_OBJECT_ARB                   = 0x8B40
    SHADER_OBJECT_ARB                    = 0x8B48
    OBJECT_TYPE_ARB                      = 0x8B4E
    OBJECT_SUBTYPE_ARB                   = 0x8B4F
    FLOAT_VEC2_ARB                       = 0x8B50
    FLOAT_VEC3_ARB                       = 0x8B51
    FLOAT_VEC4_ARB                       = 0x8B52
    INT_VEC2_ARB                         = 0x8B53
    INT_VEC3_ARB                         = 0x8B54
    INT_VEC4_ARB                         = 0x8B55
    BOOL_ARB                             = 0x8B56
    BOOL_VEC2_ARB                        = 0x8B57
    BOOL_VEC3_ARB                        = 0x8B58
    BOOL_VEC4_ARB                        = 0x8B59
    FLOAT_MAT2_ARB                       = 0x8B5A
    FLOAT_MAT3_ARB                       = 0x8B5B
    FLOAT_MAT4_ARB                       = 0x8B5C
    SAMPLER_1D_ARB                       = 0x8B5D
    SAMPLER_2D_ARB                       = 0x8B5E
    SAMPLER_3D_ARB                       = 0x8B5F
    SAMPLER_CUBE_ARB                     = 0x8B60
    SAMPLER_1D_SHADOW_ARB                = 0x8B61
    SAMPLER_2D_SHADOW_ARB                = 0x8B62
    SAMPLER_2D_RECT_ARB                  = 0x8B63
    SAMPLER_2D_RECT_SHADOW_ARB           = 0x8B64
    OBJECT_DELETE_STATUS_ARB             = 0x8B80
    OBJECT_COMPILE_STATUS_ARB            = 0x8B81
    OBJECT_LINK_STATUS_ARB               = 0x8B82
    OBJECT_VALIDATE_STATUS_ARB           = 0x8B83
    OBJECT_INFO_LOG_LENGTH_ARB           = 0x8B84
    OBJECT_ATTACHED_OBJECTS_ARB          = 0x8B85
    OBJECT_ACTIVE_UNIFORMS_ARB           = 0x8B86
    OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB = 0x8B87
    OBJECT_SHADER_SOURCE_LENGTH_ARB      = 0x8B88
  end
  
  Functions = {
    def glDeleteObjectARB(obj) end => [ :void, :GLhandleARB ].freeze,
    def glGetHandleARB(pname) end => [ :GLhandleARB, :GLenum ].freeze,
    def glDetachObjectARB(containerObj, attachedObj) end => [ :void, :GLhandleARB, :GLhandleARB ].freeze,
    def glCreateShaderObjectARB(shaderType) end => [ :GLhandleARB, :GLenum ].freeze,
    def glShaderSourceARB(shaderObj, count, string, length) end => [ :void, :GLhandleARB, :GLsizei, :pointer, :pointer ].freeze,
    def glCompileShaderARB(shaderObj) end => [ :void, :GLhandleARB ].freeze,
    def glCreateProgramObjectARB() end => [ :GLhandleARB ].freeze,
    def glAttachObjectARB(containerObj, obj) end => [ :void, :GLhandleARB, :GLhandleARB ].freeze,
    def glLinkProgramARB(programObj) end => [ :void, :GLhandleARB ].freeze,
    def glUseProgramObjectARB(programObj) end => [ :void, :GLhandleARB ].freeze,
    def glValidateProgramARB(programObj) end => [ :void, :GLhandleARB ].freeze,
    def glUniform1fARB(location, v0) end => [ :void, :GLint, :GLfloat ].freeze,
    def glUniform2fARB(location, v0, v1) end => [ :void, :GLint, :GLfloat, :GLfloat ].freeze,
    def glUniform3fARB(location, v0, v1, v2) end => [ :void, :GLint, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glUniform4fARB(location, v0, v1, v2, v3) end => [ :void, :GLint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glUniform1iARB(location, v0) end => [ :void, :GLint, :GLint ].freeze,
    def glUniform2iARB(location, v0, v1) end => [ :void, :GLint, :GLint, :GLint ].freeze,
    def glUniform3iARB(location, v0, v1, v2) end => [ :void, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glUniform4iARB(location, v0, v1, v2, v3) end => [ :void, :GLint, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glUniform1fvARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2fvARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3fvARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4fvARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform1ivARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2ivARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3ivARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4ivARB(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniformMatrix2fvARB(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix3fvARB(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix4fvARB(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glGetObjectParameterfvARB(obj, pname, params) end => [ :void, :GLhandleARB, :GLenum, :pointer ].freeze,
    def glGetObjectParameterivARB(obj, pname, params) end => [ :void, :GLhandleARB, :GLenum, :pointer ].freeze,
    def glGetInfoLogARB(obj, maxLength, length, infoLog) end => [ :void, :GLhandleARB, :GLsizei, :pointer, :pointer ].freeze,
    def glGetAttachedObjectsARB(containerObj, maxCount, count, obj) end => [ :void, :GLhandleARB, :GLsizei, :pointer, :pointer ].freeze,
    def glGetUniformLocationARB(programObj, name) end => [ :GLint, :GLhandleARB, :pointer ].freeze,
    def glGetActiveUniformARB(programObj, index, maxLength, length, size, type, name) end => [ :void, :GLhandleARB, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :pointer ].freeze,
    def glGetUniformfvARB(programObj, location, params) end => [ :void, :GLhandleARB, :GLint, :pointer ].freeze,
    def glGetUniformivARB(programObj, location, params) end => [ :void, :GLhandleARB, :GLint, :pointer ].freeze,
    def glGetShaderSourceARB(obj, maxLength, length, source) end => [ :void, :GLhandleARB, :GLsizei, :pointer, :pointer ].freeze,
  }.freeze
end