module GL_ARB_shader_subroutine
  module Constants
    ACTIVE_SUBROUTINES                   = 0x8DE5
    ACTIVE_SUBROUTINE_UNIFORMS           = 0x8DE6
    ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS  = 0x8E47
    ACTIVE_SUBROUTINE_MAX_LENGTH         = 0x8E48
    ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH = 0x8E49
    MAX_SUBROUTINES                      = 0x8DE7
    MAX_SUBROUTINE_UNIFORM_LOCATIONS     = 0x8DE8
    NUM_COMPATIBLE_SUBROUTINES           = 0x8E4A
    COMPATIBLE_SUBROUTINES               = 0x8E4B
    UNIFORM_SIZE                         = 0x8A38
    UNIFORM_NAME_LENGTH                  = 0x8A39
  end
  
  Functions = {
    def glGetSubroutineUniformLocation(program, shadertype, name) end => [ :GLint, :GLuint, :GLenum, :string ].freeze,
    def glGetSubroutineIndex(program, shadertype, name) end => [ :GLuint, :GLuint, :GLenum, :string ].freeze,
    def glGetActiveSubroutineUniformiv(program, shadertype, index, pname, values) end => [ :void, :GLuint, :GLenum, :GLuint, :GLenum, :pointer ].freeze,
    def glGetActiveSubroutineUniformName(program, shadertype, index, bufsize, length, name) end => [ :void, :GLuint, :GLenum, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glGetActiveSubroutineName(program, shadertype, index, bufsize, length, name) end => [ :void, :GLuint, :GLenum, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glUniformSubroutinesuiv(shadertype, count, indices) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetUniformSubroutineuiv(shadertype, location, params) end => [ :void, :GLenum, :GLint, :pointer ].freeze,
    def glGetProgramStageiv(program, shadertype, pname, values) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
  }.freeze
end