module GL_ARB_sync
  module Constants
    MAX_SERVER_WAIT_TIMEOUT    = 0x9111
    OBJECT_TYPE                = 0x9112
    SYNC_CONDITION             = 0x9113
    SYNC_STATUS                = 0x9114
    SYNC_FLAGS                 = 0x9115
    SYNC_FENCE                 = 0x9116
    SYNC_GPU_COMMANDS_COMPLETE = 0x9117
    UNSIGNALED                 = 0x9118
    SIGNALED                   = 0x9119
    ALREADY_SIGNALED           = 0x911A
    TIMEOUT_EXPIRED            = 0x911B
    CONDITION_SATISFIED        = 0x911C
    WAIT_FAILED                = 0x911D
    SYNC_FLUSH_COMMANDS_BIT    = 0x00000001
    TIMEOUT_IGNORED            = 0xFFFFFFFFFFFFFFFF
  end
  
  Functions = {
    def glFenceSync(condition, flags) end => [ :GLsync, :GLenum, :GLbitfield ].freeze,
    def glIsSync(sync) end => [ :GLboolean, :GLsync ].freeze,
    def glDeleteSync(sync) end => [ :void, :GLsync ].freeze,
    def glClientWaitSync(sync, flags, timeout) end => [ :GLenum, :GLsync, :GLbitfield, :GLuint64 ].freeze,
    def glWaitSync(sync, flags, timeout) end => [ :void, :GLsync, :GLbitfield, :GLuint64 ].freeze,
    def glGetInteger64v(pname, data) end => [ :void, :GLenum, :pointer ].freeze,
    def glGetSynciv(sync, pname, bufSize, length, values) end => [ :void, :GLsync, :GLenum, :GLsizei, :pointer, :pointer ].freeze,
  }.freeze
end