module GL_ARB_uniform_buffer_object
  module Constants
    UNIFORM_BUFFER                              = 0x8A11
    UNIFORM_BUFFER_BINDING                      = 0x8A28
    UNIFORM_BUFFER_START                        = 0x8A29
    UNIFORM_BUFFER_SIZE                         = 0x8A2A
    MAX_VERTEX_UNIFORM_BLOCKS                   = 0x8A2B
    MAX_GEOMETRY_UNIFORM_BLOCKS                 = 0x8A2C
    MAX_FRAGMENT_UNIFORM_BLOCKS                 = 0x8A2D
    MAX_COMBINED_UNIFORM_BLOCKS                 = 0x8A2E
    MAX_UNIFORM_BUFFER_BINDINGS                 = 0x8A2F
    MAX_UNIFORM_BLOCK_SIZE                      = 0x8A30
    MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS      = 0x8A31
    MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS    = 0x8A32
    MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS    = 0x8A33
    UNIFORM_BUFFER_OFFSET_ALIGNMENT             = 0x8A34
    ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH        = 0x8A35
    ACTIVE_UNIFORM_BLOCKS                       = 0x8A36
    UNIFORM_TYPE                                = 0x8A37
    UNIFORM_SIZE                                = 0x8A38
    UNIFORM_NAME_LENGTH                         = 0x8A39
    UNIFORM_BLOCK_INDEX                         = 0x8A3A
    UNIFORM_OFFSET                              = 0x8A3B
    UNIFORM_ARRAY_STRIDE                        = 0x8A3C
    UNIFORM_MATRIX_STRIDE                       = 0x8A3D
    UNIFORM_IS_ROW_MAJOR                        = 0x8A3E
    UNIFORM_BLOCK_BINDING                       = 0x8A3F
    UNIFORM_BLOCK_DATA_SIZE                     = 0x8A40
    UNIFORM_BLOCK_NAME_LENGTH                   = 0x8A41
    UNIFORM_BLOCK_ACTIVE_UNIFORMS               = 0x8A42
    UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES        = 0x8A43
    UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER   = 0x8A44
    UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER = 0x8A45
    UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER = 0x8A46
    INVALID_INDEX                               = 0xFFFFFFFF
  end
  
  Functions = {
    def glGetUniformIndices(program, uniformCount, uniformNames, uniformIndices) end => [ :void, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
    def glGetActiveUniformsiv(program, uniformCount, uniformIndices, pname, params) end => [ :void, :GLuint, :GLsizei, :pointer, :GLenum, :pointer ].freeze,
    def glGetActiveUniformName(program, uniformIndex, bufSize, length, uniformName) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glGetUniformBlockIndex(program, uniformBlockName) end => [ :GLuint, :GLuint, :string ].freeze,
    def glGetActiveUniformBlockiv(program, uniformBlockIndex, pname, params) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glGetActiveUniformBlockName(program, uniformBlockIndex, bufSize, length, uniformBlockName) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glUniformBlockBinding(program, uniformBlockIndex, uniformBlockBinding) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glBindBufferRange(target, index, buffer, offset, size) end => [ :void, :GLenum, :GLuint, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glBindBufferBase(target, index, buffer) end => [ :void, :GLenum, :GLuint, :GLuint ].freeze,
    def glGetIntegeri_v(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
  }.freeze
end