module GL_ARB_vertex_attrib_64bit
  module Constants
    RGB32I        = 0x8D83
    DOUBLE_VEC2   = 0x8FFC
    DOUBLE_VEC3   = 0x8FFD
    DOUBLE_VEC4   = 0x8FFE
    DOUBLE_MAT2   = 0x8F46
    DOUBLE_MAT3   = 0x8F47
    DOUBLE_MAT4   = 0x8F48
    DOUBLE_MAT2x3 = 0x8F49
    DOUBLE_MAT2x4 = 0x8F4A
    DOUBLE_MAT3x2 = 0x8F4B
    DOUBLE_MAT3x4 = 0x8F4C
    DOUBLE_MAT4x2 = 0x8F4D
    DOUBLE_MAT4x3 = 0x8F4E
  end
  
  Functions = {
    def glVertexAttribL1d(index, x) end => [ :void, :GLuint, :GLdouble ].freeze,
    def glVertexAttribL2d(index, x, y) end => [ :void, :GLuint, :GLdouble, :GLdouble ].freeze,
    def glVertexAttribL3d(index, x, y, z) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttribL4d(index, x, y, z, w) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttribL1dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL2dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL3dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL4dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribLPointer(index, size, type, stride, pointer) end => [ :void, :GLuint, :GLint, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetVertexAttribLdv(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end