module GL_ARB_vertex_attrib_binding
  module Constants
    VERTEX_ATTRIB_BINDING             = 0x82D4
    VERTEX_ATTRIB_RELATIVE_OFFSET     = 0x82D5
    VERTEX_BINDING_DIVISOR            = 0x82D6
    VERTEX_BINDING_OFFSET             = 0x82D7
    VERTEX_BINDING_STRIDE             = 0x82D8
    MAX_VERTEX_ATTRIB_RELATIVE_OFFSET = 0x82D9
    MAX_VERTEX_ATTRIB_BINDINGS        = 0x82DA
  end
  
  Functions = {
    def glBindVertexBuffer(bindingindex, buffer, offset, stride) end => [ :void, :GLuint, :GLuint, :GLintptr, :GLsizei ].freeze,
    def glVertexAttribFormat(attribindex, size, type, normalized, relativeoffset) end => [ :void, :GLuint, :GLint, :GLenum, :GLboolean, :GLuint ].freeze,
    def glVertexAttribIFormat(attribindex, size, type, relativeoffset) end => [ :void, :GLuint, :GLint, :GLenum, :GLuint ].freeze,
    def glVertexAttribLFormat(attribindex, size, type, relativeoffset) end => [ :void, :GLuint, :GLint, :GLenum, :GLuint ].freeze,
    def glVertexAttribBinding(attribindex, bindingindex) end => [ :void, :GLuint, :GLuint ].freeze,
    def glVertexBindingDivisor(bindingindex, divisor) end => [ :void, :GLuint, :GLuint ].freeze,
  }.freeze
end