module GL_ARB_vertex_buffer_object
  module Constants
    BUFFER_SIZE_ARB                          = 0x8764
    BUFFER_USAGE_ARB                         = 0x8765
    ARRAY_BUFFER_ARB                         = 0x8892
    ELEMENT_ARRAY_BUFFER_ARB                 = 0x8893
    ARRAY_BUFFER_BINDING_ARB                 = 0x8894
    ELEMENT_ARRAY_BUFFER_BINDING_ARB         = 0x8895
    VERTEX_ARRAY_BUFFER_BINDING_ARB          = 0x8896
    NORMAL_ARRAY_BUFFER_BINDING_ARB          = 0x8897
    COLOR_ARRAY_BUFFER_BINDING_ARB           = 0x8898
    INDEX_ARRAY_BUFFER_BINDING_ARB           = 0x8899
    TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB   = 0x889A
    EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB       = 0x889B
    SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB = 0x889C
    FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB  = 0x889D
    WEIGHT_ARRAY_BUFFER_BINDING_ARB          = 0x889E
    VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB   = 0x889F
    READ_ONLY_ARB                            = 0x88B8
    WRITE_ONLY_ARB                           = 0x88B9
    READ_WRITE_ARB                           = 0x88BA
    BUFFER_ACCESS_ARB                        = 0x88BB
    BUFFER_MAPPED_ARB                        = 0x88BC
    BUFFER_MAP_POINTER_ARB                   = 0x88BD
    STREAM_DRAW_ARB                          = 0x88E0
    STREAM_READ_ARB                          = 0x88E1
    STREAM_COPY_ARB                          = 0x88E2
    STATIC_DRAW_ARB                          = 0x88E4
    STATIC_READ_ARB                          = 0x88E5
    STATIC_COPY_ARB                          = 0x88E6
    DYNAMIC_DRAW_ARB                         = 0x88E8
    DYNAMIC_READ_ARB                         = 0x88E9
    DYNAMIC_COPY_ARB                         = 0x88EA
  end
  
  Functions = {
    def glBindBufferARB(target, buffer) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteBuffersARB(n, buffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGenBuffersARB(n, buffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glIsBufferARB(buffer) end => [ :GLboolean, :GLuint ].freeze,
    def glBufferDataARB(target, size, data, usage) end => [ :void, :GLenum, :GLsizeiptrARB, :pointer, :GLenum ].freeze,
    def glBufferSubDataARB(target, offset, size, data) end => [ :void, :GLenum, :GLintptrARB, :GLsizeiptrARB, :pointer ].freeze,
    def glGetBufferSubDataARB(target, offset, size, data) end => [ :void, :GLenum, :GLintptrARB, :GLsizeiptrARB, :pointer ].freeze,
    def glMapBufferARB(target, access) end => [ :pointer, :GLenum, :GLenum ].freeze,
    def glUnmapBufferARB(target) end => [ :GLboolean, :GLenum ].freeze,
    def glGetBufferParameterivARB(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetBufferPointervARB(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
  }.freeze
end