module GL_ARB_vertex_program
  module Constants
    COLOR_SUM_ARB                            = 0x8458
    VERTEX_PROGRAM_ARB                       = 0x8620
    VERTEX_ATTRIB_ARRAY_ENABLED_ARB          = 0x8622
    VERTEX_ATTRIB_ARRAY_SIZE_ARB             = 0x8623
    VERTEX_ATTRIB_ARRAY_STRIDE_ARB           = 0x8624
    VERTEX_ATTRIB_ARRAY_TYPE_ARB             = 0x8625
    CURRENT_VERTEX_ATTRIB_ARB                = 0x8626
    PROGRAM_LENGTH_ARB                       = 0x8627
    PROGRAM_STRING_ARB                       = 0x8628
    MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB       = 0x862E
    MAX_PROGRAM_MATRICES_ARB                 = 0x862F
    CURRENT_MATRIX_STACK_DEPTH_ARB           = 0x8640
    CURRENT_MATRIX_ARB                       = 0x8641
    VERTEX_PROGRAM_POINT_SIZE_ARB            = 0x8642
    VERTEX_PROGRAM_TWO_SIDE_ARB              = 0x8643
    VERTEX_ATTRIB_ARRAY_POINTER_ARB          = 0x8645
    PROGRAM_ERROR_POSITION_ARB               = 0x864B
    PROGRAM_BINDING_ARB                      = 0x8677
    MAX_VERTEX_ATTRIBS_ARB                   = 0x8869
    VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB       = 0x886A
    PROGRAM_ERROR_STRING_ARB                 = 0x8874
    PROGRAM_FORMAT_ASCII_ARB                 = 0x8875
    PROGRAM_FORMAT_ARB                       = 0x8876
    PROGRAM_INSTRUCTIONS_ARB                 = 0x88A0
    MAX_PROGRAM_INSTRUCTIONS_ARB             = 0x88A1
    PROGRAM_NATIVE_INSTRUCTIONS_ARB          = 0x88A2
    MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB      = 0x88A3
    PROGRAM_TEMPORARIES_ARB                  = 0x88A4
    MAX_PROGRAM_TEMPORARIES_ARB              = 0x88A5
    PROGRAM_NATIVE_TEMPORARIES_ARB           = 0x88A6
    MAX_PROGRAM_NATIVE_TEMPORARIES_ARB       = 0x88A7
    PROGRAM_PARAMETERS_ARB                   = 0x88A8
    MAX_PROGRAM_PARAMETERS_ARB               = 0x88A9
    PROGRAM_NATIVE_PARAMETERS_ARB            = 0x88AA
    MAX_PROGRAM_NATIVE_PARAMETERS_ARB        = 0x88AB
    PROGRAM_ATTRIBS_ARB                      = 0x88AC
    MAX_PROGRAM_ATTRIBS_ARB                  = 0x88AD
    PROGRAM_NATIVE_ATTRIBS_ARB               = 0x88AE
    MAX_PROGRAM_NATIVE_ATTRIBS_ARB           = 0x88AF
    PROGRAM_ADDRESS_REGISTERS_ARB            = 0x88B0
    MAX_PROGRAM_ADDRESS_REGISTERS_ARB        = 0x88B1
    PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB     = 0x88B2
    MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB = 0x88B3
    MAX_PROGRAM_LOCAL_PARAMETERS_ARB         = 0x88B4
    MAX_PROGRAM_ENV_PARAMETERS_ARB           = 0x88B5
    PROGRAM_UNDER_NATIVE_LIMITS_ARB          = 0x88B6
    TRANSPOSE_CURRENT_MATRIX_ARB             = 0x88B7
    MATRIX0_ARB                              = 0x88C0
    MATRIX1_ARB                              = 0x88C1
    MATRIX2_ARB                              = 0x88C2
    MATRIX3_ARB                              = 0x88C3
    MATRIX4_ARB                              = 0x88C4
    MATRIX5_ARB                              = 0x88C5
    MATRIX6_ARB                              = 0x88C6
    MATRIX7_ARB                              = 0x88C7
    MATRIX8_ARB                              = 0x88C8
    MATRIX9_ARB                              = 0x88C9
    MATRIX10_ARB                             = 0x88CA
    MATRIX11_ARB                             = 0x88CB
    MATRIX12_ARB                             = 0x88CC
    MATRIX13_ARB                             = 0x88CD
    MATRIX14_ARB                             = 0x88CE
    MATRIX15_ARB                             = 0x88CF
    MATRIX16_ARB                             = 0x88D0
    MATRIX17_ARB                             = 0x88D1
    MATRIX18_ARB                             = 0x88D2
    MATRIX19_ARB                             = 0x88D3
    MATRIX20_ARB                             = 0x88D4
    MATRIX21_ARB                             = 0x88D5
    MATRIX22_ARB                             = 0x88D6
    MATRIX23_ARB                             = 0x88D7
    MATRIX24_ARB                             = 0x88D8
    MATRIX25_ARB                             = 0x88D9
    MATRIX26_ARB                             = 0x88DA
    MATRIX27_ARB                             = 0x88DB
    MATRIX28_ARB                             = 0x88DC
    MATRIX29_ARB                             = 0x88DD
    MATRIX30_ARB                             = 0x88DE
    MATRIX31_ARB                             = 0x88DF
  end
  
  Functions = {
    def glVertexAttrib1dARB(index, x) end => [ :void, :GLuint, :GLdouble ].freeze,
    def glVertexAttrib1dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1fARB(index, x) end => [ :void, :GLuint, :GLfloat ].freeze,
    def glVertexAttrib1fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1sARB(index, x) end => [ :void, :GLuint, :GLshort ].freeze,
    def glVertexAttrib1svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2dARB(index, x, y) end => [ :void, :GLuint, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib2dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2fARB(index, x, y) end => [ :void, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib2fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2sARB(index, x, y) end => [ :void, :GLuint, :GLshort, :GLshort ].freeze,
    def glVertexAttrib2svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3dARB(index, x, y, z) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib3dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3fARB(index, x, y, z) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib3fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3sARB(index, x, y, z) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib3svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NbvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NsvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NubARB(index, x, y, z, w) end => [ :void, :GLuint, :GLubyte, :GLubyte, :GLubyte, :GLubyte ].freeze,
    def glVertexAttrib4NubvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NuivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NusvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4bvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4dARB(index, x, y, z, w) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib4dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4fARB(index, x, y, z, w) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib4fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4ivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4sARB(index, x, y, z, w) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib4svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4ubvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4uivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4usvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribPointerARB(index, size, type, normalized, stride, pointer) end => [ :void, :GLuint, :GLint, :GLenum, :GLboolean, :GLsizei, :pointer ].freeze,
    def glEnableVertexAttribArrayARB(index) end => [ :void, :GLuint ].freeze,
    def glDisableVertexAttribArrayARB(index) end => [ :void, :GLuint ].freeze,
    def glProgramStringARB(target, format, len, string) end => [ :void, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glBindProgramARB(target, program) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteProgramsARB(n, programs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGenProgramsARB(n, programs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glProgramEnvParameter4dARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramEnvParameter4dvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramEnvParameter4fARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramEnvParameter4fvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramLocalParameter4dARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramLocalParameter4dvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramLocalParameter4fARB(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramLocalParameter4fvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramEnvParameterdvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramEnvParameterfvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramLocalParameterdvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramLocalParameterfvARB(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramivARB(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetProgramStringARB(target, pname, string) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetVertexAttribdvARB(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribfvARB(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribivARB(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribPointervARB(index, pname, pointer) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glIsProgramARB(program) end => [ :GLboolean, :GLuint ].freeze,
  }.freeze
end