module GL_ARB_vertex_shader
  module Constants
    VERTEX_SHADER_ARB                      = 0x8B31
    MAX_VERTEX_UNIFORM_COMPONENTS_ARB      = 0x8B4A
    MAX_VARYING_FLOATS_ARB                 = 0x8B4B
    MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB     = 0x8B4C
    MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB   = 0x8B4D
    OBJECT_ACTIVE_ATTRIBUTES_ARB           = 0x8B89
    OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB = 0x8B8A
    MAX_VERTEX_ATTRIBS_ARB                 = 0x8869
    MAX_TEXTURE_IMAGE_UNITS_ARB            = 0x8872
    MAX_TEXTURE_COORDS_ARB                 = 0x8871
    VERTEX_PROGRAM_POINT_SIZE_ARB          = 0x8642
    VERTEX_PROGRAM_TWO_SIDE_ARB            = 0x8643
    VERTEX_ATTRIB_ARRAY_ENABLED_ARB        = 0x8622
    VERTEX_ATTRIB_ARRAY_SIZE_ARB           = 0x8623
    VERTEX_ATTRIB_ARRAY_STRIDE_ARB         = 0x8624
    VERTEX_ATTRIB_ARRAY_TYPE_ARB           = 0x8625
    VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB     = 0x886A
    CURRENT_VERTEX_ATTRIB_ARB              = 0x8626
    VERTEX_ATTRIB_ARRAY_POINTER_ARB        = 0x8645
    FLOAT                                  = 0x1406
    FLOAT_VEC2_ARB                         = 0x8B50
    FLOAT_VEC3_ARB                         = 0x8B51
    FLOAT_VEC4_ARB                         = 0x8B52
    FLOAT_MAT2_ARB                         = 0x8B5A
    FLOAT_MAT3_ARB                         = 0x8B5B
    FLOAT_MAT4_ARB                         = 0x8B5C
  end
  
  Functions = {
    def glVertexAttrib1fARB(index, x) end => [ :void, :GLuint, :GLfloat ].freeze,
    def glVertexAttrib1sARB(index, x) end => [ :void, :GLuint, :GLshort ].freeze,
    def glVertexAttrib1dARB(index, x) end => [ :void, :GLuint, :GLdouble ].freeze,
    def glVertexAttrib2fARB(index, x, y) end => [ :void, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib2sARB(index, x, y) end => [ :void, :GLuint, :GLshort, :GLshort ].freeze,
    def glVertexAttrib2dARB(index, x, y) end => [ :void, :GLuint, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib3fARB(index, x, y, z) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib3sARB(index, x, y, z) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib3dARB(index, x, y, z) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib4fARB(index, x, y, z, w) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib4sARB(index, x, y, z, w) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib4dARB(index, x, y, z, w) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib4NubARB(index, x, y, z, w) end => [ :void, :GLuint, :GLubyte, :GLubyte, :GLubyte, :GLubyte ].freeze,
    def glVertexAttrib1fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4fvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4svARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4dvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4ivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4bvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4ubvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4usvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4uivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NbvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NsvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NubvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NusvARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4NuivARB(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribPointerARB(index, size, type, normalized, stride, pointer) end => [ :void, :GLuint, :GLint, :GLenum, :GLboolean, :GLsizei, :pointer ].freeze,
    def glEnableVertexAttribArrayARB(index) end => [ :void, :GLuint ].freeze,
    def glDisableVertexAttribArrayARB(index) end => [ :void, :GLuint ].freeze,
    def glBindAttribLocationARB(programObj, index, name) end => [ :void, :GLhandleARB, :GLuint, :pointer ].freeze,
    def glGetActiveAttribARB(programObj, index, maxLength, length, size, type, name) end => [ :void, :GLhandleARB, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :pointer ].freeze,
    def glGetAttribLocationARB(programObj, name) end => [ :GLint, :GLhandleARB, :pointer ].freeze,
    def glGetVertexAttribdvARB(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribfvARB(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribivARB(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribPointervARB(index, pname, pointer) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end