module GL_ARB_viewport_array
  module Constants
    SCISSOR_BOX                     = 0x0C10
    VIEWPORT                        = 0x0BA2
    DEPTH_RANGE                     = 0x0B70
    SCISSOR_TEST                    = 0x0C11
    MAX_VIEWPORTS                   = 0x825B
    VIEWPORT_SUBPIXEL_BITS          = 0x825C
    VIEWPORT_BOUNDS_RANGE           = 0x825D
    LAYER_PROVOKING_VERTEX          = 0x825E
    VIEWPORT_INDEX_PROVOKING_VERTEX = 0x825F
    UNDEFINED_VERTEX                = 0x8260
    FIRST_VERTEX_CONVENTION         = 0x8E4D
    LAST_VERTEX_CONVENTION          = 0x8E4E
    PROVOKING_VERTEX                = 0x8E4F
  end
  
  Functions = {
    def glViewportArrayv(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glViewportIndexedf(index, x, y, w, h) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glViewportIndexedfv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glScissorArrayv(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glScissorIndexed(index, left, bottom, width, height) end => [ :void, :GLuint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glScissorIndexedv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glDepthRangeArrayv(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glDepthRangeIndexed(index, n, f) end => [ :void, :GLuint, :GLdouble, :GLdouble ].freeze,
    def glGetFloati_v(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetDoublei_v(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
  }.freeze
end