module GL_ATI_fragment_shader
  module Constants
    FRAGMENT_SHADER_ATI                   = 0x8920
    REG_0_ATI                             = 0x8921
    REG_1_ATI                             = 0x8922
    REG_2_ATI                             = 0x8923
    REG_3_ATI                             = 0x8924
    REG_4_ATI                             = 0x8925
    REG_5_ATI                             = 0x8926
    REG_6_ATI                             = 0x8927
    REG_7_ATI                             = 0x8928
    REG_8_ATI                             = 0x8929
    REG_9_ATI                             = 0x892A
    REG_10_ATI                            = 0x892B
    REG_11_ATI                            = 0x892C
    REG_12_ATI                            = 0x892D
    REG_13_ATI                            = 0x892E
    REG_14_ATI                            = 0x892F
    REG_15_ATI                            = 0x8930
    REG_16_ATI                            = 0x8931
    REG_17_ATI                            = 0x8932
    REG_18_ATI                            = 0x8933
    REG_19_ATI                            = 0x8934
    REG_20_ATI                            = 0x8935
    REG_21_ATI                            = 0x8936
    REG_22_ATI                            = 0x8937
    REG_23_ATI                            = 0x8938
    REG_24_ATI                            = 0x8939
    REG_25_ATI                            = 0x893A
    REG_26_ATI                            = 0x893B
    REG_27_ATI                            = 0x893C
    REG_28_ATI                            = 0x893D
    REG_29_ATI                            = 0x893E
    REG_30_ATI                            = 0x893F
    REG_31_ATI                            = 0x8940
    CON_0_ATI                             = 0x8941
    CON_1_ATI                             = 0x8942
    CON_2_ATI                             = 0x8943
    CON_3_ATI                             = 0x8944
    CON_4_ATI                             = 0x8945
    CON_5_ATI                             = 0x8946
    CON_6_ATI                             = 0x8947
    CON_7_ATI                             = 0x8948
    CON_8_ATI                             = 0x8949
    CON_9_ATI                             = 0x894A
    CON_10_ATI                            = 0x894B
    CON_11_ATI                            = 0x894C
    CON_12_ATI                            = 0x894D
    CON_13_ATI                            = 0x894E
    CON_14_ATI                            = 0x894F
    CON_15_ATI                            = 0x8950
    CON_16_ATI                            = 0x8951
    CON_17_ATI                            = 0x8952
    CON_18_ATI                            = 0x8953
    CON_19_ATI                            = 0x8954
    CON_20_ATI                            = 0x8955
    CON_21_ATI                            = 0x8956
    CON_22_ATI                            = 0x8957
    CON_23_ATI                            = 0x8958
    CON_24_ATI                            = 0x8959
    CON_25_ATI                            = 0x895A
    CON_26_ATI                            = 0x895B
    CON_27_ATI                            = 0x895C
    CON_28_ATI                            = 0x895D
    CON_29_ATI                            = 0x895E
    CON_30_ATI                            = 0x895F
    CON_31_ATI                            = 0x8960
    MOV_ATI                               = 0x8961
    ADD_ATI                               = 0x8963
    MUL_ATI                               = 0x8964
    SUB_ATI                               = 0x8965
    DOT3_ATI                              = 0x8966
    DOT4_ATI                              = 0x8967
    MAD_ATI                               = 0x8968
    LERP_ATI                              = 0x8969
    CND_ATI                               = 0x896A
    CND0_ATI                              = 0x896B
    DOT2_ADD_ATI                          = 0x896C
    SECONDARY_INTERPOLATOR_ATI            = 0x896D
    NUM_FRAGMENT_REGISTERS_ATI            = 0x896E
    NUM_FRAGMENT_CONSTANTS_ATI            = 0x896F
    NUM_PASSES_ATI                        = 0x8970
    NUM_INSTRUCTIONS_PER_PASS_ATI         = 0x8971
    NUM_INSTRUCTIONS_TOTAL_ATI            = 0x8972
    NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI = 0x8973
    NUM_LOOPBACK_COMPONENTS_ATI           = 0x8974
    COLOR_ALPHA_PAIRING_ATI               = 0x8975
    SWIZZLE_STR_ATI                       = 0x8976
    SWIZZLE_STQ_ATI                       = 0x8977
    SWIZZLE_STR_DR_ATI                    = 0x8978
    SWIZZLE_STQ_DQ_ATI                    = 0x8979
    SWIZZLE_STRQ_ATI                      = 0x897A
    SWIZZLE_STRQ_DQ_ATI                   = 0x897B
    RED_BIT_ATI                           = 0x00000001
    GREEN_BIT_ATI                         = 0x00000002
    BLUE_BIT_ATI                          = 0x00000004
    N2X_BIT_ATI                           = 0x00000001
    N4X_BIT_ATI                           = 0x00000002
    N8X_BIT_ATI                           = 0x00000004
    HALF_BIT_ATI                          = 0x00000008
    QUARTER_BIT_ATI                       = 0x00000010
    EIGHTH_BIT_ATI                        = 0x00000020
    SATURATE_BIT_ATI                      = 0x00000040
    COMP_BIT_ATI                          = 0x00000002
    NEGATE_BIT_ATI                        = 0x00000004
    BIAS_BIT_ATI                          = 0x00000008
  end
  
  Functions = {
    def glGenFragmentShadersATI(range) end => [ :GLuint, :GLuint ].freeze,
    def glBindFragmentShaderATI(id) end => [ :void, :GLuint ].freeze,
    def glDeleteFragmentShaderATI(id) end => [ :void, :GLuint ].freeze,
    def glBeginFragmentShaderATI() end => [ :void ].freeze,
    def glEndFragmentShaderATI() end => [ :void ].freeze,
    def glPassTexCoordATI(dst, coord, swizzle) end => [ :void, :GLuint, :GLuint, :GLenum ].freeze,
    def glSampleMapATI(dst, interp, swizzle) end => [ :void, :GLuint, :GLuint, :GLenum ].freeze,
    def glColorFragmentOp1ATI(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glColorFragmentOp2ATI(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glColorFragmentOp3ATI(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glAlphaFragmentOp1ATI(op, dst, dstMod, arg1, arg1Rep, arg1Mod) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glAlphaFragmentOp2ATI(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glAlphaFragmentOp3ATI(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glSetFragmentShaderConstantATI(dst, value) end => [ :void, :GLuint, :pointer ].freeze,
  }.freeze
end