module GL_ATI_vertex_array_object
  module Constants
    STATIC_ATI              = 0x8760
    DYNAMIC_ATI             = 0x8761
    PRESERVE_ATI            = 0x8762
    DISCARD_ATI             = 0x8763
    OBJECT_BUFFER_SIZE_ATI  = 0x8764
    OBJECT_BUFFER_USAGE_ATI = 0x8765
    ARRAY_OBJECT_BUFFER_ATI = 0x8766
    ARRAY_OBJECT_OFFSET_ATI = 0x8767
  end
  
  Functions = {
    def glNewObjectBufferATI(size, pointer, usage) end => [ :GLuint, :GLsizei, :pointer, :GLenum ].freeze,
    def glIsObjectBufferATI(buffer) end => [ :GLboolean, :GLuint ].freeze,
    def glUpdateObjectBufferATI(buffer, offset, size, pointer, preserve) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :GLenum ].freeze,
    def glGetObjectBufferfvATI(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetObjectBufferivATI(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glFreeObjectBufferATI(buffer) end => [ :void, :GLuint ].freeze,
    def glArrayObjectATI(array, size, type, stride, buffer, offset) end => [ :void, :GLenum, :GLint, :GLenum, :GLsizei, :GLuint, :GLuint ].freeze,
    def glGetArrayObjectfvATI(array, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetArrayObjectivATI(array, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glVariantArrayObjectATI(id, type, stride, buffer, offset) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLuint, :GLuint ].freeze,
    def glGetVariantArrayObjectfvATI(id, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVariantArrayObjectivATI(id, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end