module GL_ATI_vertex_streams
  module Constants
    MAX_VERTEX_STREAMS_ATI = 0x876B
    VERTEX_STREAM0_ATI     = 0x876C
    VERTEX_STREAM1_ATI     = 0x876D
    VERTEX_STREAM2_ATI     = 0x876E
    VERTEX_STREAM3_ATI     = 0x876F
    VERTEX_STREAM4_ATI     = 0x8770
    VERTEX_STREAM5_ATI     = 0x8771
    VERTEX_STREAM6_ATI     = 0x8772
    VERTEX_STREAM7_ATI     = 0x8773
    VERTEX_SOURCE_ATI      = 0x8774
  end
  
  Functions = {
    def glVertexStream1sATI(stream, x) end => [ :void, :GLenum, :GLshort ].freeze,
    def glVertexStream1svATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream1iATI(stream, x) end => [ :void, :GLenum, :GLint ].freeze,
    def glVertexStream1ivATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream1fATI(stream, x) end => [ :void, :GLenum, :GLfloat ].freeze,
    def glVertexStream1fvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream1dATI(stream, x) end => [ :void, :GLenum, :GLdouble ].freeze,
    def glVertexStream1dvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream2sATI(stream, x, y) end => [ :void, :GLenum, :GLshort, :GLshort ].freeze,
    def glVertexStream2svATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream2iATI(stream, x, y) end => [ :void, :GLenum, :GLint, :GLint ].freeze,
    def glVertexStream2ivATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream2fATI(stream, x, y) end => [ :void, :GLenum, :GLfloat, :GLfloat ].freeze,
    def glVertexStream2fvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream2dATI(stream, x, y) end => [ :void, :GLenum, :GLdouble, :GLdouble ].freeze,
    def glVertexStream2dvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream3sATI(stream, x, y, z) end => [ :void, :GLenum, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexStream3svATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream3iATI(stream, x, y, z) end => [ :void, :GLenum, :GLint, :GLint, :GLint ].freeze,
    def glVertexStream3ivATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream3fATI(stream, x, y, z) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexStream3fvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream3dATI(stream, x, y, z) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexStream3dvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream4sATI(stream, x, y, z, w) end => [ :void, :GLenum, :GLshort, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexStream4svATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream4iATI(stream, x, y, z, w) end => [ :void, :GLenum, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glVertexStream4ivATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream4fATI(stream, x, y, z, w) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexStream4fvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glVertexStream4dATI(stream, x, y, z, w) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexStream4dvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glNormalStream3bATI(stream, nx, ny, nz) end => [ :void, :GLenum, :GLbyte, :GLbyte, :GLbyte ].freeze,
    def glNormalStream3bvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glNormalStream3sATI(stream, nx, ny, nz) end => [ :void, :GLenum, :GLshort, :GLshort, :GLshort ].freeze,
    def glNormalStream3svATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glNormalStream3iATI(stream, nx, ny, nz) end => [ :void, :GLenum, :GLint, :GLint, :GLint ].freeze,
    def glNormalStream3ivATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glNormalStream3fATI(stream, nx, ny, nz) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glNormalStream3fvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glNormalStream3dATI(stream, nx, ny, nz) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glNormalStream3dvATI(stream, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glClientActiveVertexStreamATI(stream) end => [ :void, :GLenum ].freeze,
    def glVertexBlendEnviATI(pname, param) end => [ :void, :GLenum, :GLint ].freeze,
    def glVertexBlendEnvfATI(pname, param) end => [ :void, :GLenum, :GLfloat ].freeze,
  }.freeze
end