module GL_EXT_convolution
  module Constants
    CONVOLUTION_1D_EXT               = 0x8010
    CONVOLUTION_2D_EXT               = 0x8011
    SEPARABLE_2D_EXT                 = 0x8012
    CONVOLUTION_BORDER_MODE_EXT      = 0x8013
    CONVOLUTION_FILTER_SCALE_EXT     = 0x8014
    CONVOLUTION_FILTER_BIAS_EXT      = 0x8015
    REDUCE_EXT                       = 0x8016
    CONVOLUTION_FORMAT_EXT           = 0x8017
    CONVOLUTION_WIDTH_EXT            = 0x8018
    CONVOLUTION_HEIGHT_EXT           = 0x8019
    MAX_CONVOLUTION_WIDTH_EXT        = 0x801A
    MAX_CONVOLUTION_HEIGHT_EXT       = 0x801B
    POST_CONVOLUTION_RED_SCALE_EXT   = 0x801C
    POST_CONVOLUTION_GREEN_SCALE_EXT = 0x801D
    POST_CONVOLUTION_BLUE_SCALE_EXT  = 0x801E
    POST_CONVOLUTION_ALPHA_SCALE_EXT = 0x801F
    POST_CONVOLUTION_RED_BIAS_EXT    = 0x8020
    POST_CONVOLUTION_GREEN_BIAS_EXT  = 0x8021
    POST_CONVOLUTION_BLUE_BIAS_EXT   = 0x8022
    POST_CONVOLUTION_ALPHA_BIAS_EXT  = 0x8023
  end
  
  Functions = {
    def glConvolutionFilter1DEXT(target, internalformat, width, format, type, image) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glConvolutionFilter2DEXT(target, internalformat, width, height, format, type, image) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glConvolutionParameterfEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :GLfloat ].freeze,
    def glConvolutionParameterfvEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glConvolutionParameteriEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :GLint ].freeze,
    def glConvolutionParameterivEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyConvolutionFilter1DEXT(target, internalformat, x, y, width) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei ].freeze,
    def glCopyConvolutionFilter2DEXT(target, internalformat, x, y, width, height) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glGetConvolutionFilterEXT(target, format, type, image) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetConvolutionParameterfvEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetConvolutionParameterivEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetSeparableFilterEXT(target, format, type, row, column, span) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer, :pointer, :pointer ].freeze,
    def glSeparableFilter2DEXT(target, internalformat, width, height, format, type, row, column) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer, :pointer ].freeze,
  }.freeze
end