module GL_EXT_coordinate_frame
  module Constants
    TANGENT_ARRAY_EXT          = 0x8439
    BINORMAL_ARRAY_EXT         = 0x843A
    CURRENT_TANGENT_EXT        = 0x843B
    CURRENT_BINORMAL_EXT       = 0x843C
    TANGENT_ARRAY_TYPE_EXT     = 0x843E
    TANGENT_ARRAY_STRIDE_EXT   = 0x843F
    BINORMAL_ARRAY_TYPE_EXT    = 0x8440
    BINORMAL_ARRAY_STRIDE_EXT  = 0x8441
    TANGENT_ARRAY_POINTER_EXT  = 0x8442
    BINORMAL_ARRAY_POINTER_EXT = 0x8443
    MAP1_TANGENT_EXT           = 0x8444
    MAP2_TANGENT_EXT           = 0x8445
    MAP1_BINORMAL_EXT          = 0x8446
    MAP2_BINORMAL_EXT          = 0x8447
  end
  
  Functions = {
    def glTangent3bEXT(tx, ty, tz) end => [ :void, :GLbyte, :GLbyte, :GLbyte ].freeze,
    def glTangent3bvEXT(v) end => [ :void, :pointer ].freeze,
    def glTangent3dEXT(tx, ty, tz) end => [ :void, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glTangent3dvEXT(v) end => [ :void, :pointer ].freeze,
    def glTangent3fEXT(tx, ty, tz) end => [ :void, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glTangent3fvEXT(v) end => [ :void, :pointer ].freeze,
    def glTangent3iEXT(tx, ty, tz) end => [ :void, :GLint, :GLint, :GLint ].freeze,
    def glTangent3ivEXT(v) end => [ :void, :pointer ].freeze,
    def glTangent3sEXT(tx, ty, tz) end => [ :void, :GLshort, :GLshort, :GLshort ].freeze,
    def glTangent3svEXT(v) end => [ :void, :pointer ].freeze,
    def glBinormal3bEXT(bx, by, bz) end => [ :void, :GLbyte, :GLbyte, :GLbyte ].freeze,
    def glBinormal3bvEXT(v) end => [ :void, :pointer ].freeze,
    def glBinormal3dEXT(bx, by, bz) end => [ :void, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glBinormal3dvEXT(v) end => [ :void, :pointer ].freeze,
    def glBinormal3fEXT(bx, by, bz) end => [ :void, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glBinormal3fvEXT(v) end => [ :void, :pointer ].freeze,
    def glBinormal3iEXT(bx, by, bz) end => [ :void, :GLint, :GLint, :GLint ].freeze,
    def glBinormal3ivEXT(v) end => [ :void, :pointer ].freeze,
    def glBinormal3sEXT(bx, by, bz) end => [ :void, :GLshort, :GLshort, :GLshort ].freeze,
    def glBinormal3svEXT(v) end => [ :void, :pointer ].freeze,
    def glTangentPointerEXT(type, stride, pointer) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
    def glBinormalPointerEXT(type, stride, pointer) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
  }.freeze
end