module GL_EXT_direct_state_access
  module Constants
    PROGRAM_MATRIX_EXT             = 0x8E2D
    TRANSPOSE_PROGRAM_MATRIX_EXT   = 0x8E2E
    PROGRAM_MATRIX_STACK_DEPTH_EXT = 0x8E2F
  end
  
  Functions = {
    def glMatrixLoadfEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoaddEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultfEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultdEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoadIdentityEXT(mode) end => [ :void, :GLenum ].freeze,
    def glMatrixRotatefEXT(mode, angle, x, y, z) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMatrixRotatedEXT(mode, angle, x, y, z) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixScalefEXT(mode, x, y, z) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMatrixScaledEXT(mode, x, y, z) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixTranslatefEXT(mode, x, y, z) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMatrixTranslatedEXT(mode, x, y, z) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixFrustumEXT(mode, left, right, bottom, top, zNear, zFar) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixOrthoEXT(mode, left, right, bottom, top, zNear, zFar) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixPopEXT(mode) end => [ :void, :GLenum ].freeze,
    def glMatrixPushEXT(mode) end => [ :void, :GLenum ].freeze,
    def glClientAttribDefaultEXT(mask) end => [ :void, :GLbitfield ].freeze,
    def glPushClientAttribDefaultEXT(mask) end => [ :void, :GLbitfield ].freeze,
    def glTextureParameterfEXT(texture, target, pname, param) end => [ :void, :GLuint, :GLenum, :GLenum, :GLfloat ].freeze,
    def glTextureParameterfvEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureParameteriEXT(texture, target, pname, param) end => [ :void, :GLuint, :GLenum, :GLenum, :GLint ].freeze,
    def glTextureParameterivEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureImage1DEXT(texture, target, level, internalformat, width, border, format, type, pixels) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLsizei, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureImage2DEXT(texture, target, level, internalformat, width, height, border, format, type, pixels) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureSubImage1DEXT(texture, target, level, xoffset, width, format, type, pixels) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureSubImage2DEXT(texture, target, level, xoffset, yoffset, width, height, format, type, pixels) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyTextureImage1DEXT(texture, target, level, internalformat, x, y, width, border) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :GLint, :GLint, :GLsizei, :GLint ].freeze,
    def glCopyTextureImage2DEXT(texture, target, level, internalformat, x, y, width, height, border) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei, :GLint ].freeze,
    def glCopyTextureSubImage1DEXT(texture, target, level, xoffset, x, y, width) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei ].freeze,
    def glCopyTextureSubImage2DEXT(texture, target, level, xoffset, yoffset, x, y, width, height) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glGetTextureImageEXT(texture, target, level, format, type, pixels) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTextureParameterfvEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTextureParameterivEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTextureLevelParameterfvEXT(texture, target, level, pname, params) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :pointer ].freeze,
    def glGetTextureLevelParameterivEXT(texture, target, level, pname, params) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :pointer ].freeze,
    def glTextureImage3DEXT(texture, target, level, internalformat, width, height, depth, border, format, type, pixels) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureSubImage3DEXT(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyTextureSubImage3DEXT(texture, target, level, xoffset, yoffset, zoffset, x, y, width, height) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glBindMultiTextureEXT(texunit, target, texture) end => [ :void, :GLenum, :GLenum, :GLuint ].freeze,
    def glMultiTexCoordPointerEXT(texunit, size, type, stride, pointer) end => [ :void, :GLenum, :GLint, :GLenum, :GLsizei, :pointer ].freeze,
    def glMultiTexEnvfEXT(texunit, target, pname, param) end => [ :void, :GLenum, :GLenum, :GLenum, :GLfloat ].freeze,
    def glMultiTexEnvfvEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexEnviEXT(texunit, target, pname, param) end => [ :void, :GLenum, :GLenum, :GLenum, :GLint ].freeze,
    def glMultiTexEnvivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexGendEXT(texunit, coord, pname, param) end => [ :void, :GLenum, :GLenum, :GLenum, :GLdouble ].freeze,
    def glMultiTexGendvEXT(texunit, coord, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexGenfEXT(texunit, coord, pname, param) end => [ :void, :GLenum, :GLenum, :GLenum, :GLfloat ].freeze,
    def glMultiTexGenfvEXT(texunit, coord, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexGeniEXT(texunit, coord, pname, param) end => [ :void, :GLenum, :GLenum, :GLenum, :GLint ].freeze,
    def glMultiTexGenivEXT(texunit, coord, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexEnvfvEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexEnvivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexGendvEXT(texunit, coord, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexGenfvEXT(texunit, coord, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexGenivEXT(texunit, coord, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexParameteriEXT(texunit, target, pname, param) end => [ :void, :GLenum, :GLenum, :GLenum, :GLint ].freeze,
    def glMultiTexParameterivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexParameterfEXT(texunit, target, pname, param) end => [ :void, :GLenum, :GLenum, :GLenum, :GLfloat ].freeze,
    def glMultiTexParameterfvEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexImage1DEXT(texunit, target, level, internalformat, width, border, format, type, pixels) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexImage2DEXT(texunit, target, level, internalformat, width, height, border, format, type, pixels) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexSubImage1DEXT(texunit, target, level, xoffset, width, format, type, pixels) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexSubImage2DEXT(texunit, target, level, xoffset, yoffset, width, height, format, type, pixels) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyMultiTexImage1DEXT(texunit, target, level, internalformat, x, y, width, border) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :GLint, :GLint, :GLsizei, :GLint ].freeze,
    def glCopyMultiTexImage2DEXT(texunit, target, level, internalformat, x, y, width, height, border) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei, :GLint ].freeze,
    def glCopyMultiTexSubImage1DEXT(texunit, target, level, xoffset, x, y, width) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei ].freeze,
    def glCopyMultiTexSubImage2DEXT(texunit, target, level, xoffset, yoffset, x, y, width, height) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glGetMultiTexImageEXT(texunit, target, level, format, type, pixels) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexParameterfvEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexParameterivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexLevelParameterfvEXT(texunit, target, level, pname, params) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :pointer ].freeze,
    def glGetMultiTexLevelParameterivEXT(texunit, target, level, pname, params) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :pointer ].freeze,
    def glMultiTexImage3DEXT(texunit, target, level, internalformat, width, height, depth, border, format, type, pixels) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLint, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexSubImage3DEXT(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glCopyMultiTexSubImage3DEXT(texunit, target, level, xoffset, yoffset, zoffset, x, y, width, height) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glEnableClientStateIndexedEXT(array, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDisableClientStateIndexedEXT(array, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glGetFloatIndexedvEXT(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetDoubleIndexedvEXT(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetPointerIndexedvEXT(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glEnableIndexedEXT(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDisableIndexedEXT(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glIsEnabledIndexedEXT(target, index) end => [ :GLboolean, :GLenum, :GLuint ].freeze,
    def glGetIntegerIndexedvEXT(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetBooleanIndexedvEXT(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glCompressedTextureImage3DEXT(texture, target, level, internalformat, width, height, depth, border, imageSize, bits) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLint, :GLsizei, :pointer ].freeze,
    def glCompressedTextureImage2DEXT(texture, target, level, internalformat, width, height, border, imageSize, bits) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :GLsizei, :GLsizei, :GLint, :GLsizei, :pointer ].freeze,
    def glCompressedTextureImage1DEXT(texture, target, level, internalformat, width, border, imageSize, bits) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :GLsizei, :GLint, :GLsizei, :pointer ].freeze,
    def glCompressedTextureSubImage3DEXT(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glCompressedTextureSubImage2DEXT(texture, target, level, xoffset, yoffset, width, height, format, imageSize, bits) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glCompressedTextureSubImage1DEXT(texture, target, level, xoffset, width, format, imageSize, bits) end => [ :void, :GLuint, :GLenum, :GLint, :GLint, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetCompressedTextureImageEXT(texture, target, lod, img) end => [ :void, :GLuint, :GLenum, :GLint, :pointer ].freeze,
    def glCompressedMultiTexImage3DEXT(texunit, target, level, internalformat, width, height, depth, border, imageSize, bits) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLint, :GLsizei, :pointer ].freeze,
    def glCompressedMultiTexImage2DEXT(texunit, target, level, internalformat, width, height, border, imageSize, bits) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :GLsizei, :GLsizei, :GLint, :GLsizei, :pointer ].freeze,
    def glCompressedMultiTexImage1DEXT(texunit, target, level, internalformat, width, border, imageSize, bits) end => [ :void, :GLenum, :GLenum, :GLint, :GLenum, :GLsizei, :GLint, :GLsizei, :pointer ].freeze,
    def glCompressedMultiTexSubImage3DEXT(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glCompressedMultiTexSubImage2DEXT(texunit, target, level, xoffset, yoffset, width, height, format, imageSize, bits) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glCompressedMultiTexSubImage1DEXT(texunit, target, level, xoffset, width, format, imageSize, bits) end => [ :void, :GLenum, :GLenum, :GLint, :GLint, :GLsizei, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetCompressedMultiTexImageEXT(texunit, target, lod, img) end => [ :void, :GLenum, :GLenum, :GLint, :pointer ].freeze,
    def glMatrixLoadTransposefEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoadTransposedEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultTransposefEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultTransposedEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glNamedBufferDataEXT(buffer, size, data, usage) end => [ :void, :GLuint, :GLsizeiptr, :pointer, :GLenum ].freeze,
    def glNamedBufferSubDataEXT(buffer, offset, size, data) end => [ :void, :GLuint, :GLintptr, :GLsizeiptr, :pointer ].freeze,
    def glMapNamedBufferEXT(buffer, access) end => [ :pointer, :GLuint, :GLenum ].freeze,
    def glUnmapNamedBufferEXT(buffer) end => [ :GLboolean, :GLuint ].freeze,
    def glGetNamedBufferParameterivEXT(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetNamedBufferPointervEXT(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetNamedBufferSubDataEXT(buffer, offset, size, data) end => [ :void, :GLuint, :GLintptr, :GLsizeiptr, :pointer ].freeze,
    def glProgramUniform1fEXT(program, location, v0) end => [ :void, :GLuint, :GLint, :GLfloat ].freeze,
    def glProgramUniform2fEXT(program, location, v0, v1) end => [ :void, :GLuint, :GLint, :GLfloat, :GLfloat ].freeze,
    def glProgramUniform3fEXT(program, location, v0, v1, v2) end => [ :void, :GLuint, :GLint, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramUniform4fEXT(program, location, v0, v1, v2, v3) end => [ :void, :GLuint, :GLint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramUniform1iEXT(program, location, v0) end => [ :void, :GLuint, :GLint, :GLint ].freeze,
    def glProgramUniform2iEXT(program, location, v0, v1) end => [ :void, :GLuint, :GLint, :GLint, :GLint ].freeze,
    def glProgramUniform3iEXT(program, location, v0, v1, v2) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glProgramUniform4iEXT(program, location, v0, v1, v2, v3) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glProgramUniform1fvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2fvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3fvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4fvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform1ivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2ivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3ivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4ivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniformMatrix2fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix3fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix4fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix2x3fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix3x2fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix2x4fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix4x2fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix3x4fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix4x3fvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glTextureBufferEXT(texture, target, internalformat, buffer) end => [ :void, :GLuint, :GLenum, :GLenum, :GLuint ].freeze,
    def glMultiTexBufferEXT(texunit, target, internalformat, buffer) end => [ :void, :GLenum, :GLenum, :GLenum, :GLuint ].freeze,
    def glTextureParameterIivEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glTextureParameterIuivEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTextureParameterIivEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTextureParameterIuivEXT(texture, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexParameterIivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glMultiTexParameterIuivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexParameterIivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMultiTexParameterIuivEXT(texunit, target, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glProgramUniform1uiEXT(program, location, v0) end => [ :void, :GLuint, :GLint, :GLuint ].freeze,
    def glProgramUniform2uiEXT(program, location, v0, v1) end => [ :void, :GLuint, :GLint, :GLuint, :GLuint ].freeze,
    def glProgramUniform3uiEXT(program, location, v0, v1, v2) end => [ :void, :GLuint, :GLint, :GLuint, :GLuint, :GLuint ].freeze,
    def glProgramUniform4uiEXT(program, location, v0, v1, v2, v3) end => [ :void, :GLuint, :GLint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glProgramUniform1uivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2uivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3uivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4uivEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glNamedProgramLocalParameters4fvEXT(program, target, index, count, params) end => [ :void, :GLuint, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glNamedProgramLocalParameterI4iEXT(program, target, index, x, y, z, w) end => [ :void, :GLuint, :GLenum, :GLuint, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glNamedProgramLocalParameterI4ivEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glNamedProgramLocalParametersI4ivEXT(program, target, index, count, params) end => [ :void, :GLuint, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glNamedProgramLocalParameterI4uiEXT(program, target, index, x, y, z, w) end => [ :void, :GLuint, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glNamedProgramLocalParameterI4uivEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glNamedProgramLocalParametersI4uivEXT(program, target, index, count, params) end => [ :void, :GLuint, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glGetNamedProgramLocalParameterIivEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glGetNamedProgramLocalParameterIuivEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glEnableClientStateiEXT(array, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDisableClientStateiEXT(array, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glGetFloati_vEXT(pname, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetDoublei_vEXT(pname, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetPointeri_vEXT(pname, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glNamedProgramStringEXT(program, target, format, len, string) end => [ :void, :GLuint, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glNamedProgramLocalParameter4dEXT(program, target, index, x, y, z, w) end => [ :void, :GLuint, :GLenum, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glNamedProgramLocalParameter4dvEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glNamedProgramLocalParameter4fEXT(program, target, index, x, y, z, w) end => [ :void, :GLuint, :GLenum, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glNamedProgramLocalParameter4fvEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glGetNamedProgramLocalParameterdvEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glGetNamedProgramLocalParameterfvEXT(program, target, index, params) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glGetNamedProgramivEXT(program, target, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetNamedProgramStringEXT(program, target, pname, string) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glNamedRenderbufferStorageEXT(renderbuffer, internalformat, width, height) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glGetNamedRenderbufferParameterivEXT(renderbuffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glNamedRenderbufferStorageMultisampleEXT(renderbuffer, samples, internalformat, width, height) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glNamedRenderbufferStorageMultisampleCoverageEXT(renderbuffer, coverageSamples, colorSamples, internalformat, width, height) end => [ :void, :GLuint, :GLsizei, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glCheckNamedFramebufferStatusEXT(framebuffer, target) end => [ :GLenum, :GLuint, :GLenum ].freeze,
    def glNamedFramebufferTexture1DEXT(framebuffer, attachment, textarget, texture, level) end => [ :void, :GLuint, :GLenum, :GLenum, :GLuint, :GLint ].freeze,
    def glNamedFramebufferTexture2DEXT(framebuffer, attachment, textarget, texture, level) end => [ :void, :GLuint, :GLenum, :GLenum, :GLuint, :GLint ].freeze,
    def glNamedFramebufferTexture3DEXT(framebuffer, attachment, textarget, texture, level, zoffset) end => [ :void, :GLuint, :GLenum, :GLenum, :GLuint, :GLint, :GLint ].freeze,
    def glNamedFramebufferRenderbufferEXT(framebuffer, attachment, renderbuffertarget, renderbuffer) end => [ :void, :GLuint, :GLenum, :GLenum, :GLuint ].freeze,
    def glGetNamedFramebufferAttachmentParameterivEXT(framebuffer, attachment, pname, params) end => [ :void, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glGenerateTextureMipmapEXT(texture, target) end => [ :void, :GLuint, :GLenum ].freeze,
    def glGenerateMultiTexMipmapEXT(texunit, target) end => [ :void, :GLenum, :GLenum ].freeze,
    def glFramebufferDrawBufferEXT(framebuffer, mode) end => [ :void, :GLuint, :GLenum ].freeze,
    def glFramebufferDrawBuffersEXT(framebuffer, n, bufs) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glFramebufferReadBufferEXT(framebuffer, mode) end => [ :void, :GLuint, :GLenum ].freeze,
    def glGetFramebufferParameterivEXT(framebuffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glNamedCopyBufferSubDataEXT(readBuffer, writeBuffer, readOffset, writeOffset, size) end => [ :void, :GLuint, :GLuint, :GLintptr, :GLintptr, :GLsizeiptr ].freeze,
    def glNamedFramebufferTextureEXT(framebuffer, attachment, texture, level) end => [ :void, :GLuint, :GLenum, :GLuint, :GLint ].freeze,
    def glNamedFramebufferTextureLayerEXT(framebuffer, attachment, texture, level, layer) end => [ :void, :GLuint, :GLenum, :GLuint, :GLint, :GLint ].freeze,
    def glNamedFramebufferTextureFaceEXT(framebuffer, attachment, texture, level, face) end => [ :void, :GLuint, :GLenum, :GLuint, :GLint, :GLenum ].freeze,
    def glTextureRenderbufferEXT(texture, target, renderbuffer) end => [ :void, :GLuint, :GLenum, :GLuint ].freeze,
    def glMultiTexRenderbufferEXT(texunit, target, renderbuffer) end => [ :void, :GLenum, :GLenum, :GLuint ].freeze,
    def glVertexArrayVertexOffsetEXT(vaobj, buffer, size, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayColorOffsetEXT(vaobj, buffer, size, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayEdgeFlagOffsetEXT(vaobj, buffer, stride, offset) end => [ :void, :GLuint, :GLuint, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayIndexOffsetEXT(vaobj, buffer, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayNormalOffsetEXT(vaobj, buffer, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayTexCoordOffsetEXT(vaobj, buffer, size, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayMultiTexCoordOffsetEXT(vaobj, buffer, texunit, size, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayFogCoordOffsetEXT(vaobj, buffer, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArraySecondaryColorOffsetEXT(vaobj, buffer, size, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayVertexAttribOffsetEXT(vaobj, buffer, index, size, type, normalized, stride, offset) end => [ :void, :GLuint, :GLuint, :GLuint, :GLint, :GLenum, :GLboolean, :GLsizei, :GLintptr ].freeze,
    def glVertexArrayVertexAttribIOffsetEXT(vaobj, buffer, index, size, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLuint, :GLint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glEnableVertexArrayEXT(vaobj, array) end => [ :void, :GLuint, :GLenum ].freeze,
    def glDisableVertexArrayEXT(vaobj, array) end => [ :void, :GLuint, :GLenum ].freeze,
    def glEnableVertexArrayAttribEXT(vaobj, index) end => [ :void, :GLuint, :GLuint ].freeze,
    def glDisableVertexArrayAttribEXT(vaobj, index) end => [ :void, :GLuint, :GLuint ].freeze,
    def glGetVertexArrayIntegervEXT(vaobj, pname, param) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexArrayPointervEXT(vaobj, pname, param) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexArrayIntegeri_vEXT(vaobj, index, pname, param) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexArrayPointeri_vEXT(vaobj, index, pname, param) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glMapNamedBufferRangeEXT(buffer, offset, length, access) end => [ :pointer, :GLuint, :GLintptr, :GLsizeiptr, :GLbitfield ].freeze,
    def glFlushMappedNamedBufferRangeEXT(buffer, offset, length) end => [ :void, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glNamedBufferStorageEXT(buffer, size, data, flags) end => [ :void, :GLuint, :GLsizeiptr, :pointer, :GLbitfield ].freeze,
    def glClearNamedBufferDataEXT(buffer, internalformat, format, type, data) end => [ :void, :GLuint, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glClearNamedBufferSubDataEXT(buffer, internalformat, offset, size, format, type, data) end => [ :void, :GLuint, :GLenum, :GLsizeiptr, :GLsizeiptr, :GLenum, :GLenum, :pointer ].freeze,
    def glNamedFramebufferParameteriEXT(framebuffer, pname, param) end => [ :void, :GLuint, :GLenum, :GLint ].freeze,
    def glGetNamedFramebufferParameterivEXT(framebuffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glProgramUniform1dEXT(program, location, x) end => [ :void, :GLuint, :GLint, :GLdouble ].freeze,
    def glProgramUniform2dEXT(program, location, x, y) end => [ :void, :GLuint, :GLint, :GLdouble, :GLdouble ].freeze,
    def glProgramUniform3dEXT(program, location, x, y, z) end => [ :void, :GLuint, :GLint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramUniform4dEXT(program, location, x, y, z, w) end => [ :void, :GLuint, :GLint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramUniform1dvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform2dvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform3dvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniform4dvEXT(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glProgramUniformMatrix2dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix3dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix4dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix2x3dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix2x4dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix3x2dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix3x4dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix4x2dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glProgramUniformMatrix4x3dvEXT(program, location, count, transpose, value) end => [ :void, :GLuint, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glTextureBufferRangeEXT(texture, target, internalformat, buffer, offset, size) end => [ :void, :GLuint, :GLenum, :GLenum, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glTextureStorage1DEXT(texture, target, levels, internalformat, width) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei ].freeze,
    def glTextureStorage2DEXT(texture, target, levels, internalformat, width, height) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glTextureStorage3DEXT(texture, target, levels, internalformat, width, height, depth) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei ].freeze,
    def glTextureStorage2DMultisampleEXT(texture, target, samples, internalformat, width, height, fixedsamplelocations) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLboolean ].freeze,
    def glTextureStorage3DMultisampleEXT(texture, target, samples, internalformat, width, height, depth, fixedsamplelocations) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLboolean ].freeze,
    def glVertexArrayBindVertexBufferEXT(vaobj, bindingindex, buffer, offset, stride) end => [ :void, :GLuint, :GLuint, :GLuint, :GLintptr, :GLsizei ].freeze,
    def glVertexArrayVertexAttribFormatEXT(vaobj, attribindex, size, type, normalized, relativeoffset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLboolean, :GLuint ].freeze,
    def glVertexArrayVertexAttribIFormatEXT(vaobj, attribindex, size, type, relativeoffset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLuint ].freeze,
    def glVertexArrayVertexAttribLFormatEXT(vaobj, attribindex, size, type, relativeoffset) end => [ :void, :GLuint, :GLuint, :GLint, :GLenum, :GLuint ].freeze,
    def glVertexArrayVertexAttribBindingEXT(vaobj, attribindex, bindingindex) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glVertexArrayVertexBindingDivisorEXT(vaobj, bindingindex, divisor) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glVertexArrayVertexAttribLOffsetEXT(vaobj, buffer, index, size, type, stride, offset) end => [ :void, :GLuint, :GLuint, :GLuint, :GLint, :GLenum, :GLsizei, :GLintptr ].freeze,
    def glTexturePageCommitmentEXT(texture, level, xoffset, yoffset, zoffset, width, height, depth, commit) end => [ :void, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLboolean ].freeze,
    def glVertexArrayVertexAttribDivisorEXT(vaobj, index, divisor) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
  }.freeze
end