module GL_EXT_disjoint_timer_query
  module Constants
    QUERY_COUNTER_BITS_EXT     = 0x8864
    CURRENT_QUERY_EXT          = 0x8865
    QUERY_RESULT_EXT           = 0x8866
    QUERY_RESULT_AVAILABLE_EXT = 0x8867
    TIME_ELAPSED_EXT           = 0x88BF
    TIMESTAMP_EXT              = 0x8E28
    GPU_DISJOINT_EXT           = 0x8FBB
  end
  
  Functions = {
    def glGenQueriesEXT(n, ids) end => [ :void, :GLsizei, :pointer ].freeze,
    def glDeleteQueriesEXT(n, ids) end => [ :void, :GLsizei, :pointer ].freeze,
    def glIsQueryEXT(id) end => [ :GLboolean, :GLuint ].freeze,
    def glBeginQueryEXT(target, id) end => [ :void, :GLenum, :GLuint ].freeze,
    def glEndQueryEXT(target) end => [ :void, :GLenum ].freeze,
    def glQueryCounterEXT(id, target) end => [ :void, :GLuint, :GLenum ].freeze,
    def glGetQueryivEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetQueryObjectivEXT(id, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetQueryObjectuivEXT(id, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetQueryObjecti64vEXT(id, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetQueryObjectui64vEXT(id, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end