module GL_EXT_draw_buffers_indexed
  module Constants
    BLEND_EQUATION_RGB       = 0x8009
    BLEND_EQUATION_ALPHA     = 0x883D
    BLEND_SRC_RGB            = 0x80C9
    BLEND_SRC_ALPHA          = 0x80CB
    BLEND_DST_RGB            = 0x80C8
    BLEND_DST_ALPHA          = 0x80CA
    COLOR_WRITEMASK          = 0x0C23
    BLEND                    = 0x0BE2
    FUNC_ADD                 = 0x8006
    FUNC_SUBTRACT            = 0x800A
    FUNC_REVERSE_SUBTRACT    = 0x800B
    MIN                      = 0x8007
    MAX                      = 0x8008
    ZERO                     = 0
    ONE                      = 1
    SRC_COLOR                = 0x0300
    ONE_MINUS_SRC_COLOR      = 0x0301
    DST_COLOR                = 0x0306
    ONE_MINUS_DST_COLOR      = 0x0307
    SRC_ALPHA                = 0x0302
    ONE_MINUS_SRC_ALPHA      = 0x0303
    DST_ALPHA                = 0x0304
    ONE_MINUS_DST_ALPHA      = 0x0305
    CONSTANT_COLOR           = 0x8001
    ONE_MINUS_CONSTANT_COLOR = 0x8002
    CONSTANT_ALPHA           = 0x8003
    ONE_MINUS_CONSTANT_ALPHA = 0x8004
    SRC_ALPHA_SATURATE       = 0x0308
  end
  
  Functions = {
    def glEnableiEXT(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDisableiEXT(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glBlendEquationiEXT(buf, mode) end => [ :void, :GLuint, :GLenum ].freeze,
    def glBlendEquationSeparateiEXT(buf, modeRGB, modeAlpha) end => [ :void, :GLuint, :GLenum, :GLenum ].freeze,
    def glBlendFunciEXT(buf, src, dst) end => [ :void, :GLuint, :GLenum, :GLenum ].freeze,
    def glBlendFuncSeparateiEXT(buf, srcRGB, dstRGB, srcAlpha, dstAlpha) end => [ :void, :GLuint, :GLenum, :GLenum, :GLenum, :GLenum ].freeze,
    def glColorMaskiEXT(index, r, g, b, a) end => [ :void, :GLuint, :GLboolean, :GLboolean, :GLboolean, :GLboolean ].freeze,
    def glIsEnablediEXT(target, index) end => [ :GLboolean, :GLenum, :GLuint ].freeze,
  }.freeze
end