module GL_EXT_gpu_shader4
  module Constants
    VERTEX_ATTRIB_ARRAY_INTEGER_EXT   = 0x88FD
    SAMPLER_1D_ARRAY_EXT              = 0x8DC0
    SAMPLER_2D_ARRAY_EXT              = 0x8DC1
    SAMPLER_BUFFER_EXT                = 0x8DC2
    SAMPLER_1D_ARRAY_SHADOW_EXT       = 0x8DC3
    SAMPLER_2D_ARRAY_SHADOW_EXT       = 0x8DC4
    SAMPLER_CUBE_SHADOW_EXT           = 0x8DC5
    UNSIGNED_INT_VEC2_EXT             = 0x8DC6
    UNSIGNED_INT_VEC3_EXT             = 0x8DC7
    UNSIGNED_INT_VEC4_EXT             = 0x8DC8
    INT_SAMPLER_1D_EXT                = 0x8DC9
    INT_SAMPLER_2D_EXT                = 0x8DCA
    INT_SAMPLER_3D_EXT                = 0x8DCB
    INT_SAMPLER_CUBE_EXT              = 0x8DCC
    INT_SAMPLER_2D_RECT_EXT           = 0x8DCD
    INT_SAMPLER_1D_ARRAY_EXT          = 0x8DCE
    INT_SAMPLER_2D_ARRAY_EXT          = 0x8DCF
    INT_SAMPLER_BUFFER_EXT            = 0x8DD0
    UNSIGNED_INT_SAMPLER_1D_EXT       = 0x8DD1
    UNSIGNED_INT_SAMPLER_2D_EXT       = 0x8DD2
    UNSIGNED_INT_SAMPLER_3D_EXT       = 0x8DD3
    UNSIGNED_INT_SAMPLER_CUBE_EXT     = 0x8DD4
    UNSIGNED_INT_SAMPLER_2D_RECT_EXT  = 0x8DD5
    UNSIGNED_INT_SAMPLER_1D_ARRAY_EXT = 0x8DD6
    UNSIGNED_INT_SAMPLER_2D_ARRAY_EXT = 0x8DD7
    UNSIGNED_INT_SAMPLER_BUFFER_EXT   = 0x8DD8
    MIN_PROGRAM_TEXEL_OFFSET_EXT      = 0x8904
    MAX_PROGRAM_TEXEL_OFFSET_EXT      = 0x8905
  end
  
  Functions = {
    def glGetUniformuivEXT(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glBindFragDataLocationEXT(program, color, name) end => [ :void, :GLuint, :GLuint, :string ].freeze,
    def glGetFragDataLocationEXT(program, name) end => [ :GLint, :GLuint, :string ].freeze,
    def glUniform1uiEXT(location, v0) end => [ :void, :GLint, :GLuint ].freeze,
    def glUniform2uiEXT(location, v0, v1) end => [ :void, :GLint, :GLuint, :GLuint ].freeze,
    def glUniform3uiEXT(location, v0, v1, v2) end => [ :void, :GLint, :GLuint, :GLuint, :GLuint ].freeze,
    def glUniform4uiEXT(location, v0, v1, v2, v3) end => [ :void, :GLint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glUniform1uivEXT(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2uivEXT(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3uivEXT(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4uivEXT(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
  }.freeze
end