module GL_EXT_histogram
  module Constants
    HISTOGRAM_EXT                = 0x8024
    PROXY_HISTOGRAM_EXT          = 0x8025
    HISTOGRAM_WIDTH_EXT          = 0x8026
    HISTOGRAM_FORMAT_EXT         = 0x8027
    HISTOGRAM_RED_SIZE_EXT       = 0x8028
    HISTOGRAM_GREEN_SIZE_EXT     = 0x8029
    HISTOGRAM_BLUE_SIZE_EXT      = 0x802A
    HISTOGRAM_ALPHA_SIZE_EXT     = 0x802B
    HISTOGRAM_LUMINANCE_SIZE_EXT = 0x802C
    HISTOGRAM_SINK_EXT           = 0x802D
    MINMAX_EXT                   = 0x802E
    MINMAX_FORMAT_EXT            = 0x802F
    MINMAX_SINK_EXT              = 0x8030
    TABLE_TOO_LARGE_EXT          = 0x8031
  end
  
  Functions = {
    def glGetHistogramEXT(target, reset, format, type, values) end => [ :void, :GLenum, :GLboolean, :GLenum, :GLenum, :pointer ].freeze,
    def glGetHistogramParameterfvEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetHistogramParameterivEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMinmaxEXT(target, reset, format, type, values) end => [ :void, :GLenum, :GLboolean, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMinmaxParameterfvEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMinmaxParameterivEXT(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glHistogramEXT(target, width, internalformat, sink) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLboolean ].freeze,
    def glMinmaxEXT(target, internalformat, sink) end => [ :void, :GLenum, :GLenum, :GLboolean ].freeze,
    def glResetHistogramEXT(target) end => [ :void, :GLenum ].freeze,
    def glResetMinmaxEXT(target) end => [ :void, :GLenum ].freeze,
  }.freeze
end