module GL_EXT_memory_object
  module Constants
    TEXTURE_TILING_EXT          = 0x9580
    DEDICATED_MEMORY_OBJECT_EXT = 0x9581
    PROTECTED_MEMORY_OBJECT_EXT = 0x959B
    NUM_TILING_TYPES_EXT        = 0x9582
    TILING_TYPES_EXT            = 0x9583
    OPTIMAL_TILING_EXT          = 0x9584
    LINEAR_TILING_EXT           = 0x9585
    NUM_DEVICE_UUIDS_EXT        = 0x9596
    DEVICE_UUID_EXT             = 0x9597
    DRIVER_UUID_EXT             = 0x9598
    UUID_SIZE_EXT               = 16
  end
  
  Functions = {
    def glGetUnsignedBytevEXT(pname, data) end => [ :void, :GLenum, :pointer ].freeze,
    def glGetUnsignedBytei_vEXT(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glDeleteMemoryObjectsEXT(n, memoryObjects) end => [ :void, :GLsizei, :pointer ].freeze,
    def glIsMemoryObjectEXT(memoryObject) end => [ :GLboolean, :GLuint ].freeze,
    def glCreateMemoryObjectsEXT(n, memoryObjects) end => [ :void, :GLsizei, :pointer ].freeze,
    def glMemoryObjectParameterivEXT(memoryObject, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetMemoryObjectParameterivEXT(memoryObject, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glTexStorageMem2DEXT(target, levels, internalFormat, width, height, memory, offset) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLuint, :GLuint64 ].freeze,
    def glTexStorageMem2DMultisampleEXT(target, samples, internalFormat, width, height, fixedSampleLocations, memory, offset) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLboolean, :GLuint, :GLuint64 ].freeze,
    def glTexStorageMem3DEXT(target, levels, internalFormat, width, height, depth, memory, offset) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLuint, :GLuint64 ].freeze,
    def glTexStorageMem3DMultisampleEXT(target, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLboolean, :GLuint, :GLuint64 ].freeze,
    def glBufferStorageMemEXT(target, size, memory, offset) end => [ :void, :GLenum, :GLsizeiptr, :GLuint, :GLuint64 ].freeze,
    def glTextureStorageMem2DEXT(texture, levels, internalFormat, width, height, memory, offset) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLuint, :GLuint64 ].freeze,
    def glTextureStorageMem2DMultisampleEXT(texture, samples, internalFormat, width, height, fixedSampleLocations, memory, offset) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLboolean, :GLuint, :GLuint64 ].freeze,
    def glTextureStorageMem3DEXT(texture, levels, internalFormat, width, height, depth, memory, offset) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLuint, :GLuint64 ].freeze,
    def glTextureStorageMem3DMultisampleEXT(texture, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei, :GLboolean, :GLuint, :GLuint64 ].freeze,
    def glNamedBufferStorageMemEXT(buffer, size, memory, offset) end => [ :void, :GLuint, :GLsizeiptr, :GLuint, :GLuint64 ].freeze,
    def glTexStorageMem1DEXT(target, levels, internalFormat, width, memory, offset) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLuint, :GLuint64 ].freeze,
    def glTextureStorageMem1DEXT(texture, levels, internalFormat, width, memory, offset) end => [ :void, :GLuint, :GLsizei, :GLenum, :GLsizei, :GLuint, :GLuint64 ].freeze,
  }.freeze
end