module GL_EXT_robustness
  module Constants
    NO_ERROR                        = 0
    GUILTY_CONTEXT_RESET_EXT        = 0x8253
    INNOCENT_CONTEXT_RESET_EXT      = 0x8254
    UNKNOWN_CONTEXT_RESET_EXT       = 0x8255
    CONTEXT_ROBUST_ACCESS_EXT       = 0x90F3
    RESET_NOTIFICATION_STRATEGY_EXT = 0x8256
    LOSE_CONTEXT_ON_RESET_EXT       = 0x8252
    NO_RESET_NOTIFICATION_EXT       = 0x8261
  end
  
  Functions = {
    def glGetGraphicsResetStatusEXT() end => [ :GLenum ].freeze,
    def glReadnPixelsEXT(x, y, width, height, format, type, bufSize, data) end => [ :void, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnUniformfvEXT(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformivEXT(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
  }.freeze
end