module GL_EXT_secondary_color
  module Constants
    COLOR_SUM_EXT                     = 0x8458
    CURRENT_SECONDARY_COLOR_EXT       = 0x8459
    SECONDARY_COLOR_ARRAY_SIZE_EXT    = 0x845A
    SECONDARY_COLOR_ARRAY_TYPE_EXT    = 0x845B
    SECONDARY_COLOR_ARRAY_STRIDE_EXT  = 0x845C
    SECONDARY_COLOR_ARRAY_POINTER_EXT = 0x845D
    SECONDARY_COLOR_ARRAY_EXT         = 0x845E
  end
  
  Functions = {
    def glSecondaryColor3bEXT(red, green, blue) end => [ :void, :GLbyte, :GLbyte, :GLbyte ].freeze,
    def glSecondaryColor3bvEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3dEXT(red, green, blue) end => [ :void, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glSecondaryColor3dvEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3fEXT(red, green, blue) end => [ :void, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glSecondaryColor3fvEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3iEXT(red, green, blue) end => [ :void, :GLint, :GLint, :GLint ].freeze,
    def glSecondaryColor3ivEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3sEXT(red, green, blue) end => [ :void, :GLshort, :GLshort, :GLshort ].freeze,
    def glSecondaryColor3svEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3ubEXT(red, green, blue) end => [ :void, :GLubyte, :GLubyte, :GLubyte ].freeze,
    def glSecondaryColor3ubvEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3uiEXT(red, green, blue) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glSecondaryColor3uivEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3usEXT(red, green, blue) end => [ :void, :GLushort, :GLushort, :GLushort ].freeze,
    def glSecondaryColor3usvEXT(v) end => [ :void, :pointer ].freeze,
    def glSecondaryColorPointerEXT(size, type, stride, pointer) end => [ :void, :GLint, :GLenum, :GLsizei, :pointer ].freeze,
  }.freeze
end