module GL_EXT_semaphore
  module Constants
    NUM_DEVICE_UUIDS_EXT                          = 0x9596
    DEVICE_UUID_EXT                               = 0x9597
    DRIVER_UUID_EXT                               = 0x9598
    UUID_SIZE_EXT                                 = 16
    LAYOUT_GENERAL_EXT                            = 0x958D
    LAYOUT_COLOR_ATTACHMENT_EXT                   = 0x958E
    LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT           = 0x958F
    LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT            = 0x9590
    LAYOUT_SHADER_READ_ONLY_EXT                   = 0x9591
    LAYOUT_TRANSFER_SRC_EXT                       = 0x9592
    LAYOUT_TRANSFER_DST_EXT                       = 0x9593
    LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT = 0x9530
    LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT = 0x9531
  end
  
  Functions = {
    def glGetUnsignedBytevEXT(pname, data) end => [ :void, :GLenum, :pointer ].freeze,
    def glGetUnsignedBytei_vEXT(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGenSemaphoresEXT(n, semaphores) end => [ :void, :GLsizei, :pointer ].freeze,
    def glDeleteSemaphoresEXT(n, semaphores) end => [ :void, :GLsizei, :pointer ].freeze,
    def glIsSemaphoreEXT(semaphore) end => [ :GLboolean, :GLuint ].freeze,
    def glSemaphoreParameterui64vEXT(semaphore, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetSemaphoreParameterui64vEXT(semaphore, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glWaitSemaphoreEXT(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts) end => [ :void, :GLuint, :GLuint, :pointer, :GLuint, :pointer, :pointer ].freeze,
    def glSignalSemaphoreEXT(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts) end => [ :void, :GLuint, :GLuint, :pointer, :GLuint, :pointer, :pointer ].freeze,
  }.freeze
end