module GL_EXT_texture_storage
  module Constants
    TEXTURE_IMMUTABLE_FORMAT_EXT = 0x912F
    ALPHA8_EXT                   = 0x803C
    LUMINANCE8_EXT               = 0x8040
    LUMINANCE8_ALPHA8_EXT        = 0x8045
    RGBA32F_EXT                  = 0x8814
    RGB32F_EXT                   = 0x8815
    ALPHA32F_EXT                 = 0x8816
    LUMINANCE32F_EXT             = 0x8818
    LUMINANCE_ALPHA32F_EXT       = 0x8819
    RGBA16F_EXT                  = 0x881A
    RGB16F_EXT                   = 0x881B
    ALPHA16F_EXT                 = 0x881C
    LUMINANCE16F_EXT             = 0x881E
    LUMINANCE_ALPHA16F_EXT       = 0x881F
    RGB10_A2_EXT                 = 0x8059
    RGB10_EXT                    = 0x8052
    BGRA8_EXT                    = 0x93A1
    R8_EXT                       = 0x8229
    RG8_EXT                      = 0x822B
    R32F_EXT                     = 0x822E
    RG32F_EXT                    = 0x8230
    R16F_EXT                     = 0x822D
    RG16F_EXT                    = 0x822F
  end
  
  Functions = {
    def glTexStorage1DEXT(target, levels, internalformat, width) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei ].freeze,
    def glTexStorage2DEXT(target, levels, internalformat, width, height) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glTexStorage3DEXT(target, levels, internalformat, width, height, depth) end => [ :void, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei ].freeze,
    def glTextureStorage1DEXT(texture, target, levels, internalformat, width) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei ].freeze,
    def glTextureStorage2DEXT(texture, target, levels, internalformat, width, height) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glTextureStorage3DEXT(texture, target, levels, internalformat, width, height, depth) end => [ :void, :GLuint, :GLenum, :GLsizei, :GLenum, :GLsizei, :GLsizei, :GLsizei ].freeze,
  }.freeze
end