module GL_EXT_transform_feedback
  module Constants
    TRANSFORM_FEEDBACK_BUFFER_EXT                     = 0x8C8E
    TRANSFORM_FEEDBACK_BUFFER_START_EXT               = 0x8C84
    TRANSFORM_FEEDBACK_BUFFER_SIZE_EXT                = 0x8C85
    TRANSFORM_FEEDBACK_BUFFER_BINDING_EXT             = 0x8C8F
    INTERLEAVED_ATTRIBS_EXT                           = 0x8C8C
    SEPARATE_ATTRIBS_EXT                              = 0x8C8D
    PRIMITIVES_GENERATED_EXT                          = 0x8C87
    TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_EXT         = 0x8C88
    RASTERIZER_DISCARD_EXT                            = 0x8C89
    MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_EXT = 0x8C8A
    MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_EXT       = 0x8C8B
    MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_EXT    = 0x8C80
    TRANSFORM_FEEDBACK_VARYINGS_EXT                   = 0x8C83
    TRANSFORM_FEEDBACK_BUFFER_MODE_EXT                = 0x8C7F
    TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH_EXT         = 0x8C76
  end
  
  Functions = {
    def glBeginTransformFeedbackEXT(primitiveMode) end => [ :void, :GLenum ].freeze,
    def glEndTransformFeedbackEXT() end => [ :void ].freeze,
    def glBindBufferRangeEXT(target, index, buffer, offset, size) end => [ :void, :GLenum, :GLuint, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glBindBufferOffsetEXT(target, index, buffer, offset) end => [ :void, :GLenum, :GLuint, :GLuint, :GLintptr ].freeze,
    def glBindBufferBaseEXT(target, index, buffer) end => [ :void, :GLenum, :GLuint, :GLuint ].freeze,
    def glTransformFeedbackVaryingsEXT(program, count, varyings, bufferMode) end => [ :void, :GLuint, :GLsizei, :pointer, :GLenum ].freeze,
    def glGetTransformFeedbackVaryingEXT(program, index, bufSize, length, size, type, name) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :string ].freeze,
  }.freeze
end