module GL_EXT_vertex_array
  module Constants
    VERTEX_ARRAY_EXT                = 0x8074
    NORMAL_ARRAY_EXT                = 0x8075
    COLOR_ARRAY_EXT                 = 0x8076
    INDEX_ARRAY_EXT                 = 0x8077
    TEXTURE_COORD_ARRAY_EXT         = 0x8078
    EDGE_FLAG_ARRAY_EXT             = 0x8079
    VERTEX_ARRAY_SIZE_EXT           = 0x807A
    VERTEX_ARRAY_TYPE_EXT           = 0x807B
    VERTEX_ARRAY_STRIDE_EXT         = 0x807C
    VERTEX_ARRAY_COUNT_EXT          = 0x807D
    NORMAL_ARRAY_TYPE_EXT           = 0x807E
    NORMAL_ARRAY_STRIDE_EXT         = 0x807F
    NORMAL_ARRAY_COUNT_EXT          = 0x8080
    COLOR_ARRAY_SIZE_EXT            = 0x8081
    COLOR_ARRAY_TYPE_EXT            = 0x8082
    COLOR_ARRAY_STRIDE_EXT          = 0x8083
    COLOR_ARRAY_COUNT_EXT           = 0x8084
    INDEX_ARRAY_TYPE_EXT            = 0x8085
    INDEX_ARRAY_STRIDE_EXT          = 0x8086
    INDEX_ARRAY_COUNT_EXT           = 0x8087
    TEXTURE_COORD_ARRAY_SIZE_EXT    = 0x8088
    TEXTURE_COORD_ARRAY_TYPE_EXT    = 0x8089
    TEXTURE_COORD_ARRAY_STRIDE_EXT  = 0x808A
    TEXTURE_COORD_ARRAY_COUNT_EXT   = 0x808B
    EDGE_FLAG_ARRAY_STRIDE_EXT      = 0x808C
    EDGE_FLAG_ARRAY_COUNT_EXT       = 0x808D
    VERTEX_ARRAY_POINTER_EXT        = 0x808E
    NORMAL_ARRAY_POINTER_EXT        = 0x808F
    COLOR_ARRAY_POINTER_EXT         = 0x8090
    INDEX_ARRAY_POINTER_EXT         = 0x8091
    TEXTURE_COORD_ARRAY_POINTER_EXT = 0x8092
    EDGE_FLAG_ARRAY_POINTER_EXT     = 0x8093
  end
  
  Functions = {
    def glArrayElementEXT(i) end => [ :void, :GLint ].freeze,
    def glColorPointerEXT(size, type, stride, count, pointer) end => [ :void, :GLint, :GLenum, :GLsizei, :GLsizei, :pointer ].freeze,
    def glDrawArraysEXT(mode, first, count) end => [ :void, :GLenum, :GLint, :GLsizei ].freeze,
    def glEdgeFlagPointerEXT(stride, count, pointer) end => [ :void, :GLsizei, :GLsizei, :pointer ].freeze,
    def glGetPointervEXT(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
    def glIndexPointerEXT(type, stride, count, pointer) end => [ :void, :GLenum, :GLsizei, :GLsizei, :pointer ].freeze,
    def glNormalPointerEXT(type, stride, count, pointer) end => [ :void, :GLenum, :GLsizei, :GLsizei, :pointer ].freeze,
    def glTexCoordPointerEXT(size, type, stride, count, pointer) end => [ :void, :GLint, :GLenum, :GLsizei, :GLsizei, :pointer ].freeze,
    def glVertexPointerEXT(size, type, stride, count, pointer) end => [ :void, :GLint, :GLenum, :GLsizei, :GLsizei, :pointer ].freeze,
  }.freeze
end