module GL_EXT_vertex_attrib_64bit
  module Constants
    DOUBLE            = 0x140A
    DOUBLE_VEC2_EXT   = 0x8FFC
    DOUBLE_VEC3_EXT   = 0x8FFD
    DOUBLE_VEC4_EXT   = 0x8FFE
    DOUBLE_MAT2_EXT   = 0x8F46
    DOUBLE_MAT3_EXT   = 0x8F47
    DOUBLE_MAT4_EXT   = 0x8F48
    DOUBLE_MAT2x3_EXT = 0x8F49
    DOUBLE_MAT2x4_EXT = 0x8F4A
    DOUBLE_MAT3x2_EXT = 0x8F4B
    DOUBLE_MAT3x4_EXT = 0x8F4C
    DOUBLE_MAT4x2_EXT = 0x8F4D
    DOUBLE_MAT4x3_EXT = 0x8F4E
  end
  
  Functions = {
    def glVertexAttribL1dEXT(index, x) end => [ :void, :GLuint, :GLdouble ].freeze,
    def glVertexAttribL2dEXT(index, x, y) end => [ :void, :GLuint, :GLdouble, :GLdouble ].freeze,
    def glVertexAttribL3dEXT(index, x, y, z) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttribL4dEXT(index, x, y, z, w) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttribL1dvEXT(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL2dvEXT(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL3dvEXT(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL4dvEXT(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribLPointerEXT(index, size, type, stride, pointer) end => [ :void, :GLuint, :GLint, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetVertexAttribLdvEXT(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end