module GL_EXT_vertex_shader
  module Constants
    VERTEX_SHADER_EXT                               = 0x8780
    VERTEX_SHADER_BINDING_EXT                       = 0x8781
    OP_INDEX_EXT                                    = 0x8782
    OP_NEGATE_EXT                                   = 0x8783
    OP_DOT3_EXT                                     = 0x8784
    OP_DOT4_EXT                                     = 0x8785
    OP_MUL_EXT                                      = 0x8786
    OP_ADD_EXT                                      = 0x8787
    OP_MADD_EXT                                     = 0x8788
    OP_FRAC_EXT                                     = 0x8789
    OP_MAX_EXT                                      = 0x878A
    OP_MIN_EXT                                      = 0x878B
    OP_SET_GE_EXT                                   = 0x878C
    OP_SET_LT_EXT                                   = 0x878D
    OP_CLAMP_EXT                                    = 0x878E
    OP_FLOOR_EXT                                    = 0x878F
    OP_ROUND_EXT                                    = 0x8790
    OP_EXP_BASE_2_EXT                               = 0x8791
    OP_LOG_BASE_2_EXT                               = 0x8792
    OP_POWER_EXT                                    = 0x8793
    OP_RECIP_EXT                                    = 0x8794
    OP_RECIP_SQRT_EXT                               = 0x8795
    OP_SUB_EXT                                      = 0x8796
    OP_CROSS_PRODUCT_EXT                            = 0x8797
    OP_MULTIPLY_MATRIX_EXT                          = 0x8798
    OP_MOV_EXT                                      = 0x8799
    OUTPUT_VERTEX_EXT                               = 0x879A
    OUTPUT_COLOR0_EXT                               = 0x879B
    OUTPUT_COLOR1_EXT                               = 0x879C
    OUTPUT_TEXTURE_COORD0_EXT                       = 0x879D
    OUTPUT_TEXTURE_COORD1_EXT                       = 0x879E
    OUTPUT_TEXTURE_COORD2_EXT                       = 0x879F
    OUTPUT_TEXTURE_COORD3_EXT                       = 0x87A0
    OUTPUT_TEXTURE_COORD4_EXT                       = 0x87A1
    OUTPUT_TEXTURE_COORD5_EXT                       = 0x87A2
    OUTPUT_TEXTURE_COORD6_EXT                       = 0x87A3
    OUTPUT_TEXTURE_COORD7_EXT                       = 0x87A4
    OUTPUT_TEXTURE_COORD8_EXT                       = 0x87A5
    OUTPUT_TEXTURE_COORD9_EXT                       = 0x87A6
    OUTPUT_TEXTURE_COORD10_EXT                      = 0x87A7
    OUTPUT_TEXTURE_COORD11_EXT                      = 0x87A8
    OUTPUT_TEXTURE_COORD12_EXT                      = 0x87A9
    OUTPUT_TEXTURE_COORD13_EXT                      = 0x87AA
    OUTPUT_TEXTURE_COORD14_EXT                      = 0x87AB
    OUTPUT_TEXTURE_COORD15_EXT                      = 0x87AC
    OUTPUT_TEXTURE_COORD16_EXT                      = 0x87AD
    OUTPUT_TEXTURE_COORD17_EXT                      = 0x87AE
    OUTPUT_TEXTURE_COORD18_EXT                      = 0x87AF
    OUTPUT_TEXTURE_COORD19_EXT                      = 0x87B0
    OUTPUT_TEXTURE_COORD20_EXT                      = 0x87B1
    OUTPUT_TEXTURE_COORD21_EXT                      = 0x87B2
    OUTPUT_TEXTURE_COORD22_EXT                      = 0x87B3
    OUTPUT_TEXTURE_COORD23_EXT                      = 0x87B4
    OUTPUT_TEXTURE_COORD24_EXT                      = 0x87B5
    OUTPUT_TEXTURE_COORD25_EXT                      = 0x87B6
    OUTPUT_TEXTURE_COORD26_EXT                      = 0x87B7
    OUTPUT_TEXTURE_COORD27_EXT                      = 0x87B8
    OUTPUT_TEXTURE_COORD28_EXT                      = 0x87B9
    OUTPUT_TEXTURE_COORD29_EXT                      = 0x87BA
    OUTPUT_TEXTURE_COORD30_EXT                      = 0x87BB
    OUTPUT_TEXTURE_COORD31_EXT                      = 0x87BC
    OUTPUT_FOG_EXT                                  = 0x87BD
    SCALAR_EXT                                      = 0x87BE
    VECTOR_EXT                                      = 0x87BF
    MATRIX_EXT                                      = 0x87C0
    VARIANT_EXT                                     = 0x87C1
    INVARIANT_EXT                                   = 0x87C2
    LOCAL_CONSTANT_EXT                              = 0x87C3
    LOCAL_EXT                                       = 0x87C4
    MAX_VERTEX_SHADER_INSTRUCTIONS_EXT              = 0x87C5
    MAX_VERTEX_SHADER_VARIANTS_EXT                  = 0x87C6
    MAX_VERTEX_SHADER_INVARIANTS_EXT                = 0x87C7
    MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT           = 0x87C8
    MAX_VERTEX_SHADER_LOCALS_EXT                    = 0x87C9
    MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT    = 0x87CA
    MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT        = 0x87CB
    MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT = 0x87CC
    MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT      = 0x87CD
    MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT          = 0x87CE
    VERTEX_SHADER_INSTRUCTIONS_EXT                  = 0x87CF
    VERTEX_SHADER_VARIANTS_EXT                      = 0x87D0
    VERTEX_SHADER_INVARIANTS_EXT                    = 0x87D1
    VERTEX_SHADER_LOCAL_CONSTANTS_EXT               = 0x87D2
    VERTEX_SHADER_LOCALS_EXT                        = 0x87D3
    VERTEX_SHADER_OPTIMIZED_EXT                     = 0x87D4
    X_EXT                                           = 0x87D5
    Y_EXT                                           = 0x87D6
    Z_EXT                                           = 0x87D7
    W_EXT                                           = 0x87D8
    NEGATIVE_X_EXT                                  = 0x87D9
    NEGATIVE_Y_EXT                                  = 0x87DA
    NEGATIVE_Z_EXT                                  = 0x87DB
    NEGATIVE_W_EXT                                  = 0x87DC
    ZERO_EXT                                        = 0x87DD
    ONE_EXT                                         = 0x87DE
    NEGATIVE_ONE_EXT                                = 0x87DF
    NORMALIZED_RANGE_EXT                            = 0x87E0
    FULL_RANGE_EXT                                  = 0x87E1
    CURRENT_VERTEX_EXT                              = 0x87E2
    MVP_MATRIX_EXT                                  = 0x87E3
    VARIANT_VALUE_EXT                               = 0x87E4
    VARIANT_DATATYPE_EXT                            = 0x87E5
    VARIANT_ARRAY_STRIDE_EXT                        = 0x87E6
    VARIANT_ARRAY_TYPE_EXT                          = 0x87E7
    VARIANT_ARRAY_EXT                               = 0x87E8
    VARIANT_ARRAY_POINTER_EXT                       = 0x87E9
    INVARIANT_VALUE_EXT                             = 0x87EA
    INVARIANT_DATATYPE_EXT                          = 0x87EB
    LOCAL_CONSTANT_VALUE_EXT                        = 0x87EC
    LOCAL_CONSTANT_DATATYPE_EXT                     = 0x87ED
  end
  
  Functions = {
    def glBeginVertexShaderEXT() end => [ :void ].freeze,
    def glEndVertexShaderEXT() end => [ :void ].freeze,
    def glBindVertexShaderEXT(id) end => [ :void, :GLuint ].freeze,
    def glGenVertexShadersEXT(range) end => [ :GLuint, :GLuint ].freeze,
    def glDeleteVertexShaderEXT(id) end => [ :void, :GLuint ].freeze,
    def glShaderOp1EXT(op, res, arg1) end => [ :void, :GLenum, :GLuint, :GLuint ].freeze,
    def glShaderOp2EXT(op, res, arg1, arg2) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint ].freeze,
    def glShaderOp3EXT(op, res, arg1, arg2, arg3) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glSwizzleEXT(res, in_, outX, outY, outZ, outW) end => [ :void, :GLuint, :GLuint, :GLenum, :GLenum, :GLenum, :GLenum ].freeze,
    def glWriteMaskEXT(res, in_, outX, outY, outZ, outW) end => [ :void, :GLuint, :GLuint, :GLenum, :GLenum, :GLenum, :GLenum ].freeze,
    def glInsertComponentEXT(res, src, num) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glExtractComponentEXT(res, src, num) end => [ :void, :GLuint, :GLuint, :GLuint ].freeze,
    def glGenSymbolsEXT(datatype, storagetype, range, components) end => [ :GLuint, :GLenum, :GLenum, :GLenum, :GLuint ].freeze,
    def glSetInvariantEXT(id, type, addr) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glSetLocalConstantEXT(id, type, addr) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glVariantbvEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantsvEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantivEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantfvEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantdvEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantubvEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantusvEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantuivEXT(id, addr) end => [ :void, :GLuint, :pointer ].freeze,
    def glVariantPointerEXT(id, type, stride, addr) end => [ :void, :GLuint, :GLenum, :GLuint, :pointer ].freeze,
    def glEnableVariantClientStateEXT(id) end => [ :void, :GLuint ].freeze,
    def glDisableVariantClientStateEXT(id) end => [ :void, :GLuint ].freeze,
    def glBindLightParameterEXT(light, value) end => [ :GLuint, :GLenum, :GLenum ].freeze,
    def glBindMaterialParameterEXT(face, value) end => [ :GLuint, :GLenum, :GLenum ].freeze,
    def glBindTexGenParameterEXT(unit, coord, value) end => [ :GLuint, :GLenum, :GLenum, :GLenum ].freeze,
    def glBindTextureUnitParameterEXT(unit, value) end => [ :GLuint, :GLenum, :GLenum ].freeze,
    def glBindParameterEXT(value) end => [ :GLuint, :GLenum ].freeze,
    def glIsVariantEnabledEXT(id, cap) end => [ :GLboolean, :GLuint, :GLenum ].freeze,
    def glGetVariantBooleanvEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVariantIntegervEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVariantFloatvEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVariantPointervEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetInvariantBooleanvEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetInvariantIntegervEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetInvariantFloatvEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetLocalConstantBooleanvEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetLocalConstantIntegervEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetLocalConstantFloatvEXT(id, value, data) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end