module GL_EXT_vertex_weighting
  module Constants
    MODELVIEW0_STACK_DEPTH_EXT      = 0x0BA3
    MODELVIEW1_STACK_DEPTH_EXT      = 0x8502
    MODELVIEW0_MATRIX_EXT           = 0x0BA6
    MODELVIEW1_MATRIX_EXT           = 0x8506
    VERTEX_WEIGHTING_EXT            = 0x8509
    MODELVIEW0_EXT                  = 0x1700
    MODELVIEW1_EXT                  = 0x850A
    CURRENT_VERTEX_WEIGHT_EXT       = 0x850B
    VERTEX_WEIGHT_ARRAY_EXT         = 0x850C
    VERTEX_WEIGHT_ARRAY_SIZE_EXT    = 0x850D
    VERTEX_WEIGHT_ARRAY_TYPE_EXT    = 0x850E
    VERTEX_WEIGHT_ARRAY_STRIDE_EXT  = 0x850F
    VERTEX_WEIGHT_ARRAY_POINTER_EXT = 0x8510
  end
  
  Functions = {
    def glVertexWeightfEXT(weight) end => [ :void, :GLfloat ].freeze,
    def glVertexWeightfvEXT(weight) end => [ :void, :pointer ].freeze,
    def glVertexWeightPointerEXT(size, type, stride, pointer) end => [ :void, :GLint, :GLenum, :GLsizei, :pointer ].freeze,
  }.freeze
end