module GL_INTEL_performance_query
  module Constants
    PERFQUERY_SINGLE_CONTEXT_INTEL          = 0x00000000
    PERFQUERY_GLOBAL_CONTEXT_INTEL          = 0x00000001
    PERFQUERY_WAIT_INTEL                    = 0x83FB
    PERFQUERY_FLUSH_INTEL                   = 0x83FA
    PERFQUERY_DONOT_FLUSH_INTEL             = 0x83F9
    PERFQUERY_COUNTER_EVENT_INTEL           = 0x94F0
    PERFQUERY_COUNTER_DURATION_NORM_INTEL   = 0x94F1
    PERFQUERY_COUNTER_DURATION_RAW_INTEL    = 0x94F2
    PERFQUERY_COUNTER_THROUGHPUT_INTEL      = 0x94F3
    PERFQUERY_COUNTER_RAW_INTEL             = 0x94F4
    PERFQUERY_COUNTER_TIMESTAMP_INTEL       = 0x94F5
    PERFQUERY_COUNTER_DATA_UINT32_INTEL     = 0x94F8
    PERFQUERY_COUNTER_DATA_UINT64_INTEL     = 0x94F9
    PERFQUERY_COUNTER_DATA_FLOAT_INTEL      = 0x94FA
    PERFQUERY_COUNTER_DATA_DOUBLE_INTEL     = 0x94FB
    PERFQUERY_COUNTER_DATA_BOOL32_INTEL     = 0x94FC
    PERFQUERY_QUERY_NAME_LENGTH_MAX_INTEL   = 0x94FD
    PERFQUERY_COUNTER_NAME_LENGTH_MAX_INTEL = 0x94FE
    PERFQUERY_COUNTER_DESC_LENGTH_MAX_INTEL = 0x94FF
    PERFQUERY_GPA_EXTENDED_COUNTERS_INTEL   = 0x9500
  end
  
  Functions = {
    def glBeginPerfQueryINTEL(queryHandle) end => [ :void, :GLuint ].freeze,
    def glCreatePerfQueryINTEL(queryId, queryHandle) end => [ :void, :GLuint, :pointer ].freeze,
    def glDeletePerfQueryINTEL(queryHandle) end => [ :void, :GLuint ].freeze,
    def glEndPerfQueryINTEL(queryHandle) end => [ :void, :GLuint ].freeze,
    def glGetFirstPerfQueryIdINTEL(queryId) end => [ :void, :pointer ].freeze,
    def glGetNextPerfQueryIdINTEL(queryId, nextQueryId) end => [ :void, :GLuint, :pointer ].freeze,
    def glGetPerfCounterInfoINTEL(queryId, counterId, counterNameLength, counterName, counterDescLength, counterDesc, counterOffset, counterDataSize, counterTypeEnum, counterDataTypeEnum, rawCounterMaxValue) end => [ :void, :GLuint, :GLuint, :GLuint, :string, :GLuint, :string, :pointer, :pointer, :pointer, :pointer, :pointer ].freeze,
    def glGetPerfQueryDataINTEL(queryHandle, flags, dataSize, data, bytesWritten) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
    def glGetPerfQueryIdByNameINTEL(queryName, queryId) end => [ :void, :string, :pointer ].freeze,
    def glGetPerfQueryInfoINTEL(queryId, queryNameLength, queryName, dataSize, noCounters, noInstances, capsMask) end => [ :void, :GLuint, :GLuint, :string, :pointer, :pointer, :pointer, :pointer ].freeze,
  }.freeze
end