module GL_KHR_debug
  module Constants
    DEBUG_OUTPUT_SYNCHRONOUS             = 0x8242
    DEBUG_NEXT_LOGGED_MESSAGE_LENGTH     = 0x8243
    DEBUG_CALLBACK_FUNCTION              = 0x8244
    DEBUG_CALLBACK_USER_PARAM            = 0x8245
    DEBUG_SOURCE_API                     = 0x8246
    DEBUG_SOURCE_WINDOW_SYSTEM           = 0x8247
    DEBUG_SOURCE_SHADER_COMPILER         = 0x8248
    DEBUG_SOURCE_THIRD_PARTY             = 0x8249
    DEBUG_SOURCE_APPLICATION             = 0x824A
    DEBUG_SOURCE_OTHER                   = 0x824B
    DEBUG_TYPE_ERROR                     = 0x824C
    DEBUG_TYPE_DEPRECATED_BEHAVIOR       = 0x824D
    DEBUG_TYPE_UNDEFINED_BEHAVIOR        = 0x824E
    DEBUG_TYPE_PORTABILITY               = 0x824F
    DEBUG_TYPE_PERFORMANCE               = 0x8250
    DEBUG_TYPE_OTHER                     = 0x8251
    DEBUG_TYPE_MARKER                    = 0x8268
    DEBUG_TYPE_PUSH_GROUP                = 0x8269
    DEBUG_TYPE_POP_GROUP                 = 0x826A
    DEBUG_SEVERITY_NOTIFICATION          = 0x826B
    MAX_DEBUG_GROUP_STACK_DEPTH          = 0x826C
    DEBUG_GROUP_STACK_DEPTH              = 0x826D
    BUFFER                               = 0x82E0
    SHADER                               = 0x82E1
    PROGRAM                              = 0x82E2
    VERTEX_ARRAY                         = 0x8074
    QUERY                                = 0x82E3
    PROGRAM_PIPELINE                     = 0x82E4
    SAMPLER                              = 0x82E6
    MAX_LABEL_LENGTH                     = 0x82E8
    MAX_DEBUG_MESSAGE_LENGTH             = 0x9143
    MAX_DEBUG_LOGGED_MESSAGES            = 0x9144
    DEBUG_LOGGED_MESSAGES                = 0x9145
    DEBUG_SEVERITY_HIGH                  = 0x9146
    DEBUG_SEVERITY_MEDIUM                = 0x9147
    DEBUG_SEVERITY_LOW                   = 0x9148
    DEBUG_OUTPUT                         = 0x92E0
    CONTEXT_FLAG_DEBUG_BIT               = 0x00000002
    STACK_OVERFLOW                       = 0x0503
    STACK_UNDERFLOW                      = 0x0504
    DEBUG_OUTPUT_SYNCHRONOUS_KHR         = 0x8242
    DEBUG_NEXT_LOGGED_MESSAGE_LENGTH_KHR = 0x8243
    DEBUG_CALLBACK_FUNCTION_KHR          = 0x8244
    DEBUG_CALLBACK_USER_PARAM_KHR        = 0x8245
    DEBUG_SOURCE_API_KHR                 = 0x8246
    DEBUG_SOURCE_WINDOW_SYSTEM_KHR       = 0x8247
    DEBUG_SOURCE_SHADER_COMPILER_KHR     = 0x8248
    DEBUG_SOURCE_THIRD_PARTY_KHR         = 0x8249
    DEBUG_SOURCE_APPLICATION_KHR         = 0x824A
    DEBUG_SOURCE_OTHER_KHR               = 0x824B
    DEBUG_TYPE_ERROR_KHR                 = 0x824C
    DEBUG_TYPE_DEPRECATED_BEHAVIOR_KHR   = 0x824D
    DEBUG_TYPE_UNDEFINED_BEHAVIOR_KHR    = 0x824E
    DEBUG_TYPE_PORTABILITY_KHR           = 0x824F
    DEBUG_TYPE_PERFORMANCE_KHR           = 0x8250
    DEBUG_TYPE_OTHER_KHR                 = 0x8251
    DEBUG_TYPE_MARKER_KHR                = 0x8268
    DEBUG_TYPE_PUSH_GROUP_KHR            = 0x8269
    DEBUG_TYPE_POP_GROUP_KHR             = 0x826A
    DEBUG_SEVERITY_NOTIFICATION_KHR      = 0x826B
    MAX_DEBUG_GROUP_STACK_DEPTH_KHR      = 0x826C
    DEBUG_GROUP_STACK_DEPTH_KHR          = 0x826D
    BUFFER_KHR                           = 0x82E0
    SHADER_KHR                           = 0x82E1
    PROGRAM_KHR                          = 0x82E2
    VERTEX_ARRAY_KHR                     = 0x8074
    QUERY_KHR                            = 0x82E3
    PROGRAM_PIPELINE_KHR                 = 0x82E4
    SAMPLER_KHR                          = 0x82E6
    MAX_LABEL_LENGTH_KHR                 = 0x82E8
    MAX_DEBUG_MESSAGE_LENGTH_KHR         = 0x9143
    MAX_DEBUG_LOGGED_MESSAGES_KHR        = 0x9144
    DEBUG_LOGGED_MESSAGES_KHR            = 0x9145
    DEBUG_SEVERITY_HIGH_KHR              = 0x9146
    DEBUG_SEVERITY_MEDIUM_KHR            = 0x9147
    DEBUG_SEVERITY_LOW_KHR               = 0x9148
    DEBUG_OUTPUT_KHR                     = 0x92E0
    CONTEXT_FLAG_DEBUG_BIT_KHR           = 0x00000002
    STACK_OVERFLOW_KHR                   = 0x0503
    STACK_UNDERFLOW_KHR                  = 0x0504
    DISPLAY_LIST                         = 0x82E7
  end
  
  Callbacks = {
    GLDEBUGPROC:    [ :void, :GLenum, :GLenum, :GLuint, :GLenum, :GLsizei, :string, :pointer ].freeze,
    GLDEBUGPROCKHR: [ :void, :GLenum, :GLenum, :GLuint, :GLenum, :GLsizei, :string, :pointer ].freeze,
  }.freeze
  
  Functions = {
    def glDebugMessageControl(source, type, severity, count, ids, enabled) end => [ :void, :GLenum, :GLenum, :GLenum, :GLsizei, :pointer, :GLboolean ].freeze,
    def glDebugMessageInsert(source, type, id, severity, length, buf) end => [ :void, :GLenum, :GLenum, :GLuint, :GLenum, :GLsizei, :string ].freeze,
    def glDebugMessageCallback(callback, userParam) end => [ :void, :GLDEBUGPROC, :pointer ].freeze,
    def glGetDebugMessageLog(count, bufSize, sources, types, ids, severities, lengths, messageLog) end => [ :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :pointer, :pointer, :string ].freeze,
    def glPushDebugGroup(source, id, length, message) end => [ :void, :GLenum, :GLuint, :GLsizei, :string ].freeze,
    def glPopDebugGroup() end => [ :void ].freeze,
    def glObjectLabel(identifier, name, length, label) end => [ :void, :GLenum, :GLuint, :GLsizei, :string ].freeze,
    def glGetObjectLabel(identifier, name, bufSize, length, label) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glObjectPtrLabel(ptr, length, label) end => [ :void, :pointer, :GLsizei, :string ].freeze,
    def glGetObjectPtrLabel(ptr, bufSize, length, label) end => [ :void, :pointer, :GLsizei, :pointer, :string ].freeze,
    def glGetPointerv(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
    def glDebugMessageControlKHR(source, type, severity, count, ids, enabled) end => [ :void, :GLenum, :GLenum, :GLenum, :GLsizei, :pointer, :GLboolean ].freeze,
    def glDebugMessageInsertKHR(source, type, id, severity, length, buf) end => [ :void, :GLenum, :GLenum, :GLuint, :GLenum, :GLsizei, :string ].freeze,
    def glDebugMessageCallbackKHR(callback, userParam) end => [ :void, :GLDEBUGPROCKHR, :pointer ].freeze,
    def glGetDebugMessageLogKHR(count, bufSize, sources, types, ids, severities, lengths, messageLog) end => [ :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :pointer, :pointer, :string ].freeze,
    def glPushDebugGroupKHR(source, id, length, message) end => [ :void, :GLenum, :GLuint, :GLsizei, :string ].freeze,
    def glPopDebugGroupKHR() end => [ :void ].freeze,
    def glObjectLabelKHR(identifier, name, length, label) end => [ :void, :GLenum, :GLuint, :GLsizei, :string ].freeze,
    def glGetObjectLabelKHR(identifier, name, bufSize, length, label) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glObjectPtrLabelKHR(ptr, length, label) end => [ :void, :pointer, :GLsizei, :string ].freeze,
    def glGetObjectPtrLabelKHR(ptr, bufSize, length, label) end => [ :void, :pointer, :GLsizei, :pointer, :string ].freeze,
    def glGetPointervKHR(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
  }.freeze
end