module GL_KHR_robustness
  module Constants
    NO_ERROR                        = 0
    CONTEXT_ROBUST_ACCESS           = 0x90F3
    LOSE_CONTEXT_ON_RESET           = 0x8252
    GUILTY_CONTEXT_RESET            = 0x8253
    INNOCENT_CONTEXT_RESET          = 0x8254
    UNKNOWN_CONTEXT_RESET           = 0x8255
    RESET_NOTIFICATION_STRATEGY     = 0x8256
    NO_RESET_NOTIFICATION           = 0x8261
    CONTEXT_LOST                    = 0x0507
    CONTEXT_ROBUST_ACCESS_KHR       = 0x90F3
    LOSE_CONTEXT_ON_RESET_KHR       = 0x8252
    GUILTY_CONTEXT_RESET_KHR        = 0x8253
    INNOCENT_CONTEXT_RESET_KHR      = 0x8254
    UNKNOWN_CONTEXT_RESET_KHR       = 0x8255
    RESET_NOTIFICATION_STRATEGY_KHR = 0x8256
    NO_RESET_NOTIFICATION_KHR       = 0x8261
    CONTEXT_LOST_KHR                = 0x0507
  end
  
  Functions = {
    def glGetGraphicsResetStatus() end => [ :GLenum ].freeze,
    def glReadnPixels(x, y, width, height, format, type, bufSize, data) end => [ :void, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnUniformfv(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformiv(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformuiv(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetGraphicsResetStatusKHR() end => [ :GLenum ].freeze,
    def glReadnPixelsKHR(x, y, width, height, format, type, bufSize, data) end => [ :void, :GLint, :GLint, :GLsizei, :GLsizei, :GLenum, :GLenum, :GLsizei, :pointer ].freeze,
    def glGetnUniformfvKHR(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformivKHR(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
    def glGetnUniformuivKHR(program, location, bufSize, params) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
  }.freeze
end