module GL_NV_command_list
  module Constants
    TERMINATE_SEQUENCE_COMMAND_NV      = 0x0000
    NOP_COMMAND_NV                     = 0x0001
    DRAW_ELEMENTS_COMMAND_NV           = 0x0002
    DRAW_ARRAYS_COMMAND_NV             = 0x0003
    DRAW_ELEMENTS_STRIP_COMMAND_NV     = 0x0004
    DRAW_ARRAYS_STRIP_COMMAND_NV       = 0x0005
    DRAW_ELEMENTS_INSTANCED_COMMAND_NV = 0x0006
    DRAW_ARRAYS_INSTANCED_COMMAND_NV   = 0x0007
    ELEMENT_ADDRESS_COMMAND_NV         = 0x0008
    ATTRIBUTE_ADDRESS_COMMAND_NV       = 0x0009
    UNIFORM_ADDRESS_COMMAND_NV         = 0x000A
    BLEND_COLOR_COMMAND_NV             = 0x000B
    STENCIL_REF_COMMAND_NV             = 0x000C
    LINE_WIDTH_COMMAND_NV              = 0x000D
    POLYGON_OFFSET_COMMAND_NV          = 0x000E
    ALPHA_REF_COMMAND_NV               = 0x000F
    VIEWPORT_COMMAND_NV                = 0x0010
    SCISSOR_COMMAND_NV                 = 0x0011
    FRONT_FACE_COMMAND_NV              = 0x0012
  end
  
  Functions = {
    def glCreateStatesNV(n, states) end => [ :void, :GLsizei, :pointer ].freeze,
    def glDeleteStatesNV(n, states) end => [ :void, :GLsizei, :pointer ].freeze,
    def glIsStateNV(state) end => [ :GLboolean, :GLuint ].freeze,
    def glStateCaptureNV(state, mode) end => [ :void, :GLuint, :GLenum ].freeze,
    def glGetCommandHeaderNV(tokenID, size) end => [ :GLuint, :GLenum, :GLuint ].freeze,
    def glGetStageIndexNV(shadertype) end => [ :GLushort, :GLenum ].freeze,
    def glDrawCommandsNV(primitiveMode, buffer, indirects, sizes, count) end => [ :void, :GLenum, :GLuint, :pointer, :pointer, :GLuint ].freeze,
    def glDrawCommandsAddressNV(primitiveMode, indirects, sizes, count) end => [ :void, :GLenum, :pointer, :pointer, :GLuint ].freeze,
    def glDrawCommandsStatesNV(buffer, indirects, sizes, states, fbos, count) end => [ :void, :GLuint, :pointer, :pointer, :pointer, :pointer, :GLuint ].freeze,
    def glDrawCommandsStatesAddressNV(indirects, sizes, states, fbos, count) end => [ :void, :pointer, :pointer, :pointer, :pointer, :GLuint ].freeze,
    def glCreateCommandListsNV(n, lists) end => [ :void, :GLsizei, :pointer ].freeze,
    def glDeleteCommandListsNV(n, lists) end => [ :void, :GLsizei, :pointer ].freeze,
    def glIsCommandListNV(list) end => [ :GLboolean, :GLuint ].freeze,
    def glListDrawCommandsStatesClientNV(list, segment, indirects, sizes, states, fbos, count) end => [ :void, :GLuint, :GLuint, :pointer, :pointer, :pointer, :pointer, :GLuint ].freeze,
    def glCommandListSegmentsNV(list, segments) end => [ :void, :GLuint, :GLuint ].freeze,
    def glCompileCommandListNV(list) end => [ :void, :GLuint ].freeze,
    def glCallCommandListNV(list) end => [ :void, :GLuint ].freeze,
  }.freeze
end