module GL_NV_evaluators
  module Constants
    EVAL_2D_NV                      = 0x86C0
    EVAL_TRIANGULAR_2D_NV           = 0x86C1
    MAP_TESSELLATION_NV             = 0x86C2
    MAP_ATTRIB_U_ORDER_NV           = 0x86C3
    MAP_ATTRIB_V_ORDER_NV           = 0x86C4
    EVAL_FRACTIONAL_TESSELLATION_NV = 0x86C5
    EVAL_VERTEX_ATTRIB0_NV          = 0x86C6
    EVAL_VERTEX_ATTRIB1_NV          = 0x86C7
    EVAL_VERTEX_ATTRIB2_NV          = 0x86C8
    EVAL_VERTEX_ATTRIB3_NV          = 0x86C9
    EVAL_VERTEX_ATTRIB4_NV          = 0x86CA
    EVAL_VERTEX_ATTRIB5_NV          = 0x86CB
    EVAL_VERTEX_ATTRIB6_NV          = 0x86CC
    EVAL_VERTEX_ATTRIB7_NV          = 0x86CD
    EVAL_VERTEX_ATTRIB8_NV          = 0x86CE
    EVAL_VERTEX_ATTRIB9_NV          = 0x86CF
    EVAL_VERTEX_ATTRIB10_NV         = 0x86D0
    EVAL_VERTEX_ATTRIB11_NV         = 0x86D1
    EVAL_VERTEX_ATTRIB12_NV         = 0x86D2
    EVAL_VERTEX_ATTRIB13_NV         = 0x86D3
    EVAL_VERTEX_ATTRIB14_NV         = 0x86D4
    EVAL_VERTEX_ATTRIB15_NV         = 0x86D5
    MAX_MAP_TESSELLATION_NV         = 0x86D6
    MAX_RATIONAL_EVAL_ORDER_NV      = 0x86D7
  end
  
  Functions = {
    def glMapControlPointsNV(target, index, type, ustride, vstride, uorder, vorder, packed, points) end => [ :void, :GLenum, :GLuint, :GLenum, :GLsizei, :GLsizei, :GLint, :GLint, :GLboolean, :pointer ].freeze,
    def glMapParameterivNV(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glMapParameterfvNV(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMapControlPointsNV(target, index, type, ustride, vstride, packed, points) end => [ :void, :GLenum, :GLuint, :GLenum, :GLsizei, :GLsizei, :GLboolean, :pointer ].freeze,
    def glGetMapParameterivNV(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMapParameterfvNV(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMapAttribParameterivNV(target, index, pname, params) end => [ :void, :GLenum, :GLuint, :GLenum, :pointer ].freeze,
    def glGetMapAttribParameterfvNV(target, index, pname, params) end => [ :void, :GLenum, :GLuint, :GLenum, :pointer ].freeze,
    def glEvalMapsNV(target, mode) end => [ :void, :GLenum, :GLenum ].freeze,
  }.freeze
end