module GL_NV_fragment_program
  module Constants
    MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV = 0x8868
    FRAGMENT_PROGRAM_NV                      = 0x8870
    MAX_TEXTURE_COORDS_NV                    = 0x8871
    MAX_TEXTURE_IMAGE_UNITS_NV               = 0x8872
    FRAGMENT_PROGRAM_BINDING_NV              = 0x8873
    PROGRAM_ERROR_STRING_NV                  = 0x8874
  end
  
  Functions = {
    def glProgramNamedParameter4fNV(id, len, name, x, y, z, w) end => [ :void, :GLuint, :GLsizei, :pointer, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramNamedParameter4fvNV(id, len, name, v) end => [ :void, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
    def glProgramNamedParameter4dNV(id, len, name, x, y, z, w) end => [ :void, :GLuint, :GLsizei, :pointer, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramNamedParameter4dvNV(id, len, name, v) end => [ :void, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
    def glGetProgramNamedParameterfvNV(id, len, name, params) end => [ :void, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
    def glGetProgramNamedParameterdvNV(id, len, name, params) end => [ :void, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
  }.freeze
end