module GL_NV_framebuffer_mixed_samples
  module Constants
    RASTER_MULTISAMPLE_EXT                = 0x9327
    COVERAGE_MODULATION_TABLE_NV          = 0x9331
    RASTER_SAMPLES_EXT                    = 0x9328
    MAX_RASTER_SAMPLES_EXT                = 0x9329
    RASTER_FIXED_SAMPLE_LOCATIONS_EXT     = 0x932A
    MULTISAMPLE_RASTERIZATION_ALLOWED_EXT = 0x932B
    EFFECTIVE_RASTER_SAMPLES_EXT          = 0x932C
    COLOR_SAMPLES_NV                      = 0x8E20
    DEPTH_SAMPLES_NV                      = 0x932D
    STENCIL_SAMPLES_NV                    = 0x932E
    MIXED_DEPTH_SAMPLES_SUPPORTED_NV      = 0x932F
    MIXED_STENCIL_SAMPLES_SUPPORTED_NV    = 0x9330
    COVERAGE_MODULATION_NV                = 0x9332
    COVERAGE_MODULATION_TABLE_SIZE_NV     = 0x9333
  end
  
  Functions = {
    def glRasterSamplesEXT(samples, fixedsamplelocations) end => [ :void, :GLuint, :GLboolean ].freeze,
    def glCoverageModulationTableNV(n, v) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGetCoverageModulationTableNV(bufsize, v) end => [ :void, :GLsizei, :pointer ].freeze,
    def glCoverageModulationNV(components) end => [ :void, :GLenum ].freeze,
  }.freeze
end