module GL_NV_gpu_multicast
  module Constants
    PER_GPU_STORAGE_BIT_NV                    = 0x0800
    MULTICAST_GPUS_NV                         = 0x92BA
    RENDER_GPU_MASK_NV                        = 0x9558
    PER_GPU_STORAGE_NV                        = 0x9548
    MULTICAST_PROGRAMMABLE_SAMPLE_LOCATION_NV = 0x9549
  end
  
  Functions = {
    def glRenderGpuMaskNV(mask) end => [ :void, :GLbitfield ].freeze,
    def glMulticastBufferSubDataNV(gpuMask, buffer, offset, size, data) end => [ :void, :GLbitfield, :GLuint, :GLintptr, :GLsizeiptr, :pointer ].freeze,
    def glMulticastCopyBufferSubDataNV(readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size) end => [ :void, :GLuint, :GLbitfield, :GLuint, :GLuint, :GLintptr, :GLintptr, :GLsizeiptr ].freeze,
    def glMulticastCopyImageSubDataNV(srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth) end => [ :void, :GLuint, :GLbitfield, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLuint, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei ].freeze,
    def glMulticastBlitFramebufferNV(srcGpu, dstGpu, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter) end => [ :void, :GLuint, :GLuint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLbitfield, :GLenum ].freeze,
    def glMulticastFramebufferSampleLocationsfvNV(gpu, framebuffer, start, count, v) end => [ :void, :GLuint, :GLuint, :GLuint, :GLsizei, :pointer ].freeze,
    def glMulticastBarrierNV() end => [ :void ].freeze,
    def glMulticastWaitSyncNV(signalGpu, waitGpuMask) end => [ :void, :GLuint, :GLbitfield ].freeze,
    def glMulticastGetQueryObjectivNV(gpu, id, pname, params) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glMulticastGetQueryObjectuivNV(gpu, id, pname, params) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glMulticastGetQueryObjecti64vNV(gpu, id, pname, params) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glMulticastGetQueryObjectui64vNV(gpu, id, pname, params) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
  }.freeze
end