module GL_NV_gpu_program4
  module Constants
    MIN_PROGRAM_TEXEL_OFFSET_NV      = 0x8904
    MAX_PROGRAM_TEXEL_OFFSET_NV      = 0x8905
    PROGRAM_ATTRIB_COMPONENTS_NV     = 0x8906
    PROGRAM_RESULT_COMPONENTS_NV     = 0x8907
    MAX_PROGRAM_ATTRIB_COMPONENTS_NV = 0x8908
    MAX_PROGRAM_RESULT_COMPONENTS_NV = 0x8909
    MAX_PROGRAM_GENERIC_ATTRIBS_NV   = 0x8DA5
    MAX_PROGRAM_GENERIC_RESULTS_NV   = 0x8DA6
  end
  
  Functions = {
    def glProgramLocalParameterI4iNV(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glProgramLocalParameterI4ivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramLocalParametersI4ivNV(target, index, count, params) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glProgramLocalParameterI4uiNV(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glProgramLocalParameterI4uivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramLocalParametersI4uivNV(target, index, count, params) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glProgramEnvParameterI4iNV(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glProgramEnvParameterI4ivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramEnvParametersI4ivNV(target, index, count, params) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glProgramEnvParameterI4uiNV(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLuint, :GLuint, :GLuint, :GLuint ].freeze,
    def glProgramEnvParameterI4uivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramEnvParametersI4uivNV(target, index, count, params) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glGetProgramLocalParameterIivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramLocalParameterIuivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramEnvParameterIivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGetProgramEnvParameterIuivNV(target, index, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
  }.freeze
end