module GL_NV_half_float
  module Constants
    HALF_FLOAT_NV = 0x140B
  end
  
  Functions = {
    def glVertex2hNV(x, y) end => [ :void, :GLhalfNV, :GLhalfNV ].freeze,
    def glVertex2hvNV(v) end => [ :void, :pointer ].freeze,
    def glVertex3hNV(x, y, z) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glVertex3hvNV(v) end => [ :void, :pointer ].freeze,
    def glVertex4hNV(x, y, z, w) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glVertex4hvNV(v) end => [ :void, :pointer ].freeze,
    def glNormal3hNV(nx, ny, nz) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glNormal3hvNV(v) end => [ :void, :pointer ].freeze,
    def glColor3hNV(red, green, blue) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glColor3hvNV(v) end => [ :void, :pointer ].freeze,
    def glColor4hNV(red, green, blue, alpha) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glColor4hvNV(v) end => [ :void, :pointer ].freeze,
    def glTexCoord1hNV(s) end => [ :void, :GLhalfNV ].freeze,
    def glTexCoord1hvNV(v) end => [ :void, :pointer ].freeze,
    def glTexCoord2hNV(s, t) end => [ :void, :GLhalfNV, :GLhalfNV ].freeze,
    def glTexCoord2hvNV(v) end => [ :void, :pointer ].freeze,
    def glTexCoord3hNV(s, t, r) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glTexCoord3hvNV(v) end => [ :void, :pointer ].freeze,
    def glTexCoord4hNV(s, t, r, q) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glTexCoord4hvNV(v) end => [ :void, :pointer ].freeze,
    def glMultiTexCoord1hNV(target, s) end => [ :void, :GLenum, :GLhalfNV ].freeze,
    def glMultiTexCoord1hvNV(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord2hNV(target, s, t) end => [ :void, :GLenum, :GLhalfNV, :GLhalfNV ].freeze,
    def glMultiTexCoord2hvNV(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord3hNV(target, s, t, r) end => [ :void, :GLenum, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glMultiTexCoord3hvNV(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord4hNV(target, s, t, r, q) end => [ :void, :GLenum, :GLhalfNV, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glMultiTexCoord4hvNV(target, v) end => [ :void, :GLenum, :pointer ].freeze,
    def glFogCoordhNV(fog) end => [ :void, :GLhalfNV ].freeze,
    def glFogCoordhvNV(fog) end => [ :void, :pointer ].freeze,
    def glSecondaryColor3hNV(red, green, blue) end => [ :void, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glSecondaryColor3hvNV(v) end => [ :void, :pointer ].freeze,
    def glVertexWeighthNV(weight) end => [ :void, :GLhalfNV ].freeze,
    def glVertexWeighthvNV(weight) end => [ :void, :pointer ].freeze,
    def glVertexAttrib1hNV(index, x) end => [ :void, :GLuint, :GLhalfNV ].freeze,
    def glVertexAttrib1hvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2hNV(index, x, y) end => [ :void, :GLuint, :GLhalfNV, :GLhalfNV ].freeze,
    def glVertexAttrib2hvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3hNV(index, x, y, z) end => [ :void, :GLuint, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glVertexAttrib3hvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4hNV(index, x, y, z, w) end => [ :void, :GLuint, :GLhalfNV, :GLhalfNV, :GLhalfNV, :GLhalfNV ].freeze,
    def glVertexAttrib4hvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribs1hvNV(index, n, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs2hvNV(index, n, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs3hvNV(index, n, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs4hvNV(index, n, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
  }.freeze
end