module GL_NV_path_rendering
  module Constants
    PATH_FORMAT_SVG_NV                      = 0x9070
    PATH_FORMAT_PS_NV                       = 0x9071
    STANDARD_FONT_NAME_NV                   = 0x9072
    SYSTEM_FONT_NAME_NV                     = 0x9073
    FILE_NAME_NV                            = 0x9074
    PATH_STROKE_WIDTH_NV                    = 0x9075
    PATH_END_CAPS_NV                        = 0x9076
    PATH_INITIAL_END_CAP_NV                 = 0x9077
    PATH_TERMINAL_END_CAP_NV                = 0x9078
    PATH_JOIN_STYLE_NV                      = 0x9079
    PATH_MITER_LIMIT_NV                     = 0x907A
    PATH_DASH_CAPS_NV                       = 0x907B
    PATH_INITIAL_DASH_CAP_NV                = 0x907C
    PATH_TERMINAL_DASH_CAP_NV               = 0x907D
    PATH_DASH_OFFSET_NV                     = 0x907E
    PATH_CLIENT_LENGTH_NV                   = 0x907F
    PATH_FILL_MODE_NV                       = 0x9080
    PATH_FILL_MASK_NV                       = 0x9081
    PATH_FILL_COVER_MODE_NV                 = 0x9082
    PATH_STROKE_COVER_MODE_NV               = 0x9083
    PATH_STROKE_MASK_NV                     = 0x9084
    COUNT_UP_NV                             = 0x9088
    COUNT_DOWN_NV                           = 0x9089
    PATH_OBJECT_BOUNDING_BOX_NV             = 0x908A
    CONVEX_HULL_NV                          = 0x908B
    BOUNDING_BOX_NV                         = 0x908D
    TRANSLATE_X_NV                          = 0x908E
    TRANSLATE_Y_NV                          = 0x908F
    TRANSLATE_2D_NV                         = 0x9090
    TRANSLATE_3D_NV                         = 0x9091
    AFFINE_2D_NV                            = 0x9092
    AFFINE_3D_NV                            = 0x9094
    TRANSPOSE_AFFINE_2D_NV                  = 0x9096
    TRANSPOSE_AFFINE_3D_NV                  = 0x9098
    UTF8_NV                                 = 0x909A
    UTF16_NV                                = 0x909B
    BOUNDING_BOX_OF_BOUNDING_BOXES_NV       = 0x909C
    PATH_COMMAND_COUNT_NV                   = 0x909D
    PATH_COORD_COUNT_NV                     = 0x909E
    PATH_DASH_ARRAY_COUNT_NV                = 0x909F
    PATH_COMPUTED_LENGTH_NV                 = 0x90A0
    PATH_FILL_BOUNDING_BOX_NV               = 0x90A1
    PATH_STROKE_BOUNDING_BOX_NV             = 0x90A2
    SQUARE_NV                               = 0x90A3
    ROUND_NV                                = 0x90A4
    TRIANGULAR_NV                           = 0x90A5
    BEVEL_NV                                = 0x90A6
    MITER_REVERT_NV                         = 0x90A7
    MITER_TRUNCATE_NV                       = 0x90A8
    SKIP_MISSING_GLYPH_NV                   = 0x90A9
    USE_MISSING_GLYPH_NV                    = 0x90AA
    PATH_ERROR_POSITION_NV                  = 0x90AB
    ACCUM_ADJACENT_PAIRS_NV                 = 0x90AD
    ADJACENT_PAIRS_NV                       = 0x90AE
    FIRST_TO_REST_NV                        = 0x90AF
    PATH_GEN_MODE_NV                        = 0x90B0
    PATH_GEN_COEFF_NV                       = 0x90B1
    PATH_GEN_COMPONENTS_NV                  = 0x90B3
    PATH_STENCIL_FUNC_NV                    = 0x90B7
    PATH_STENCIL_REF_NV                     = 0x90B8
    PATH_STENCIL_VALUE_MASK_NV              = 0x90B9
    PATH_STENCIL_DEPTH_OFFSET_FACTOR_NV     = 0x90BD
    PATH_STENCIL_DEPTH_OFFSET_UNITS_NV      = 0x90BE
    PATH_COVER_DEPTH_FUNC_NV                = 0x90BF
    PATH_DASH_OFFSET_RESET_NV               = 0x90B4
    MOVE_TO_RESETS_NV                       = 0x90B5
    MOVE_TO_CONTINUES_NV                    = 0x90B6
    CLOSE_PATH_NV                           = 0x00
    MOVE_TO_NV                              = 0x02
    RELATIVE_MOVE_TO_NV                     = 0x03
    LINE_TO_NV                              = 0x04
    RELATIVE_LINE_TO_NV                     = 0x05
    HORIZONTAL_LINE_TO_NV                   = 0x06
    RELATIVE_HORIZONTAL_LINE_TO_NV          = 0x07
    VERTICAL_LINE_TO_NV                     = 0x08
    RELATIVE_VERTICAL_LINE_TO_NV            = 0x09
    QUADRATIC_CURVE_TO_NV                   = 0x0A
    RELATIVE_QUADRATIC_CURVE_TO_NV          = 0x0B
    CUBIC_CURVE_TO_NV                       = 0x0C
    RELATIVE_CUBIC_CURVE_TO_NV              = 0x0D
    SMOOTH_QUADRATIC_CURVE_TO_NV            = 0x0E
    RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV   = 0x0F
    SMOOTH_CUBIC_CURVE_TO_NV                = 0x10
    RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV       = 0x11
    SMALL_CCW_ARC_TO_NV                     = 0x12
    RELATIVE_SMALL_CCW_ARC_TO_NV            = 0x13
    SMALL_CW_ARC_TO_NV                      = 0x14
    RELATIVE_SMALL_CW_ARC_TO_NV             = 0x15
    LARGE_CCW_ARC_TO_NV                     = 0x16
    RELATIVE_LARGE_CCW_ARC_TO_NV            = 0x17
    LARGE_CW_ARC_TO_NV                      = 0x18
    RELATIVE_LARGE_CW_ARC_TO_NV             = 0x19
    RESTART_PATH_NV                         = 0xF0
    DUP_FIRST_CUBIC_CURVE_TO_NV             = 0xF2
    DUP_LAST_CUBIC_CURVE_TO_NV              = 0xF4
    RECT_NV                                 = 0xF6
    CIRCULAR_CCW_ARC_TO_NV                  = 0xF8
    CIRCULAR_CW_ARC_TO_NV                   = 0xFA
    CIRCULAR_TANGENT_ARC_TO_NV              = 0xFC
    ARC_TO_NV                               = 0xFE
    RELATIVE_ARC_TO_NV                      = 0xFF
    BOLD_BIT_NV                             = 0x01
    ITALIC_BIT_NV                           = 0x02
    GLYPH_WIDTH_BIT_NV                      = 0x01
    GLYPH_HEIGHT_BIT_NV                     = 0x02
    GLYPH_HORIZONTAL_BEARING_X_BIT_NV       = 0x04
    GLYPH_HORIZONTAL_BEARING_Y_BIT_NV       = 0x08
    GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV = 0x10
    GLYPH_VERTICAL_BEARING_X_BIT_NV         = 0x20
    GLYPH_VERTICAL_BEARING_Y_BIT_NV         = 0x40
    GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV   = 0x80
    GLYPH_HAS_KERNING_BIT_NV                = 0x100
    FONT_X_MIN_BOUNDS_BIT_NV                = 0x00010000
    FONT_Y_MIN_BOUNDS_BIT_NV                = 0x00020000
    FONT_X_MAX_BOUNDS_BIT_NV                = 0x00040000
    FONT_Y_MAX_BOUNDS_BIT_NV                = 0x00080000
    FONT_UNITS_PER_EM_BIT_NV                = 0x00100000
    FONT_ASCENDER_BIT_NV                    = 0x00200000
    FONT_DESCENDER_BIT_NV                   = 0x00400000
    FONT_HEIGHT_BIT_NV                      = 0x00800000
    FONT_MAX_ADVANCE_WIDTH_BIT_NV           = 0x01000000
    FONT_MAX_ADVANCE_HEIGHT_BIT_NV          = 0x02000000
    FONT_UNDERLINE_POSITION_BIT_NV          = 0x04000000
    FONT_UNDERLINE_THICKNESS_BIT_NV         = 0x08000000
    FONT_HAS_KERNING_BIT_NV                 = 0x10000000
    ROUNDED_RECT_NV                         = 0xE8
    RELATIVE_ROUNDED_RECT_NV                = 0xE9
    ROUNDED_RECT2_NV                        = 0xEA
    RELATIVE_ROUNDED_RECT2_NV               = 0xEB
    ROUNDED_RECT4_NV                        = 0xEC
    RELATIVE_ROUNDED_RECT4_NV               = 0xED
    ROUNDED_RECT8_NV                        = 0xEE
    RELATIVE_ROUNDED_RECT8_NV               = 0xEF
    RELATIVE_RECT_NV                        = 0xF7
    FONT_GLYPHS_AVAILABLE_NV                = 0x9368
    FONT_TARGET_UNAVAILABLE_NV              = 0x9369
    FONT_UNAVAILABLE_NV                     = 0x936A
    FONT_UNINTELLIGIBLE_NV                  = 0x936B
    CONIC_CURVE_TO_NV                       = 0x1A
    RELATIVE_CONIC_CURVE_TO_NV              = 0x1B
    FONT_NUM_GLYPH_INDICES_BIT_NV           = 0x20000000
    STANDARD_FONT_FORMAT_NV                 = 0x936C
    N2_BYTES_NV                             = 0x1407
    N3_BYTES_NV                             = 0x1408
    N4_BYTES_NV                             = 0x1409
    EYE_LINEAR_NV                           = 0x2400
    OBJECT_LINEAR_NV                        = 0x2401
    CONSTANT_NV                             = 0x8576
    PATH_FOG_GEN_MODE_NV                    = 0x90AC
    PRIMARY_COLOR                           = 0x8577
    PRIMARY_COLOR_NV                        = 0x852C
    SECONDARY_COLOR_NV                      = 0x852D
    PATH_GEN_COLOR_FORMAT_NV                = 0x90B2
    PATH_PROJECTION_NV                      = 0x1701
    PATH_MODELVIEW_NV                       = 0x1700
    PATH_MODELVIEW_STACK_DEPTH_NV           = 0x0BA3
    PATH_MODELVIEW_MATRIX_NV                = 0x0BA6
    PATH_MAX_MODELVIEW_STACK_DEPTH_NV       = 0x0D36
    PATH_TRANSPOSE_MODELVIEW_MATRIX_NV      = 0x84E3
    PATH_PROJECTION_STACK_DEPTH_NV          = 0x0BA4
    PATH_PROJECTION_MATRIX_NV               = 0x0BA7
    PATH_MAX_PROJECTION_STACK_DEPTH_NV      = 0x0D38
    PATH_TRANSPOSE_PROJECTION_MATRIX_NV     = 0x84E4
    FRAGMENT_INPUT_NV                       = 0x936D
  end
  
  Functions = {
    def glGenPathsNV(range) end => [ :GLuint, :GLsizei ].freeze,
    def glDeletePathsNV(path, range) end => [ :void, :GLuint, :GLsizei ].freeze,
    def glIsPathNV(path) end => [ :GLboolean, :GLuint ].freeze,
    def glPathCommandsNV(path, numCommands, commands, numCoords, coordType, coords) end => [ :void, :GLuint, :GLsizei, :pointer, :GLsizei, :GLenum, :pointer ].freeze,
    def glPathCoordsNV(path, numCoords, coordType, coords) end => [ :void, :GLuint, :GLsizei, :GLenum, :pointer ].freeze,
    def glPathSubCommandsNV(path, commandStart, commandsToDelete, numCommands, commands, numCoords, coordType, coords) end => [ :void, :GLuint, :GLsizei, :GLsizei, :GLsizei, :pointer, :GLsizei, :GLenum, :pointer ].freeze,
    def glPathSubCoordsNV(path, coordStart, numCoords, coordType, coords) end => [ :void, :GLuint, :GLsizei, :GLsizei, :GLenum, :pointer ].freeze,
    def glPathStringNV(path, format, length, pathString) end => [ :void, :GLuint, :GLenum, :GLsizei, :pointer ].freeze,
    def glPathGlyphsNV(firstPathName, fontTarget, fontName, fontStyle, numGlyphs, type, charcodes, handleMissingGlyphs, pathParameterTemplate, emScale) end => [ :void, :GLuint, :GLenum, :pointer, :GLbitfield, :GLsizei, :GLenum, :pointer, :GLenum, :GLuint, :GLfloat ].freeze,
    def glPathGlyphRangeNV(firstPathName, fontTarget, fontName, fontStyle, firstGlyph, numGlyphs, handleMissingGlyphs, pathParameterTemplate, emScale) end => [ :void, :GLuint, :GLenum, :pointer, :GLbitfield, :GLuint, :GLsizei, :GLenum, :GLuint, :GLfloat ].freeze,
    def glWeightPathsNV(resultPath, numPaths, paths, weights) end => [ :void, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
    def glCopyPathNV(resultPath, srcPath) end => [ :void, :GLuint, :GLuint ].freeze,
    def glInterpolatePathsNV(resultPath, pathA, pathB, weight) end => [ :void, :GLuint, :GLuint, :GLuint, :GLfloat ].freeze,
    def glTransformPathNV(resultPath, srcPath, transformType, transformValues) end => [ :void, :GLuint, :GLuint, :GLenum, :pointer ].freeze,
    def glPathParameterivNV(path, pname, value) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glPathParameteriNV(path, pname, value) end => [ :void, :GLuint, :GLenum, :GLint ].freeze,
    def glPathParameterfvNV(path, pname, value) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glPathParameterfNV(path, pname, value) end => [ :void, :GLuint, :GLenum, :GLfloat ].freeze,
    def glPathDashArrayNV(path, dashCount, dashArray) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glPathStencilFuncNV(func, ref, mask) end => [ :void, :GLenum, :GLint, :GLuint ].freeze,
    def glPathStencilDepthOffsetNV(factor, units) end => [ :void, :GLfloat, :GLfloat ].freeze,
    def glStencilFillPathNV(path, fillMode, mask) end => [ :void, :GLuint, :GLenum, :GLuint ].freeze,
    def glStencilStrokePathNV(path, reference, mask) end => [ :void, :GLuint, :GLint, :GLuint ].freeze,
    def glStencilFillPathInstancedNV(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues) end => [ :void, :GLsizei, :GLenum, :pointer, :GLuint, :GLenum, :GLuint, :GLenum, :pointer ].freeze,
    def glStencilStrokePathInstancedNV(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues) end => [ :void, :GLsizei, :GLenum, :pointer, :GLuint, :GLint, :GLuint, :GLenum, :pointer ].freeze,
    def glPathCoverDepthFuncNV(func) end => [ :void, :GLenum ].freeze,
    def glCoverFillPathNV(path, coverMode) end => [ :void, :GLuint, :GLenum ].freeze,
    def glCoverStrokePathNV(path, coverMode) end => [ :void, :GLuint, :GLenum ].freeze,
    def glCoverFillPathInstancedNV(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues) end => [ :void, :GLsizei, :GLenum, :pointer, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glCoverStrokePathInstancedNV(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues) end => [ :void, :GLsizei, :GLenum, :pointer, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glGetPathParameterivNV(path, pname, value) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetPathParameterfvNV(path, pname, value) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetPathCommandsNV(path, commands) end => [ :void, :GLuint, :pointer ].freeze,
    def glGetPathCoordsNV(path, coords) end => [ :void, :GLuint, :pointer ].freeze,
    def glGetPathDashArrayNV(path, dashArray) end => [ :void, :GLuint, :pointer ].freeze,
    def glGetPathMetricsNV(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics) end => [ :void, :GLbitfield, :GLsizei, :GLenum, :pointer, :GLuint, :GLsizei, :pointer ].freeze,
    def glGetPathMetricRangeNV(metricQueryMask, firstPathName, numPaths, stride, metrics) end => [ :void, :GLbitfield, :GLuint, :GLsizei, :GLsizei, :pointer ].freeze,
    def glGetPathSpacingNV(pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing) end => [ :void, :GLenum, :GLsizei, :GLenum, :pointer, :GLuint, :GLfloat, :GLfloat, :GLenum, :pointer ].freeze,
    def glIsPointInFillPathNV(path, mask, x, y) end => [ :GLboolean, :GLuint, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glIsPointInStrokePathNV(path, x, y) end => [ :GLboolean, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glGetPathLengthNV(path, startSegment, numSegments) end => [ :GLfloat, :GLuint, :GLsizei, :GLsizei ].freeze,
    def glPointAlongPathNV(path, startSegment, numSegments, distance, x, y, tangentX, tangentY) end => [ :GLboolean, :GLuint, :GLsizei, :GLsizei, :GLfloat, :pointer, :pointer, :pointer, :pointer ].freeze,
    def glMatrixLoad3x2fNV(matrixMode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoad3x3fNV(matrixMode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoadTranspose3x3fNV(matrixMode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMult3x2fNV(matrixMode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMult3x3fNV(matrixMode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultTranspose3x3fNV(matrixMode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glStencilThenCoverFillPathNV(path, fillMode, mask, coverMode) end => [ :void, :GLuint, :GLenum, :GLuint, :GLenum ].freeze,
    def glStencilThenCoverStrokePathNV(path, reference, mask, coverMode) end => [ :void, :GLuint, :GLint, :GLuint, :GLenum ].freeze,
    def glStencilThenCoverFillPathInstancedNV(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues) end => [ :void, :GLsizei, :GLenum, :pointer, :GLuint, :GLenum, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glStencilThenCoverStrokePathInstancedNV(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues) end => [ :void, :GLsizei, :GLenum, :pointer, :GLuint, :GLint, :GLuint, :GLenum, :GLenum, :pointer ].freeze,
    def glPathGlyphIndexRangeNV(fontTarget, fontName, fontStyle, pathParameterTemplate, emScale, baseAndCount) end => [ :GLenum, :GLenum, :pointer, :GLbitfield, :GLuint, :GLfloat, :pointer ].freeze,
    def glPathGlyphIndexArrayNV(firstPathName, fontTarget, fontName, fontStyle, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale) end => [ :GLenum, :GLuint, :GLenum, :pointer, :GLbitfield, :GLuint, :GLsizei, :GLuint, :GLfloat ].freeze,
    def glPathMemoryGlyphIndexArrayNV(firstPathName, fontTarget, fontSize, fontData, faceIndex, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale) end => [ :GLenum, :GLuint, :GLenum, :GLsizeiptr, :pointer, :GLsizei, :GLuint, :GLsizei, :GLuint, :GLfloat ].freeze,
    def glProgramPathFragmentInputGenNV(program, location, genMode, components, coeffs) end => [ :void, :GLuint, :GLint, :GLenum, :GLint, :pointer ].freeze,
    def glGetProgramResourcefvNV(program, programInterface, index, propCount, props, bufSize, length, params) end => [ :void, :GLuint, :GLenum, :GLuint, :GLsizei, :pointer, :GLsizei, :pointer, :pointer ].freeze,
    def glPathColorGenNV(color, genMode, colorFormat, coeffs) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glPathTexGenNV(texCoordSet, genMode, components, coeffs) end => [ :void, :GLenum, :GLenum, :GLint, :pointer ].freeze,
    def glPathFogGenNV(genMode) end => [ :void, :GLenum ].freeze,
    def glGetPathColorGenivNV(color, pname, value) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetPathColorGenfvNV(color, pname, value) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetPathTexGenivNV(texCoordSet, pname, value) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetPathTexGenfvNV(texCoordSet, pname, value) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glMatrixFrustumEXT(mode, left, right, bottom, top, zNear, zFar) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixLoadIdentityEXT(mode) end => [ :void, :GLenum ].freeze,
    def glMatrixLoadTransposefEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoadTransposedEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoadfEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixLoaddEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultTransposefEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultTransposedEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultfEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixMultdEXT(mode, m) end => [ :void, :GLenum, :pointer ].freeze,
    def glMatrixOrthoEXT(mode, left, right, bottom, top, zNear, zFar) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixPopEXT(mode) end => [ :void, :GLenum ].freeze,
    def glMatrixPushEXT(mode) end => [ :void, :GLenum ].freeze,
    def glMatrixRotatefEXT(mode, angle, x, y, z) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMatrixRotatedEXT(mode, angle, x, y, z) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixScalefEXT(mode, x, y, z) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMatrixScaledEXT(mode, x, y, z) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glMatrixTranslatefEXT(mode, x, y, z) end => [ :void, :GLenum, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glMatrixTranslatedEXT(mode, x, y, z) end => [ :void, :GLenum, :GLdouble, :GLdouble, :GLdouble ].freeze,
  }.freeze
end