module GL_NV_shader_buffer_load
  module Constants
    BUFFER_GPU_ADDRESS_NV        = 0x8F1D
    GPU_ADDRESS_NV               = 0x8F34
    MAX_SHADER_BUFFER_ADDRESS_NV = 0x8F35
  end
  
  Functions = {
    def glMakeBufferResidentNV(target, access) end => [ :void, :GLenum, :GLenum ].freeze,
    def glMakeBufferNonResidentNV(target) end => [ :void, :GLenum ].freeze,
    def glIsBufferResidentNV(target) end => [ :GLboolean, :GLenum ].freeze,
    def glMakeNamedBufferResidentNV(buffer, access) end => [ :void, :GLuint, :GLenum ].freeze,
    def glMakeNamedBufferNonResidentNV(buffer) end => [ :void, :GLuint ].freeze,
    def glIsNamedBufferResidentNV(buffer) end => [ :GLboolean, :GLuint ].freeze,
    def glGetBufferParameterui64vNV(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetNamedBufferParameterui64vNV(buffer, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetIntegerui64vNV(value, result) end => [ :void, :GLenum, :pointer ].freeze,
    def glUniformui64NV(location, value) end => [ :void, :GLint, :GLuint64EXT ].freeze,
    def glUniformui64vNV(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glGetUniformui64vNV(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glProgramUniformui64NV(program, location, value) end => [ :void, :GLuint, :GLint, :GLuint64EXT ].freeze,
    def glProgramUniformui64vNV(program, location, count, value) end => [ :void, :GLuint, :GLint, :GLsizei, :pointer ].freeze,
  }.freeze
end