module GL_NV_transform_feedback
  module Constants
    BACK_PRIMARY_COLOR_NV                            = 0x8C77
    BACK_SECONDARY_COLOR_NV                          = 0x8C78
    TEXTURE_COORD_NV                                 = 0x8C79
    CLIP_DISTANCE_NV                                 = 0x8C7A
    VERTEX_ID_NV                                     = 0x8C7B
    PRIMITIVE_ID_NV                                  = 0x8C7C
    GENERIC_ATTRIB_NV                                = 0x8C7D
    TRANSFORM_FEEDBACK_ATTRIBS_NV                    = 0x8C7E
    TRANSFORM_FEEDBACK_BUFFER_MODE_NV                = 0x8C7F
    MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_NV    = 0x8C80
    ACTIVE_VARYINGS_NV                               = 0x8C81
    ACTIVE_VARYING_MAX_LENGTH_NV                     = 0x8C82
    TRANSFORM_FEEDBACK_VARYINGS_NV                   = 0x8C83
    TRANSFORM_FEEDBACK_BUFFER_START_NV               = 0x8C84
    TRANSFORM_FEEDBACK_BUFFER_SIZE_NV                = 0x8C85
    TRANSFORM_FEEDBACK_RECORD_NV                     = 0x8C86
    PRIMITIVES_GENERATED_NV                          = 0x8C87
    TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_NV         = 0x8C88
    RASTERIZER_DISCARD_NV                            = 0x8C89
    MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_NV = 0x8C8A
    MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_NV       = 0x8C8B
    INTERLEAVED_ATTRIBS_NV                           = 0x8C8C
    SEPARATE_ATTRIBS_NV                              = 0x8C8D
    TRANSFORM_FEEDBACK_BUFFER_NV                     = 0x8C8E
    TRANSFORM_FEEDBACK_BUFFER_BINDING_NV             = 0x8C8F
    LAYER_NV                                         = 0x8DAA
    NEXT_BUFFER_NV                                   = -2
    SKIP_COMPONENTS4_NV                              = -3
    SKIP_COMPONENTS3_NV                              = -4
    SKIP_COMPONENTS2_NV                              = -5
    SKIP_COMPONENTS1_NV                              = -6
  end
  
  Functions = {
    def glBeginTransformFeedbackNV(primitiveMode) end => [ :void, :GLenum ].freeze,
    def glEndTransformFeedbackNV() end => [ :void ].freeze,
    def glTransformFeedbackAttribsNV(count, attribs, bufferMode) end => [ :void, :GLsizei, :pointer, :GLenum ].freeze,
    def glBindBufferRangeNV(target, index, buffer, offset, size) end => [ :void, :GLenum, :GLuint, :GLuint, :GLintptr, :GLsizeiptr ].freeze,
    def glBindBufferOffsetNV(target, index, buffer, offset) end => [ :void, :GLenum, :GLuint, :GLuint, :GLintptr ].freeze,
    def glBindBufferBaseNV(target, index, buffer) end => [ :void, :GLenum, :GLuint, :GLuint ].freeze,
    def glTransformFeedbackVaryingsNV(program, count, locations, bufferMode) end => [ :void, :GLuint, :GLsizei, :pointer, :GLenum ].freeze,
    def glActiveVaryingNV(program, name) end => [ :void, :GLuint, :string ].freeze,
    def glGetVaryingLocationNV(program, name) end => [ :GLint, :GLuint, :string ].freeze,
    def glGetActiveVaryingNV(program, index, bufSize, length, size, type, name) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :string ].freeze,
    def glGetTransformFeedbackVaryingNV(program, index, location) end => [ :void, :GLuint, :GLuint, :pointer ].freeze,
    def glTransformFeedbackStreamAttribsNV(count, attribs, nbuffers, bufstreams, bufferMode) end => [ :void, :GLsizei, :pointer, :GLsizei, :pointer, :GLenum ].freeze,
  }.freeze
end