module GL_NV_vdpau_interop
  module Constants
    SURFACE_STATE_NV      = 0x86EB
    SURFACE_REGISTERED_NV = 0x86FD
    SURFACE_MAPPED_NV     = 0x8700
    WRITE_DISCARD_NV      = 0x88BE
  end
  
  Functions = {
    def glVDPAUInitNV(vdpDevice, getProcAddress) end => [ :void, :pointer, :pointer ].freeze,
    def glVDPAUFiniNV() end => [ :void ].freeze,
    def glVDPAURegisterVideoSurfaceNV(vdpSurface, target, numTextureNames, textureNames) end => [ :GLvdpauSurfaceNV, :pointer, :GLenum, :GLsizei, :pointer ].freeze,
    def glVDPAURegisterOutputSurfaceNV(vdpSurface, target, numTextureNames, textureNames) end => [ :GLvdpauSurfaceNV, :pointer, :GLenum, :GLsizei, :pointer ].freeze,
    def glVDPAUIsSurfaceNV(surface) end => [ :GLboolean, :GLvdpauSurfaceNV ].freeze,
    def glVDPAUUnregisterSurfaceNV(surface) end => [ :void, :GLvdpauSurfaceNV ].freeze,
    def glVDPAUGetSurfaceivNV(surface, pname, bufSize, length, values) end => [ :void, :GLvdpauSurfaceNV, :GLenum, :GLsizei, :pointer, :pointer ].freeze,
    def glVDPAUSurfaceAccessNV(surface, access) end => [ :void, :GLvdpauSurfaceNV, :GLenum ].freeze,
    def glVDPAUMapSurfacesNV(numSurfaces, surfaces) end => [ :void, :GLsizei, :pointer ].freeze,
    def glVDPAUUnmapSurfacesNV(numSurface, surfaces) end => [ :void, :GLsizei, :pointer ].freeze,
  }.freeze
end