module GL_NV_vertex_attrib_integer_64bit
  module Constants
    INT64_NV          = 0x140E
    UNSIGNED_INT64_NV = 0x140F
  end
  
  Functions = {
    def glVertexAttribL1i64NV(index, x) end => [ :void, :GLuint, :GLint64EXT ].freeze,
    def glVertexAttribL2i64NV(index, x, y) end => [ :void, :GLuint, :GLint64EXT, :GLint64EXT ].freeze,
    def glVertexAttribL3i64NV(index, x, y, z) end => [ :void, :GLuint, :GLint64EXT, :GLint64EXT, :GLint64EXT ].freeze,
    def glVertexAttribL4i64NV(index, x, y, z, w) end => [ :void, :GLuint, :GLint64EXT, :GLint64EXT, :GLint64EXT, :GLint64EXT ].freeze,
    def glVertexAttribL1i64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL2i64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL3i64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL4i64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL1ui64NV(index, x) end => [ :void, :GLuint, :GLuint64EXT ].freeze,
    def glVertexAttribL2ui64NV(index, x, y) end => [ :void, :GLuint, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glVertexAttribL3ui64NV(index, x, y, z) end => [ :void, :GLuint, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glVertexAttribL4ui64NV(index, x, y, z, w) end => [ :void, :GLuint, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT, :GLuint64EXT ].freeze,
    def glVertexAttribL1ui64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL2ui64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL3ui64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribL4ui64vNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glGetVertexAttribLi64vNV(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribLui64vNV(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glVertexAttribLFormatNV(index, size, type, stride) end => [ :void, :GLuint, :GLint, :GLenum, :GLsizei ].freeze,
  }.freeze
end