module GL_NV_vertex_buffer_unified_memory
  module Constants
    VERTEX_ATTRIB_ARRAY_UNIFIED_NV   = 0x8F1E
    ELEMENT_ARRAY_UNIFIED_NV         = 0x8F1F
    VERTEX_ATTRIB_ARRAY_ADDRESS_NV   = 0x8F20
    VERTEX_ARRAY_ADDRESS_NV          = 0x8F21
    NORMAL_ARRAY_ADDRESS_NV          = 0x8F22
    COLOR_ARRAY_ADDRESS_NV           = 0x8F23
    INDEX_ARRAY_ADDRESS_NV           = 0x8F24
    TEXTURE_COORD_ARRAY_ADDRESS_NV   = 0x8F25
    EDGE_FLAG_ARRAY_ADDRESS_NV       = 0x8F26
    SECONDARY_COLOR_ARRAY_ADDRESS_NV = 0x8F27
    FOG_COORD_ARRAY_ADDRESS_NV       = 0x8F28
    ELEMENT_ARRAY_ADDRESS_NV         = 0x8F29
    VERTEX_ATTRIB_ARRAY_LENGTH_NV    = 0x8F2A
    VERTEX_ARRAY_LENGTH_NV           = 0x8F2B
    NORMAL_ARRAY_LENGTH_NV           = 0x8F2C
    COLOR_ARRAY_LENGTH_NV            = 0x8F2D
    INDEX_ARRAY_LENGTH_NV            = 0x8F2E
    TEXTURE_COORD_ARRAY_LENGTH_NV    = 0x8F2F
    EDGE_FLAG_ARRAY_LENGTH_NV        = 0x8F30
    SECONDARY_COLOR_ARRAY_LENGTH_NV  = 0x8F31
    FOG_COORD_ARRAY_LENGTH_NV        = 0x8F32
    ELEMENT_ARRAY_LENGTH_NV          = 0x8F33
    DRAW_INDIRECT_UNIFIED_NV         = 0x8F40
    DRAW_INDIRECT_ADDRESS_NV         = 0x8F41
    DRAW_INDIRECT_LENGTH_NV          = 0x8F42
  end
  
  Functions = {
    def glBufferAddressRangeNV(pname, index, address, length) end => [ :void, :GLenum, :GLuint, :GLuint64EXT, :GLsizeiptr ].freeze,
    def glVertexFormatNV(size, type, stride) end => [ :void, :GLint, :GLenum, :GLsizei ].freeze,
    def glNormalFormatNV(type, stride) end => [ :void, :GLenum, :GLsizei ].freeze,
    def glColorFormatNV(size, type, stride) end => [ :void, :GLint, :GLenum, :GLsizei ].freeze,
    def glIndexFormatNV(type, stride) end => [ :void, :GLenum, :GLsizei ].freeze,
    def glTexCoordFormatNV(size, type, stride) end => [ :void, :GLint, :GLenum, :GLsizei ].freeze,
    def glEdgeFlagFormatNV(stride) end => [ :void, :GLsizei ].freeze,
    def glSecondaryColorFormatNV(size, type, stride) end => [ :void, :GLint, :GLenum, :GLsizei ].freeze,
    def glFogCoordFormatNV(type, stride) end => [ :void, :GLenum, :GLsizei ].freeze,
    def glVertexAttribFormatNV(index, size, type, normalized, stride) end => [ :void, :GLuint, :GLint, :GLenum, :GLboolean, :GLsizei ].freeze,
    def glVertexAttribIFormatNV(index, size, type, stride) end => [ :void, :GLuint, :GLint, :GLenum, :GLsizei ].freeze,
    def glGetIntegerui64i_vNV(value, index, result) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
  }.freeze
end