module GL_NV_vertex_program
  module Constants
    VERTEX_PROGRAM_NV               = 0x8620
    VERTEX_STATE_PROGRAM_NV         = 0x8621
    ATTRIB_ARRAY_SIZE_NV            = 0x8623
    ATTRIB_ARRAY_STRIDE_NV          = 0x8624
    ATTRIB_ARRAY_TYPE_NV            = 0x8625
    CURRENT_ATTRIB_NV               = 0x8626
    PROGRAM_LENGTH_NV               = 0x8627
    PROGRAM_STRING_NV               = 0x8628
    MODELVIEW_PROJECTION_NV         = 0x8629
    IDENTITY_NV                     = 0x862A
    INVERSE_NV                      = 0x862B
    TRANSPOSE_NV                    = 0x862C
    INVERSE_TRANSPOSE_NV            = 0x862D
    MAX_TRACK_MATRIX_STACK_DEPTH_NV = 0x862E
    MAX_TRACK_MATRICES_NV           = 0x862F
    MATRIX0_NV                      = 0x8630
    MATRIX1_NV                      = 0x8631
    MATRIX2_NV                      = 0x8632
    MATRIX3_NV                      = 0x8633
    MATRIX4_NV                      = 0x8634
    MATRIX5_NV                      = 0x8635
    MATRIX6_NV                      = 0x8636
    MATRIX7_NV                      = 0x8637
    CURRENT_MATRIX_STACK_DEPTH_NV   = 0x8640
    CURRENT_MATRIX_NV               = 0x8641
    VERTEX_PROGRAM_POINT_SIZE_NV    = 0x8642
    VERTEX_PROGRAM_TWO_SIDE_NV      = 0x8643
    PROGRAM_PARAMETER_NV            = 0x8644
    ATTRIB_ARRAY_POINTER_NV         = 0x8645
    PROGRAM_TARGET_NV               = 0x8646
    PROGRAM_RESIDENT_NV             = 0x8647
    TRACK_MATRIX_NV                 = 0x8648
    TRACK_MATRIX_TRANSFORM_NV       = 0x8649
    VERTEX_PROGRAM_BINDING_NV       = 0x864A
    PROGRAM_ERROR_POSITION_NV       = 0x864B
    VERTEX_ATTRIB_ARRAY0_NV         = 0x8650
    VERTEX_ATTRIB_ARRAY1_NV         = 0x8651
    VERTEX_ATTRIB_ARRAY2_NV         = 0x8652
    VERTEX_ATTRIB_ARRAY3_NV         = 0x8653
    VERTEX_ATTRIB_ARRAY4_NV         = 0x8654
    VERTEX_ATTRIB_ARRAY5_NV         = 0x8655
    VERTEX_ATTRIB_ARRAY6_NV         = 0x8656
    VERTEX_ATTRIB_ARRAY7_NV         = 0x8657
    VERTEX_ATTRIB_ARRAY8_NV         = 0x8658
    VERTEX_ATTRIB_ARRAY9_NV         = 0x8659
    VERTEX_ATTRIB_ARRAY10_NV        = 0x865A
    VERTEX_ATTRIB_ARRAY11_NV        = 0x865B
    VERTEX_ATTRIB_ARRAY12_NV        = 0x865C
    VERTEX_ATTRIB_ARRAY13_NV        = 0x865D
    VERTEX_ATTRIB_ARRAY14_NV        = 0x865E
    VERTEX_ATTRIB_ARRAY15_NV        = 0x865F
    MAP1_VERTEX_ATTRIB0_4_NV        = 0x8660
    MAP1_VERTEX_ATTRIB1_4_NV        = 0x8661
    MAP1_VERTEX_ATTRIB2_4_NV        = 0x8662
    MAP1_VERTEX_ATTRIB3_4_NV        = 0x8663
    MAP1_VERTEX_ATTRIB4_4_NV        = 0x8664
    MAP1_VERTEX_ATTRIB5_4_NV        = 0x8665
    MAP1_VERTEX_ATTRIB6_4_NV        = 0x8666
    MAP1_VERTEX_ATTRIB7_4_NV        = 0x8667
    MAP1_VERTEX_ATTRIB8_4_NV        = 0x8668
    MAP1_VERTEX_ATTRIB9_4_NV        = 0x8669
    MAP1_VERTEX_ATTRIB10_4_NV       = 0x866A
    MAP1_VERTEX_ATTRIB11_4_NV       = 0x866B
    MAP1_VERTEX_ATTRIB12_4_NV       = 0x866C
    MAP1_VERTEX_ATTRIB13_4_NV       = 0x866D
    MAP1_VERTEX_ATTRIB14_4_NV       = 0x866E
    MAP1_VERTEX_ATTRIB15_4_NV       = 0x866F
    MAP2_VERTEX_ATTRIB0_4_NV        = 0x8670
    MAP2_VERTEX_ATTRIB1_4_NV        = 0x8671
    MAP2_VERTEX_ATTRIB2_4_NV        = 0x8672
    MAP2_VERTEX_ATTRIB3_4_NV        = 0x8673
    MAP2_VERTEX_ATTRIB4_4_NV        = 0x8674
    MAP2_VERTEX_ATTRIB5_4_NV        = 0x8675
    MAP2_VERTEX_ATTRIB6_4_NV        = 0x8676
    MAP2_VERTEX_ATTRIB7_4_NV        = 0x8677
    MAP2_VERTEX_ATTRIB8_4_NV        = 0x8678
    MAP2_VERTEX_ATTRIB9_4_NV        = 0x8679
    MAP2_VERTEX_ATTRIB10_4_NV       = 0x867A
    MAP2_VERTEX_ATTRIB11_4_NV       = 0x867B
    MAP2_VERTEX_ATTRIB12_4_NV       = 0x867C
    MAP2_VERTEX_ATTRIB13_4_NV       = 0x867D
    MAP2_VERTEX_ATTRIB14_4_NV       = 0x867E
    MAP2_VERTEX_ATTRIB15_4_NV       = 0x867F
  end
  
  Functions = {
    def glAreProgramsResidentNV(n, programs, residences) end => [ :GLboolean, :GLsizei, :pointer, :pointer ].freeze,
    def glBindProgramNV(target, id) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteProgramsNV(n, programs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glExecuteProgramNV(target, id, params) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glGenProgramsNV(n, programs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGetProgramParameterdvNV(target, index, pname, params) end => [ :void, :GLenum, :GLuint, :GLenum, :pointer ].freeze,
    def glGetProgramParameterfvNV(target, index, pname, params) end => [ :void, :GLenum, :GLuint, :GLenum, :pointer ].freeze,
    def glGetProgramivNV(id, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetProgramStringNV(id, pname, program) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetTrackMatrixivNV(target, address, pname, params) end => [ :void, :GLenum, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribdvNV(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribfvNV(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribivNV(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribPointervNV(index, pname, pointer) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glIsProgramNV(id) end => [ :GLboolean, :GLuint ].freeze,
    def glLoadProgramNV(target, id, len, program) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glProgramParameter4dNV(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glProgramParameter4dvNV(target, index, v) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramParameter4fNV(target, index, x, y, z, w) end => [ :void, :GLenum, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glProgramParameter4fvNV(target, index, v) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glProgramParameters4dvNV(target, index, count, v) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glProgramParameters4fvNV(target, index, count, v) end => [ :void, :GLenum, :GLuint, :GLsizei, :pointer ].freeze,
    def glRequestResidentProgramsNV(n, programs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glTrackMatrixNV(target, address, matrix, transform) end => [ :void, :GLenum, :GLuint, :GLenum, :GLenum ].freeze,
    def glVertexAttribPointerNV(index, fsize, type, stride, pointer) end => [ :void, :GLuint, :GLint, :GLenum, :GLsizei, :pointer ].freeze,
    def glVertexAttrib1dNV(index, x) end => [ :void, :GLuint, :GLdouble ].freeze,
    def glVertexAttrib1dvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1fNV(index, x) end => [ :void, :GLuint, :GLfloat ].freeze,
    def glVertexAttrib1fvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1sNV(index, x) end => [ :void, :GLuint, :GLshort ].freeze,
    def glVertexAttrib1svNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2dNV(index, x, y) end => [ :void, :GLuint, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib2dvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2fNV(index, x, y) end => [ :void, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib2fvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2sNV(index, x, y) end => [ :void, :GLuint, :GLshort, :GLshort ].freeze,
    def glVertexAttrib2svNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3dNV(index, x, y, z) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib3dvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3fNV(index, x, y, z) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib3fvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3sNV(index, x, y, z) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib3svNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4dNV(index, x, y, z, w) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib4dvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4fNV(index, x, y, z, w) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib4fvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4sNV(index, x, y, z, w) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib4svNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4ubNV(index, x, y, z, w) end => [ :void, :GLuint, :GLubyte, :GLubyte, :GLubyte, :GLubyte ].freeze,
    def glVertexAttrib4ubvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribs1dvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs1fvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs1svNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs2dvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs2fvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs2svNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs3dvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs3fvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs3svNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs4dvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs4fvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs4svNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glVertexAttribs4ubvNV(index, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
  }.freeze
end