module GL_NV_viewport_array
  module Constants
    MAX_VIEWPORTS_NV                   = 0x825B
    VIEWPORT_SUBPIXEL_BITS_NV          = 0x825C
    VIEWPORT_BOUNDS_RANGE_NV           = 0x825D
    VIEWPORT_INDEX_PROVOKING_VERTEX_NV = 0x825F
    SCISSOR_BOX                        = 0x0C10
    VIEWPORT                           = 0x0BA2
    DEPTH_RANGE                        = 0x0B70
    SCISSOR_TEST                       = 0x0C11
  end
  
  Functions = {
    def glViewportArrayvNV(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glViewportIndexedfNV(index, x, y, w, h) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glViewportIndexedfvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glScissorArrayvNV(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glScissorIndexedNV(index, left, bottom, width, height) end => [ :void, :GLuint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glScissorIndexedvNV(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glDepthRangeArrayfvNV(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glDepthRangeIndexedfNV(index, n, f) end => [ :void, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glGetFloati_vNV(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glEnableiNV(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDisableiNV(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glIsEnablediNV(target, index) end => [ :GLboolean, :GLenum, :GLuint ].freeze,
  }.freeze
end