module GL_OES_fixed_point
  module Constants
    FIXED_OES = 0x140C
  end
  
  Functions = {
    def glAlphaFuncxOES(func, ref) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glClearColorxOES(red, green, blue, alpha) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glClearDepthxOES(depth) end => [ :void, :GLfixed ].freeze,
    def glClipPlanexOES(plane, equation) end => [ :void, :GLenum, :pointer ].freeze,
    def glColor4xOES(red, green, blue, alpha) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glDepthRangexOES(n, f) end => [ :void, :GLfixed, :GLfixed ].freeze,
    def glFogxOES(pname, param) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glFogxvOES(pname, param) end => [ :void, :GLenum, :pointer ].freeze,
    def glFrustumxOES(l, r, b, t, n, f) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glGetClipPlanexOES(plane, equation) end => [ :void, :GLenum, :pointer ].freeze,
    def glGetFixedvOES(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
    def glGetTexEnvxvOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTexParameterxvOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glLightModelxOES(pname, param) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glLightModelxvOES(pname, param) end => [ :void, :GLenum, :pointer ].freeze,
    def glLightxOES(light, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glLightxvOES(light, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glLineWidthxOES(width) end => [ :void, :GLfixed ].freeze,
    def glLoadMatrixxOES(m) end => [ :void, :pointer ].freeze,
    def glMaterialxOES(face, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glMaterialxvOES(face, pname, param) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glMultMatrixxOES(m) end => [ :void, :pointer ].freeze,
    def glMultiTexCoord4xOES(texture, s, t, r, q) end => [ :void, :GLenum, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glNormal3xOES(nx, ny, nz) end => [ :void, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glOrthoxOES(l, r, b, t, n, f) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glPointParameterxvOES(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
    def glPointSizexOES(size) end => [ :void, :GLfixed ].freeze,
    def glPolygonOffsetxOES(factor, units) end => [ :void, :GLfixed, :GLfixed ].freeze,
    def glRotatexOES(angle, x, y, z) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glScalexOES(x, y, z) end => [ :void, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glTexEnvxOES(target, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glTexEnvxvOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glTexParameterxOES(target, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glTexParameterxvOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glTranslatexOES(x, y, z) end => [ :void, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glGetLightxvOES(light, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMaterialxvOES(face, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glPointParameterxOES(pname, param) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glSampleCoveragexOES(value, invert) end => [ :void, :GLclampx, :GLboolean ].freeze,
    def glAccumxOES(op, value) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glBitmapxOES(width, height, xorig, yorig, xmove, ymove, bitmap) end => [ :void, :GLsizei, :GLsizei, :GLfixed, :GLfixed, :GLfixed, :GLfixed, :pointer ].freeze,
    def glBlendColorxOES(red, green, blue, alpha) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glClearAccumxOES(red, green, blue, alpha) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glColor3xOES(red, green, blue) end => [ :void, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glColor3xvOES(components) end => [ :void, :pointer ].freeze,
    def glColor4xvOES(components) end => [ :void, :pointer ].freeze,
    def glConvolutionParameterxOES(target, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glConvolutionParameterxvOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glEvalCoord1xOES(u) end => [ :void, :GLfixed ].freeze,
    def glEvalCoord1xvOES(coords) end => [ :void, :pointer ].freeze,
    def glEvalCoord2xOES(u, v) end => [ :void, :GLfixed, :GLfixed ].freeze,
    def glEvalCoord2xvOES(coords) end => [ :void, :pointer ].freeze,
    def glFeedbackBufferxOES(n, type, buffer) end => [ :void, :GLsizei, :GLenum, :pointer ].freeze,
    def glGetConvolutionParameterxvOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetHistogramParameterxvOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetLightxOES(light, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMapxvOES(target, query, v) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetMaterialxOES(face, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glGetPixelMapxv(map, size, values) end => [ :void, :GLenum, :GLint, :pointer ].freeze,
    def glGetTexGenxvOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTexLevelParameterxvOES(target, level, pname, params) end => [ :void, :GLenum, :GLint, :GLenum, :pointer ].freeze,
    def glIndexxOES(component) end => [ :void, :GLfixed ].freeze,
    def glIndexxvOES(component) end => [ :void, :pointer ].freeze,
    def glLoadTransposeMatrixxOES(m) end => [ :void, :pointer ].freeze,
    def glMap1xOES(target, u1, u2, stride, order, points) end => [ :void, :GLenum, :GLfixed, :GLfixed, :GLint, :GLint, :GLfixed ].freeze,
    def glMap2xOES(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points) end => [ :void, :GLenum, :GLfixed, :GLfixed, :GLint, :GLint, :GLfixed, :GLfixed, :GLint, :GLint, :GLfixed ].freeze,
    def glMapGrid1xOES(n, u1, u2) end => [ :void, :GLint, :GLfixed, :GLfixed ].freeze,
    def glMapGrid2xOES(n, u1, u2, v1, v2) end => [ :void, :GLint, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glMultTransposeMatrixxOES(m) end => [ :void, :pointer ].freeze,
    def glMultiTexCoord1xOES(texture, s) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glMultiTexCoord1xvOES(texture, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord2xOES(texture, s, t) end => [ :void, :GLenum, :GLfixed, :GLfixed ].freeze,
    def glMultiTexCoord2xvOES(texture, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord3xOES(texture, s, t, r) end => [ :void, :GLenum, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glMultiTexCoord3xvOES(texture, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glMultiTexCoord4xvOES(texture, coords) end => [ :void, :GLenum, :pointer ].freeze,
    def glNormal3xvOES(coords) end => [ :void, :pointer ].freeze,
    def glPassThroughxOES(token) end => [ :void, :GLfixed ].freeze,
    def glPixelMapx(map, size, values) end => [ :void, :GLenum, :GLint, :pointer ].freeze,
    def glPixelStorex(pname, param) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glPixelTransferxOES(pname, param) end => [ :void, :GLenum, :GLfixed ].freeze,
    def glPixelZoomxOES(xfactor, yfactor) end => [ :void, :GLfixed, :GLfixed ].freeze,
    def glPrioritizeTexturesxOES(n, textures, priorities) end => [ :void, :GLsizei, :pointer, :pointer ].freeze,
    def glRasterPos2xOES(x, y) end => [ :void, :GLfixed, :GLfixed ].freeze,
    def glRasterPos2xvOES(coords) end => [ :void, :pointer ].freeze,
    def glRasterPos3xOES(x, y, z) end => [ :void, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glRasterPos3xvOES(coords) end => [ :void, :pointer ].freeze,
    def glRasterPos4xOES(x, y, z, w) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glRasterPos4xvOES(coords) end => [ :void, :pointer ].freeze,
    def glRectxOES(x1, y1, x2, y2) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glRectxvOES(v1, v2) end => [ :void, :pointer, :pointer ].freeze,
    def glTexCoord1xOES(s) end => [ :void, :GLfixed ].freeze,
    def glTexCoord1xvOES(coords) end => [ :void, :pointer ].freeze,
    def glTexCoord2xOES(s, t) end => [ :void, :GLfixed, :GLfixed ].freeze,
    def glTexCoord2xvOES(coords) end => [ :void, :pointer ].freeze,
    def glTexCoord3xOES(s, t, r) end => [ :void, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glTexCoord3xvOES(coords) end => [ :void, :pointer ].freeze,
    def glTexCoord4xOES(s, t, r, q) end => [ :void, :GLfixed, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glTexCoord4xvOES(coords) end => [ :void, :pointer ].freeze,
    def glTexGenxOES(coord, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glTexGenxvOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glVertex2xOES(x) end => [ :void, :GLfixed ].freeze,
    def glVertex2xvOES(coords) end => [ :void, :pointer ].freeze,
    def glVertex3xOES(x, y) end => [ :void, :GLfixed, :GLfixed ].freeze,
    def glVertex3xvOES(coords) end => [ :void, :pointer ].freeze,
    def glVertex4xOES(x, y, z) end => [ :void, :GLfixed, :GLfixed, :GLfixed ].freeze,
    def glVertex4xvOES(coords) end => [ :void, :pointer ].freeze,
  }.freeze
end