module GL_OES_framebuffer_object
  module Constants
    NONE_OES                                         = 0
    FRAMEBUFFER_OES                                  = 0x8D40
    RENDERBUFFER_OES                                 = 0x8D41
    RGBA4_OES                                        = 0x8056
    RGB5_A1_OES                                      = 0x8057
    RGB565_OES                                       = 0x8D62
    DEPTH_COMPONENT16_OES                            = 0x81A5
    RENDERBUFFER_WIDTH_OES                           = 0x8D42
    RENDERBUFFER_HEIGHT_OES                          = 0x8D43
    RENDERBUFFER_INTERNAL_FORMAT_OES                 = 0x8D44
    RENDERBUFFER_RED_SIZE_OES                        = 0x8D50
    RENDERBUFFER_GREEN_SIZE_OES                      = 0x8D51
    RENDERBUFFER_BLUE_SIZE_OES                       = 0x8D52
    RENDERBUFFER_ALPHA_SIZE_OES                      = 0x8D53
    RENDERBUFFER_DEPTH_SIZE_OES                      = 0x8D54
    RENDERBUFFER_STENCIL_SIZE_OES                    = 0x8D55
    FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES           = 0x8CD0
    FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES           = 0x8CD1
    FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES         = 0x8CD2
    FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES = 0x8CD3
    COLOR_ATTACHMENT0_OES                            = 0x8CE0
    DEPTH_ATTACHMENT_OES                             = 0x8D00
    STENCIL_ATTACHMENT_OES                           = 0x8D20
    FRAMEBUFFER_COMPLETE_OES                         = 0x8CD5
    FRAMEBUFFER_INCOMPLETE_ATTACHMENT_OES            = 0x8CD6
    FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_OES    = 0x8CD7
    FRAMEBUFFER_INCOMPLETE_DIMENSIONS_OES            = 0x8CD9
    FRAMEBUFFER_INCOMPLETE_FORMATS_OES               = 0x8CDA
    FRAMEBUFFER_UNSUPPORTED_OES                      = 0x8CDD
    FRAMEBUFFER_BINDING_OES                          = 0x8CA6
    RENDERBUFFER_BINDING_OES                         = 0x8CA7
    MAX_RENDERBUFFER_SIZE_OES                        = 0x84E8
    INVALID_FRAMEBUFFER_OPERATION_OES                = 0x0506
  end
  
  Functions = {
    def glIsRenderbufferOES(renderbuffer) end => [ :GLboolean, :GLuint ].freeze,
    def glBindRenderbufferOES(target, renderbuffer) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteRenderbuffersOES(n, renderbuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGenRenderbuffersOES(n, renderbuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glRenderbufferStorageOES(target, internalformat, width, height) end => [ :void, :GLenum, :GLenum, :GLsizei, :GLsizei ].freeze,
    def glGetRenderbufferParameterivOES(target, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glIsFramebufferOES(framebuffer) end => [ :GLboolean, :GLuint ].freeze,
    def glBindFramebufferOES(target, framebuffer) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDeleteFramebuffersOES(n, framebuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glGenFramebuffersOES(n, framebuffers) end => [ :void, :GLsizei, :pointer ].freeze,
    def glCheckFramebufferStatusOES(target) end => [ :GLenum, :GLenum ].freeze,
    def glFramebufferRenderbufferOES(target, attachment, renderbuffertarget, renderbuffer) end => [ :void, :GLenum, :GLenum, :GLenum, :GLuint ].freeze,
    def glFramebufferTexture2DOES(target, attachment, textarget, texture, level) end => [ :void, :GLenum, :GLenum, :GLenum, :GLuint, :GLint ].freeze,
    def glGetFramebufferAttachmentParameterivOES(target, attachment, pname, params) end => [ :void, :GLenum, :GLenum, :GLenum, :pointer ].freeze,
    def glGenerateMipmapOES(target) end => [ :void, :GLenum ].freeze,
  }.freeze
end