module GL_OES_texture_cube_map
  module Constants
    NORMAL_MAP_OES                  = 0x8511
    REFLECTION_MAP_OES              = 0x8512
    TEXTURE_CUBE_MAP_OES            = 0x8513
    TEXTURE_BINDING_CUBE_MAP_OES    = 0x8514
    TEXTURE_CUBE_MAP_POSITIVE_X_OES = 0x8515
    TEXTURE_CUBE_MAP_NEGATIVE_X_OES = 0x8516
    TEXTURE_CUBE_MAP_POSITIVE_Y_OES = 0x8517
    TEXTURE_CUBE_MAP_NEGATIVE_Y_OES = 0x8518
    TEXTURE_CUBE_MAP_POSITIVE_Z_OES = 0x8519
    TEXTURE_CUBE_MAP_NEGATIVE_Z_OES = 0x851A
    MAX_CUBE_MAP_TEXTURE_SIZE_OES   = 0x851C
    TEXTURE_GEN_MODE_OES            = 0x2500
    TEXTURE_GEN_STR_OES             = 0x8D60
  end
  
  Functions = {
    def glTexGenfOES(coord, pname, param) end => [ :void, :GLenum, :GLenum, :GLfloat ].freeze,
    def glTexGenfvOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glTexGeniOES(coord, pname, param) end => [ :void, :GLenum, :GLenum, :GLint ].freeze,
    def glTexGenivOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glTexGenxOES(coord, pname, param) end => [ :void, :GLenum, :GLenum, :GLfixed ].freeze,
    def glTexGenxvOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTexGenfvOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTexGenivOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetTexGenxvOES(coord, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
  }.freeze
end