module GL_OES_viewport_array
  module Constants
    SCISSOR_BOX                         = 0x0C10
    VIEWPORT                            = 0x0BA2
    DEPTH_RANGE                         = 0x0B70
    SCISSOR_TEST                        = 0x0C11
    MAX_VIEWPORTS_OES                   = 0x825B
    VIEWPORT_SUBPIXEL_BITS_OES          = 0x825C
    VIEWPORT_BOUNDS_RANGE_OES           = 0x825D
    VIEWPORT_INDEX_PROVOKING_VERTEX_OES = 0x825F
  end
  
  Functions = {
    def glViewportArrayvOES(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glViewportIndexedfOES(index, x, y, w, h) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glViewportIndexedfvOES(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glScissorArrayvOES(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glScissorIndexedOES(index, left, bottom, width, height) end => [ :void, :GLuint, :GLint, :GLint, :GLsizei, :GLsizei ].freeze,
    def glScissorIndexedvOES(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glDepthRangeArrayfvOES(first, count, v) end => [ :void, :GLuint, :GLsizei, :pointer ].freeze,
    def glDepthRangeIndexedfOES(index, n, f) end => [ :void, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glGetFloati_vOES(target, index, data) end => [ :void, :GLenum, :GLuint, :pointer ].freeze,
    def glEnableiOES(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glDisableiOES(target, index) end => [ :void, :GLenum, :GLuint ].freeze,
    def glIsEnablediOES(target, index) end => [ :GLboolean, :GLenum, :GLuint ].freeze,
  }.freeze
end