module GL_QCOM_extended_get
  module Constants
    TEXTURE_WIDTH_QCOM           = 0x8BD2
    TEXTURE_HEIGHT_QCOM          = 0x8BD3
    TEXTURE_DEPTH_QCOM           = 0x8BD4
    TEXTURE_INTERNAL_FORMAT_QCOM = 0x8BD5
    TEXTURE_FORMAT_QCOM          = 0x8BD6
    TEXTURE_TYPE_QCOM            = 0x8BD7
    TEXTURE_IMAGE_VALID_QCOM     = 0x8BD8
    TEXTURE_NUM_LEVELS_QCOM      = 0x8BD9
    TEXTURE_TARGET_QCOM          = 0x8BDA
    TEXTURE_OBJECT_VALID_QCOM    = 0x8BDB
    STATE_RESTORE                = 0x8BDC
  end
  
  Functions = {
    def glExtGetTexturesQCOM(textures, maxTextures, numTextures) end => [ :void, :pointer, :GLint, :pointer ].freeze,
    def glExtGetBuffersQCOM(buffers, maxBuffers, numBuffers) end => [ :void, :pointer, :GLint, :pointer ].freeze,
    def glExtGetRenderbuffersQCOM(renderbuffers, maxRenderbuffers, numRenderbuffers) end => [ :void, :pointer, :GLint, :pointer ].freeze,
    def glExtGetFramebuffersQCOM(framebuffers, maxFramebuffers, numFramebuffers) end => [ :void, :pointer, :GLint, :pointer ].freeze,
    def glExtGetTexLevelParameterivQCOM(texture, face, level, pname, params) end => [ :void, :GLuint, :GLenum, :GLint, :GLenum, :pointer ].freeze,
    def glExtTexObjectStateOverrideiQCOM(target, pname, param) end => [ :void, :GLenum, :GLenum, :GLint ].freeze,
    def glExtGetTexSubImageQCOM(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, texels) end => [ :void, :GLenum, :GLint, :GLint, :GLint, :GLint, :GLsizei, :GLsizei, :GLsizei, :GLenum, :GLenum, :pointer ].freeze,
    def glExtGetBufferPointervQCOM(target, params) end => [ :void, :GLenum, :pointer ].freeze,
  }.freeze
end