module GL_SGIX_fragment_lighting
  module Constants
    FRAGMENT_LIGHTING_SGIX                         = 0x8400
    FRAGMENT_COLOR_MATERIAL_SGIX                   = 0x8401
    FRAGMENT_COLOR_MATERIAL_FACE_SGIX              = 0x8402
    FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX         = 0x8403
    MAX_FRAGMENT_LIGHTS_SGIX                       = 0x8404
    MAX_ACTIVE_LIGHTS_SGIX                         = 0x8405
    CURRENT_RASTER_NORMAL_SGIX                     = 0x8406
    LIGHT_ENV_MODE_SGIX                            = 0x8407
    FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX         = 0x8408
    FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX             = 0x8409
    FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX              = 0x840A
    FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX = 0x840B
    FRAGMENT_LIGHT0_SGIX                           = 0x840C
    FRAGMENT_LIGHT1_SGIX                           = 0x840D
    FRAGMENT_LIGHT2_SGIX                           = 0x840E
    FRAGMENT_LIGHT3_SGIX                           = 0x840F
    FRAGMENT_LIGHT4_SGIX                           = 0x8410
    FRAGMENT_LIGHT5_SGIX                           = 0x8411
    FRAGMENT_LIGHT6_SGIX                           = 0x8412
    FRAGMENT_LIGHT7_SGIX                           = 0x8413
  end
  
  Functions = {
    def glFragmentColorMaterialSGIX(face, mode) end => [ :void, :GLenum, :GLenum ].freeze,
    def glFragmentLightfSGIX(light, pname, param) end => [ :void, :GLenum, :GLenum, :GLfloat ].freeze,
    def glFragmentLightfvSGIX(light, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glFragmentLightiSGIX(light, pname, param) end => [ :void, :GLenum, :GLenum, :GLint ].freeze,
    def glFragmentLightivSGIX(light, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glFragmentLightModelfSGIX(pname, param) end => [ :void, :GLenum, :GLfloat ].freeze,
    def glFragmentLightModelfvSGIX(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
    def glFragmentLightModeliSGIX(pname, param) end => [ :void, :GLenum, :GLint ].freeze,
    def glFragmentLightModelivSGIX(pname, params) end => [ :void, :GLenum, :pointer ].freeze,
    def glFragmentMaterialfSGIX(face, pname, param) end => [ :void, :GLenum, :GLenum, :GLfloat ].freeze,
    def glFragmentMaterialfvSGIX(face, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glFragmentMaterialiSGIX(face, pname, param) end => [ :void, :GLenum, :GLenum, :GLint ].freeze,
    def glFragmentMaterialivSGIX(face, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetFragmentLightfvSGIX(light, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetFragmentLightivSGIX(light, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetFragmentMaterialfvSGIX(face, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glGetFragmentMaterialivSGIX(face, pname, params) end => [ :void, :GLenum, :GLenum, :pointer ].freeze,
    def glLightEnviSGIX(pname, param) end => [ :void, :GLenum, :GLint ].freeze,
  }.freeze
end