module GL_SUN_triangle_list
  module Constants
    RESTART_SUN                        = 0x0001
    REPLACE_MIDDLE_SUN                 = 0x0002
    REPLACE_OLDEST_SUN                 = 0x0003
    TRIANGLE_LIST_SUN                  = 0x81D7
    REPLACEMENT_CODE_SUN               = 0x81D8
    REPLACEMENT_CODE_ARRAY_SUN         = 0x85C0
    REPLACEMENT_CODE_ARRAY_TYPE_SUN    = 0x85C1
    REPLACEMENT_CODE_ARRAY_STRIDE_SUN  = 0x85C2
    REPLACEMENT_CODE_ARRAY_POINTER_SUN = 0x85C3
    R1UI_V3F_SUN                       = 0x85C4
    R1UI_C4UB_V3F_SUN                  = 0x85C5
    R1UI_C3F_V3F_SUN                   = 0x85C6
    R1UI_N3F_V3F_SUN                   = 0x85C7
    R1UI_C4F_N3F_V3F_SUN               = 0x85C8
    R1UI_T2F_V3F_SUN                   = 0x85C9
    R1UI_T2F_N3F_V3F_SUN               = 0x85CA
    R1UI_T2F_C4F_N3F_V3F_SUN           = 0x85CB
  end
  
  Functions = {
    def glReplacementCodeuiSUN(code) end => [ :void, :GLuint ].freeze,
    def glReplacementCodeusSUN(code) end => [ :void, :GLushort ].freeze,
    def glReplacementCodeubSUN(code) end => [ :void, :GLubyte ].freeze,
    def glReplacementCodeuivSUN(code) end => [ :void, :pointer ].freeze,
    def glReplacementCodeusvSUN(code) end => [ :void, :pointer ].freeze,
    def glReplacementCodeubvSUN(code) end => [ :void, :pointer ].freeze,
    def glReplacementCodePointerSUN(type, stride, pointer) end => [ :void, :GLenum, :GLsizei, :pointer ].freeze,
  }.freeze
end