module WGL_AMD_gpu_association
  module Constants
    GPU_VENDOR_AMD                = 0x1F00
    GPU_RENDERER_STRING_AMD       = 0x1F01
    GPU_OPENGL_VERSION_STRING_AMD = 0x1F02
    GPU_FASTEST_TARGET_GPUS_AMD   = 0x21A2
    GPU_RAM_AMD                   = 0x21A3
    GPU_CLOCK_AMD                 = 0x21A4
    GPU_NUM_PIPES_AMD             = 0x21A5
    GPU_NUM_SIMD_AMD              = 0x21A6
    GPU_NUM_RB_AMD                = 0x21A7
    GPU_NUM_SPI_AMD               = 0x21A8
  end
  
  Functions = {
    def wglGetGPUIDsAMD(maxCount, ids) end => [ :UINT, :UINT, :pointer ].freeze,
    def wglGetGPUInfoAMD(id, property, dataType, size, data) end => [ :INT, :UINT, :int, :GLenum, :UINT, :pointer ].freeze,
    def wglGetContextGPUIDAMD(hglrc) end => [ :UINT, :HGLRC ].freeze,
    def wglCreateAssociatedContextAMD(id) end => [ :HGLRC, :UINT ].freeze,
    def wglCreateAssociatedContextAttribsAMD(id, hShareContext, attribList) end => [ :HGLRC, :UINT, :HGLRC, :pointer ].freeze,
    def wglDeleteAssociatedContextAMD(hglrc) end => [ :BOOL, :HGLRC ].freeze,
    def wglMakeAssociatedContextCurrentAMD(hglrc) end => [ :BOOL, :HGLRC ].freeze,
    def wglGetCurrentAssociatedContextAMD() end => [ :HGLRC ].freeze,
    def wglBlitContextFramebufferAMD(dstCtx, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter) end => [ :VOID, :HGLRC, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLint, :GLbitfield, :GLenum ].freeze,
  }.freeze
end