module WGL_EXT_pbuffer
  module Constants
    DRAW_TO_PBUFFER_EXT        = 0x202D
    MAX_PBUFFER_PIXELS_EXT     = 0x202E
    MAX_PBUFFER_WIDTH_EXT      = 0x202F
    MAX_PBUFFER_HEIGHT_EXT     = 0x2030
    OPTIMAL_PBUFFER_WIDTH_EXT  = 0x2031
    OPTIMAL_PBUFFER_HEIGHT_EXT = 0x2032
    PBUFFER_LARGEST_EXT        = 0x2033
    PBUFFER_WIDTH_EXT          = 0x2034
    PBUFFER_HEIGHT_EXT         = 0x2035
  end
  
  Functions = {
    def wglCreatePbufferEXT(hDC, iPixelFormat, iWidth, iHeight, piAttribList) end => [ :HPBUFFEREXT, :HDC, :int, :int, :int, :pointer ].freeze,
    def wglGetPbufferDCEXT(hPbuffer) end => [ :HDC, :HPBUFFEREXT ].freeze,
    def wglReleasePbufferDCEXT(hPbuffer, hDC) end => [ :int, :HPBUFFEREXT, :HDC ].freeze,
    def wglDestroyPbufferEXT(hPbuffer) end => [ :BOOL, :HPBUFFEREXT ].freeze,
    def wglQueryPbufferEXT(hPbuffer, iAttribute, piValue) end => [ :BOOL, :HPBUFFEREXT, :int, :pointer ].freeze,
  }.freeze
end