module WGL_EXT_pixel_format
  module Constants
    NUMBER_PIXEL_FORMATS_EXT = 0x2000
    DRAW_TO_WINDOW_EXT       = 0x2001
    DRAW_TO_BITMAP_EXT       = 0x2002
    ACCELERATION_EXT         = 0x2003
    NEED_PALETTE_EXT         = 0x2004
    NEED_SYSTEM_PALETTE_EXT  = 0x2005
    SWAP_LAYER_BUFFERS_EXT   = 0x2006
    SWAP_METHOD_EXT          = 0x2007
    NUMBER_OVERLAYS_EXT      = 0x2008
    NUMBER_UNDERLAYS_EXT     = 0x2009
    TRANSPARENT_EXT          = 0x200A
    TRANSPARENT_VALUE_EXT    = 0x200B
    SHARE_DEPTH_EXT          = 0x200C
    SHARE_STENCIL_EXT        = 0x200D
    SHARE_ACCUM_EXT          = 0x200E
    SUPPORT_GDI_EXT          = 0x200F
    SUPPORT_OPENGL_EXT       = 0x2010
    DOUBLE_BUFFER_EXT        = 0x2011
    STEREO_EXT               = 0x2012
    PIXEL_TYPE_EXT           = 0x2013
    COLOR_BITS_EXT           = 0x2014
    RED_BITS_EXT             = 0x2015
    RED_SHIFT_EXT            = 0x2016
    GREEN_BITS_EXT           = 0x2017
    GREEN_SHIFT_EXT          = 0x2018
    BLUE_BITS_EXT            = 0x2019
    BLUE_SHIFT_EXT           = 0x201A
    ALPHA_BITS_EXT           = 0x201B
    ALPHA_SHIFT_EXT          = 0x201C
    ACCUM_BITS_EXT           = 0x201D
    ACCUM_RED_BITS_EXT       = 0x201E
    ACCUM_GREEN_BITS_EXT     = 0x201F
    ACCUM_BLUE_BITS_EXT      = 0x2020
    ACCUM_ALPHA_BITS_EXT     = 0x2021
    DEPTH_BITS_EXT           = 0x2022
    STENCIL_BITS_EXT         = 0x2023
    AUX_BUFFERS_EXT          = 0x2024
    NO_ACCELERATION_EXT      = 0x2025
    GENERIC_ACCELERATION_EXT = 0x2026
    FULL_ACCELERATION_EXT    = 0x2027
    SWAP_EXCHANGE_EXT        = 0x2028
    SWAP_COPY_EXT            = 0x2029
    SWAP_UNDEFINED_EXT       = 0x202A
    TYPE_RGBA_EXT            = 0x202B
    TYPE_COLORINDEX_EXT      = 0x202C
  end
  
  Functions = {
    def wglGetPixelFormatAttribivEXT(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues) end => [ :BOOL, :HDC, :int, :int, :UINT, :pointer, :pointer ].freeze,
    def wglGetPixelFormatAttribfvEXT(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues) end => [ :BOOL, :HDC, :int, :int, :UINT, :pointer, :pointer ].freeze,
    def wglChoosePixelFormatEXT(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats) end => [ :BOOL, :HDC, :pointer, :pointer, :UINT, :pointer, :pointer ].freeze,
  }.freeze
end