module WGL_I3D_genlock
  module Constants
    GENLOCK_SOURCE_MULTIVIEW_I3D      = 0x2044
    GENLOCK_SOURCE_EXTERNAL_SYNC_I3D  = 0x2045
    GENLOCK_SOURCE_EXTERNAL_FIELD_I3D = 0x2046
    GENLOCK_SOURCE_EXTERNAL_TTL_I3D   = 0x2047
    GENLOCK_SOURCE_DIGITAL_SYNC_I3D   = 0x2048
    GENLOCK_SOURCE_DIGITAL_FIELD_I3D  = 0x2049
    GENLOCK_SOURCE_EDGE_FALLING_I3D   = 0x204A
    GENLOCK_SOURCE_EDGE_RISING_I3D    = 0x204B
    GENLOCK_SOURCE_EDGE_BOTH_I3D      = 0x204C
  end
  
  Functions = {
    def wglEnableGenlockI3D(hDC) end => [ :BOOL, :HDC ].freeze,
    def wglDisableGenlockI3D(hDC) end => [ :BOOL, :HDC ].freeze,
    def wglIsEnabledGenlockI3D(hDC, pFlag) end => [ :BOOL, :HDC, :pointer ].freeze,
    def wglGenlockSourceI3D(hDC, uSource) end => [ :BOOL, :HDC, :UINT ].freeze,
    def wglGetGenlockSourceI3D(hDC, uSource) end => [ :BOOL, :HDC, :pointer ].freeze,
    def wglGenlockSourceEdgeI3D(hDC, uEdge) end => [ :BOOL, :HDC, :UINT ].freeze,
    def wglGetGenlockSourceEdgeI3D(hDC, uEdge) end => [ :BOOL, :HDC, :pointer ].freeze,
    def wglGenlockSampleRateI3D(hDC, uRate) end => [ :BOOL, :HDC, :UINT ].freeze,
    def wglGetGenlockSampleRateI3D(hDC, uRate) end => [ :BOOL, :HDC, :pointer ].freeze,
    def wglGenlockSourceDelayI3D(hDC, uDelay) end => [ :BOOL, :HDC, :UINT ].freeze,
    def wglGetGenlockSourceDelayI3D(hDC, uDelay) end => [ :BOOL, :HDC, :pointer ].freeze,
    def wglQueryGenlockMaxSourceDelayI3D(hDC, uMaxLineDelay, uMaxPixelDelay) end => [ :BOOL, :HDC, :pointer, :pointer ].freeze,
  }.freeze
end