module WGL_NV_DX_interop
  module Constants
    ACCESS_READ_ONLY_NV     = 0x00000000
    ACCESS_READ_WRITE_NV    = 0x00000001
    ACCESS_WRITE_DISCARD_NV = 0x00000002
  end
  
  Functions = {
    def wglDXSetResourceShareHandleNV(dxObject, shareHandle) end => [ :BOOL, :pointer, :HANDLE ].freeze,
    def wglDXOpenDeviceNV(dxDevice) end => [ :HANDLE, :pointer ].freeze,
    def wglDXCloseDeviceNV(hDevice) end => [ :BOOL, :HANDLE ].freeze,
    def wglDXRegisterObjectNV(hDevice, dxObject, name, type, access) end => [ :HANDLE, :HANDLE, :pointer, :GLuint, :GLenum, :GLenum ].freeze,
    def wglDXUnregisterObjectNV(hDevice, hObject) end => [ :BOOL, :HANDLE, :HANDLE ].freeze,
    def wglDXObjectAccessNV(hObject, access) end => [ :BOOL, :HANDLE, :GLenum ].freeze,
    def wglDXLockObjectsNV(hDevice, count, hObjects) end => [ :BOOL, :HANDLE, :GLint, :pointer ].freeze,
    def wglDXUnlockObjectsNV(hDevice, count, hObjects) end => [ :BOOL, :HANDLE, :GLint, :pointer ].freeze,
  }.freeze
end