module GL_VERSION_2_0
  module Constants
    ACTIVE_ATTRIBUTE_MAX_LENGTH      = 0x8B8A
    ACTIVE_ATTRIBUTES                = 0x8B89
    ACTIVE_UNIFORM_MAX_LENGTH        = 0x8B87
    ACTIVE_UNIFORMS                  = 0x8B86
    ATTACHED_SHADERS                 = 0x8B85
    BLEND_EQUATION_ALPHA             = 0x883D
    BLEND_EQUATION                   = 0x8009
    BLEND_EQUATION_RGB               = BLEND_EQUATION
    BOOL                             = 0x8B56
    BOOL_VEC2                        = 0x8B57
    BOOL_VEC3                        = 0x8B58
    BOOL_VEC4                        = 0x8B59
    COMPILE_STATUS                   = 0x8B81
    COORD_REPLACE                    = 0x8862
    CURRENT_PROGRAM                  = 0x8B8D
    CURRENT_VERTEX_ATTRIB            = 0x8626
    DELETE_STATUS                    = 0x8B80
    DRAW_BUFFER0                     = 0x8825
    DRAW_BUFFER1                     = 0x8826
    DRAW_BUFFER10                    = 0x882F
    DRAW_BUFFER11                    = 0x8830
    DRAW_BUFFER12                    = 0x8831
    DRAW_BUFFER13                    = 0x8832
    DRAW_BUFFER14                    = 0x8833
    DRAW_BUFFER15                    = 0x8834
    DRAW_BUFFER2                     = 0x8827
    DRAW_BUFFER3                     = 0x8828
    DRAW_BUFFER4                     = 0x8829
    DRAW_BUFFER5                     = 0x882A
    DRAW_BUFFER6                     = 0x882B
    DRAW_BUFFER7                     = 0x882C
    DRAW_BUFFER8                     = 0x882D
    DRAW_BUFFER9                     = 0x882E
    FLOAT_MAT2                       = 0x8B5A
    FLOAT_MAT3                       = 0x8B5B
    FLOAT_MAT4                       = 0x8B5C
    FLOAT_VEC2                       = 0x8B50
    FLOAT_VEC3                       = 0x8B51
    FLOAT_VEC4                       = 0x8B52
    FRAGMENT_SHADER                  = 0x8B30
    FRAGMENT_SHADER_DERIVATIVE_HINT  = 0x8B8B
    INFO_LOG_LENGTH                  = 0x8B84
    INT_VEC2                         = 0x8B53
    INT_VEC3                         = 0x8B54
    INT_VEC4                         = 0x8B55
    LINK_STATUS                      = 0x8B82
    LOWER_LEFT                       = 0x8CA1
    MAX_COMBINED_TEXTURE_IMAGE_UNITS = 0x8B4D
    MAX_DRAW_BUFFERS                 = 0x8824
    MAX_FRAGMENT_UNIFORM_COMPONENTS  = 0x8B49
    MAX_TEXTURE_COORDS               = 0x8871
    MAX_TEXTURE_IMAGE_UNITS          = 0x8872
    MAX_VARYING_FLOATS               = 0x8B4B
    MAX_VERTEX_ATTRIBS               = 0x8869
    MAX_VERTEX_TEXTURE_IMAGE_UNITS   = 0x8B4C
    MAX_VERTEX_UNIFORM_COMPONENTS    = 0x8B4A
    POINT_SPRITE                     = 0x8861
    POINT_SPRITE_COORD_ORIGIN        = 0x8CA0
    SAMPLER_1D                       = 0x8B5D
    SAMPLER_1D_SHADOW                = 0x8B61
    SAMPLER_2D                       = 0x8B5E
    SAMPLER_2D_SHADOW                = 0x8B62
    SAMPLER_3D                       = 0x8B5F
    SAMPLER_CUBE                     = 0x8B60
    SHADER_SOURCE_LENGTH             = 0x8B88
    SHADER_TYPE                      = 0x8B4F
    SHADING_LANGUAGE_VERSION         = 0x8B8C
    STENCIL_BACK_FAIL                = 0x8801
    STENCIL_BACK_FUNC                = 0x8800
    STENCIL_BACK_PASS_DEPTH_FAIL     = 0x8802
    STENCIL_BACK_PASS_DEPTH_PASS     = 0x8803
    STENCIL_BACK_REF                 = 0x8CA3
    STENCIL_BACK_VALUE_MASK          = 0x8CA4
    STENCIL_BACK_WRITEMASK           = 0x8CA5
    UPPER_LEFT                       = 0x8CA2
    VALIDATE_STATUS                  = 0x8B83
    VERTEX_ATTRIB_ARRAY_ENABLED      = 0x8622
    VERTEX_ATTRIB_ARRAY_NORMALIZED   = 0x886A
    VERTEX_ATTRIB_ARRAY_POINTER      = 0x8645
    VERTEX_ATTRIB_ARRAY_SIZE         = 0x8623
    VERTEX_ATTRIB_ARRAY_STRIDE       = 0x8624
    VERTEX_ATTRIB_ARRAY_TYPE         = 0x8625
    VERTEX_PROGRAM_POINT_SIZE        = 0x8642
    VERTEX_PROGRAM_TWO_SIDE          = 0x8643
    VERTEX_SHADER                    = 0x8B31
  end

  Functions = {
    def glAttachShader(program, shader) end => [ :void, :GLuint, :GLuint ].freeze,
    def glBindAttribLocation(program, index, name) end => [ :void, :GLuint, :GLuint, :string ].freeze,
    def glBlendEquationSeparate(modeRGB, modeAlpha) end => [ :void, :GLenum, :GLenum ].freeze,
    def glCompileShader(shader) end => [ :void, :GLuint ].freeze,
    def glCreateProgram() end => [ :GLuint ].freeze,
    def glCreateShader(type) end => [ :GLuint, :GLenum ].freeze,
    def glDeleteProgram(program) end => [ :void, :GLuint ].freeze,
    def glDeleteShader(shader) end => [ :void, :GLuint ].freeze,
    def glDetachShader(program, shader) end => [ :void, :GLuint, :GLuint ].freeze,
    def glDisableVertexAttribArray(index) end => [ :void, :GLuint ].freeze,
    def glDrawBuffers(n, bufs) end => [ :void, :GLsizei, :pointer ].freeze,
    def glEnableVertexAttribArray(index) end => [ :void, :GLuint ].freeze,
    def glGetActiveAttrib(program, index, bufSize, length, size, type, name) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :string ].freeze,
    def glGetActiveUniform(program, index, bufSize, length, size, type, name) end => [ :void, :GLuint, :GLuint, :GLsizei, :pointer, :pointer, :pointer, :string ].freeze,
    def glGetAttachedShaders(program, maxCount, count, shaders) end => [ :void, :GLuint, :GLsizei, :pointer, :pointer ].freeze,
    def glGetAttribLocation(program, name) end => [ :GLint, :GLuint, :string ].freeze,
    def glGetProgramInfoLog(program, bufSize, length, infoLog) end => [ :void, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glGetProgramiv(program, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetShaderInfoLog(shader, bufSize, length, infoLog) end => [ :void, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glGetShaderSource(shader, bufSize, length, source) end => [ :void, :GLuint, :GLsizei, :pointer, :string ].freeze,
    def glGetShaderiv(shader, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetUniformLocation(program, name) end => [ :GLint, :GLuint, :string ].freeze,
    def glGetUniformfv(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glGetUniformiv(program, location, params) end => [ :void, :GLuint, :GLint, :pointer ].freeze,
    def glGetVertexAttribPointerv(index, pname, pointer) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribdv(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribfv(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glGetVertexAttribiv(index, pname, params) end => [ :void, :GLuint, :GLenum, :pointer ].freeze,
    def glIsProgram(program) end => [ :GLboolean, :GLuint ].freeze,
    def glIsShader(shader) end => [ :GLboolean, :GLuint ].freeze,
    def glLinkProgram(program) end => [ :void, :GLuint ].freeze,
    def glShaderSource(shader, count, string, length) end => [ :void, :GLuint, :GLsizei, :string, :pointer ].freeze,
    def glStencilFuncSeparate(face, func, ref, mask) end => [ :void, :GLenum, :GLenum, :GLint, :GLuint ].freeze,
    def glStencilMaskSeparate(face, mask) end => [ :void, :GLenum, :GLuint ].freeze,
    def glStencilOpSeparate(face, sfail, dpfail, dppass) end => [ :void, :GLenum, :GLenum, :GLenum, :GLenum ].freeze,
    def glUniform1f(location, v0) end => [ :void, :GLint, :GLfloat ].freeze,
    def glUniform1fv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform1i(location, v0) end => [ :void, :GLint, :GLint ].freeze,
    def glUniform1iv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2f(location, v0, v1) end => [ :void, :GLint, :GLfloat, :GLfloat ].freeze,
    def glUniform2fv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform2i(location, v0, v1) end => [ :void, :GLint, :GLint, :GLint ].freeze,
    def glUniform2iv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3f(location, v0, v1, v2) end => [ :void, :GLint, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glUniform3fv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform3i(location, v0, v1, v2) end => [ :void, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glUniform3iv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4f(location, v0, v1, v2, v3) end => [ :void, :GLint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glUniform4fv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniform4i(location, v0, v1, v2, v3) end => [ :void, :GLint, :GLint, :GLint, :GLint, :GLint ].freeze,
    def glUniform4iv(location, count, value) end => [ :void, :GLint, :GLsizei, :pointer ].freeze,
    def glUniformMatrix2fv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix3fv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUniformMatrix4fv(location, count, transpose, value) end => [ :void, :GLint, :GLsizei, :GLboolean, :pointer ].freeze,
    def glUseProgram(program) end => [ :void, :GLuint ].freeze,
    def glValidateProgram(program) end => [ :void, :GLuint ].freeze,
    def glVertexAttrib1d(index, x) end => [ :void, :GLuint, :GLdouble ].freeze,
    def glVertexAttrib1dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1f(index, x) end => [ :void, :GLuint, :GLfloat ].freeze,
    def glVertexAttrib1fv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib1s(index, x) end => [ :void, :GLuint, :GLshort ].freeze,
    def glVertexAttrib1sv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2d(index, x, y) end => [ :void, :GLuint, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib2dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2f(index, x, y) end => [ :void, :GLuint, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib2fv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib2s(index, x, y) end => [ :void, :GLuint, :GLshort, :GLshort ].freeze,
    def glVertexAttrib2sv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3d(index, x, y, z) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib3dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3f(index, x, y, z) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib3fv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib3s(index, x, y, z) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib3sv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4Nbv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4Niv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4Nsv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4Nub(index, x, y, z, w) end => [ :void, :GLuint, :GLubyte, :GLubyte, :GLubyte, :GLubyte ].freeze,
    def glVertexAttrib4Nubv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4Nuiv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4Nusv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4bv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4d(index, x, y, z, w) end => [ :void, :GLuint, :GLdouble, :GLdouble, :GLdouble, :GLdouble ].freeze,
    def glVertexAttrib4dv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4f(index, x, y, z, w) end => [ :void, :GLuint, :GLfloat, :GLfloat, :GLfloat, :GLfloat ].freeze,
    def glVertexAttrib4fv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4iv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4s(index, x, y, z, w) end => [ :void, :GLuint, :GLshort, :GLshort, :GLshort, :GLshort ].freeze,
    def glVertexAttrib4sv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4ubv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4uiv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttrib4usv(index, v) end => [ :void, :GLuint, :pointer ].freeze,
    def glVertexAttribPointer(index, size, type, normalized, stride, pointer) end => [ :void, :GLuint, :GLint, :GLenum, :GLboolean, :GLsizei, :pointer ].freeze,
  }.freeze
end