module GL_VERSION_3_1
  module Constants
    BUFFER_ACCESS_FLAGS               = 0x911F
    BUFFER_MAP_LENGTH                 = 0x9120
    BUFFER_MAP_OFFSET                 = 0x9121
    INT_SAMPLER_2D_RECT               = 0x8DCD
    INT_SAMPLER_BUFFER                = 0x8DD0
    MAX_RECTANGLE_TEXTURE_SIZE        = 0x84F8
    MAX_TEXTURE_BUFFER_SIZE           = 0x8C2B
    PRIMITIVE_RESTART                 = 0x8F9D
    PRIMITIVE_RESTART_INDEX           = 0x8F9E
    PROXY_TEXTURE_RECTANGLE           = 0x84F7
    R16_SNORM                         = 0x8F98
    R8_SNORM                          = 0x8F94
    RED_SNORM                         = 0x8F90
    RG_SNORM                          = 0x8F91
    RG16_SNORM                        = 0x8F99
    RG8_SNORM                         = 0x8F95
    RGB_SNORM                         = 0x8F92
    RGB16_SNORM                       = 0x8F9A
    RGB8_SNORM                        = 0x8F96
    RGBA_SNORM                        = 0x8F93
    RGBA16_SNORM                      = 0x8F9B
    RGBA8_SNORM                       = 0x8F97
    SAMPLER_2D_RECT                   = 0x8B63
    SAMPLER_2D_RECT_SHADOW            = 0x8B64
    SAMPLER_BUFFER                    = 0x8DC2
    SIGNED_NORMALIZED                 = 0x8F9C
    TEXTURE_BINDING_BUFFER            = 0x8C2C
    TEXTURE_BINDING_RECTANGLE         = 0x84F6
    TEXTURE_BUFFER                    = 0x8C2A
    TEXTURE_BUFFER_DATA_STORE_BINDING = 0x8C2D
    TEXTURE_BUFFER_FORMAT             = 0x8C2E
    TEXTURE_RECTANGLE                 = 0x84F5
    UNSIGNED_INT_SAMPLER_2D_RECT      = 0x8DD5
    UNSIGNED_INT_SAMPLER_BUFFER       = 0x8DD8
  end

  Extensions = [
    :GL_ARB_copy_buffer,
    :GL_ARB_uniform_buffer_object
  ].freeze

  Functions = {
    def glDrawArraysInstanced(mode, first, count, instancecount) end => [ :void, :GLenum, :GLint, :GLsizei, :GLsizei ].freeze,
    def glDrawElementsInstanced(mode, count, type, indices, instancecount) end => [ :void, :GLenum, :GLsizei, :GLenum, :pointer, :GLsizei ].freeze,
    def glPrimitiveRestartIndex(index) end => [ :void, :GLuint ].freeze,
    def glTexBuffer(target, internalformat, buffer) end => [ :void, :GLenum, :GLenum, :GLuint ].freeze,
  }.freeze
end
